2007-06-04  Rob Savoye  <rob@bertha.welcomehome.org>

	* NEWS, README: Update for upcoming release.
	* macros/kde.m4: Use newlist so we don't stomp on libslist.
	* server/asobj/Makefile.am: Don't link ffmpeg to convienince lib. 
	* server/parser/Makefile.am: We don't need ffmpeg or gstreamer
	headers for this directory.

2007-06-04 Sandro Santilli <strk@keybit.net>

	* backend/render_handler.h: expose a new getBitsPerPixel interface.
	* backend/render_handler_agg.{cpp,h}: implement getBitsPerPixel,
	  const-correct the existing getBytesPerPixel.
	* testsuite/MovieTester.cpp (checkPixel): never use a tolerance
	  inferior to the minimum tolerance for a renderer, with min tolerance
	  being a function of BPP (formula suggested by UdoG).
	  Fixes bug #20035.

2007-06-04 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStreamFfmpeg.cpp (av_streamer): sleep for 1
	  microsecond between iterations, to allow other threads to run.
	  Fixes the 100% CPU problem (thanks to UdoG for support).

2007-06-04 Sandro Santilli <strk@keybit.net>

	* libbase/FLVParser.h: updated dox for nextAudioFrame() and
	  nextVideoFrame() noting the non-blocking nature of the calls;
	  add a parsingCompleted() method.
	* server/asobj/NetStreamFfmpeg.h: update documentation of
	  decodeFLVFrame()

2007-06-04 Sandro Santilli <strk@keybit.net>

	* libbase/FLVParser.{cpp,h}: put FLVParser in the gnash namespace.

2007-06-04 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStreamFfmpeg.{cpp,h}: Drop the decoder mutex and
	  conditional variable. Decoder should never stop till the end of
	  the stream is fully decoder. Rename {pause,unpause}Decoding to
	  {pause,unpause}Playback, which is matches reality more, and is
	  also more correct.

2007-06-04 Sandro Santilli <strk@keybit.net>

	* server/timers.cpp (expired): allow now == _start.
	  Hopefully fixes bug #20047.

2007-06-02 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStream.cpp (::bufferLength): return milliseconds,
	  as (correctly) documented.

2007-06-02 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* backend/render_handler_ogl.cpp,libbase/log.cpp, macros/opengl.m4,
	  server/asobj/Date.cpp: Fixes for builing on win32/MSYS/mingw.
	  Linking is still broken.

2007-06-02 Sandro Santilli <strk@keybit.net>

	* server/vm/ASHandlers.cpp (CommonGetUrl): log about _level#
	  target for GetUrl being unsupported.

2007-06-02 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/asobj/NetConnection.{cpp,h}: Permit openConnection 
	to be called more than once with the same URL.
	* server/asobj/NetStreamFfmpeg.cpp: Call detach_aux_streamer
	with a valid owner argument, so something will actually
	happen. Make sure that the NetConnection position is 0
	just in case openConnection was called before. Fix a deadlock
	by avoiding calls to the sound handler in startPlayback().
	This is cheating, but fixes bug #20036.

2007-06-01 Bastiaan Jacques <bastiaan@bjacques.org>

	* macros/ffmpeg.m4: Avoid using libswscale with broken ffmpeg
	versions.
	* configure.ac: Revert unintentional change.

2007-06-01 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStreamGst.cpp: protect all log_debug calls
	  with a GNASH_DEBUG macro.

2007-06-01 Sandro Santilli <strk@keybit.net>

	* libbase/rc.{cpp,h}: Add a "StartStopped" variable, to
	  have the gui start in "stop" mode.
	* doc/C/gnashrc.xml: document the new "StartStopped" variable.
	* gui/Player.cpp (init_gui): set the Gui to "stop" if requested
	  by the user (trough gnashrc)
	* testsuite/libbase/: TCXXRc.cpp, gnashrc.in: test "StartStopped"
	  variable.

2007-06-01 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStream.{cpp,h}: split processStatusNotifications
	  so that onStatus handler call is performed while the statusMutex
	  is NOT locked, to prevent attempts to lock the mutex again while
	  reacting to status handlers. statusQueue type changed from vector
	  to deque, for faster pop_front.

2007-06-01 Sandro Santilli <strk@keybit.net>

	* gui/Player.cpp (run): remove sound_handler cleanup, will
	  be done by gnash::clear().
	* gui/: gtk.cpp, gtksup.h: implement gui::quit()
	* server/impl.cpp (clear): report the problem with cleaning
	  up resources before all threads are completed, exit() rather
	  then cleanup and document the reason for doing so.
	* utilities/processor.cpp (main): call gnash::clear() again, that's
	  where proper threads cleanup is supposed to be implemented.

2007-06-01 Sandro Santilli <strk@keybit.net>

	* server/vm/ActionExec.cpp (call operator): if pc == oldPc that's
	  still to be considered a branch-back, so count it; Increment
	  branch-back limit to 2^16 (65535).
	* gui/Player.cpp: print a debugging message when the main gui loop
	  returns so we know if we exited cleanly or due to a call to exit().
	* gui/gui.cpp{cpp,h}: add a quit() virtual method, for returning
	  from the main rendering loop. This is aimed at removing the exit()
	  call, altought currently we'll still call it as the default
	  implementation.

2007-05-31 Bastiaan Jacques <bastiaan@bjacques.org>

	* macros/ffmpeg.m4: Define HAVE_SWSCALE_H if swscale.h is present.
	* libbase/embedVideoDecoderFfmpeg.cpp: If swscale.h is available,
	use swscale and friends. Otherwise, default to img_convert. Also,
	conditionally include swscale.h itself.
	* server/asobj/NetStreamFfmpeg.cpp: Remove unused include.

2007-05-31 Sandro Santilli <strk@keybit.net>

	* backend/sound_handler.h: document attach_aux_streamer and
	  detach_aux_streamer; add TODO items.
	* backend/sound_handler_sdl.cpp (sdl_audio_callback): documentation,
	  TODO items, early return if buffer len passed by SDL == 0.

2007-05-31 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStream*.{h,cpp}: Always use milliseconds internally.

2007-05-31  Rob Savoye  <rob@ute.welcomehome.org>

	* configure.ac: Change renderer default to opengl.

2007-05-31 Sandro Santilli <strk@keybit.net>

	* server/asobj/: NetStream.cpp, NetStreamFfmpeg.cpp:
	  More debugging lines protection.

2007-05-31 Sandro Santilli <strk@keybit.net>

	* libbase/FLVParser.cpp: protect seek debugging by
	  a GNASH_DEBUG_SEEK macro
	* server/asobj/NetStreamFfmpeg.cpp: dont debug condition
	  variable signaling if GNASH_DEBUG_THREADS is undefined.

2007-05-31 Sandro Santilli <strk@keybit.net>

	* libbase/log.{cpp,h}: lock the io Mutex on closeLog, to
	  prevent race conditions between a thread using log()
	  and one using closeLog().

2007-05-31 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/FLVParser.cpp: (FLVFrame* FLVParser::nextMediaFrame)
	  Fixed a bug causing nextMediaFrame to return NULL.

2007-05-31 Martin Guy <martinwguy@yahoo.it>

        * libbase/embedVideoDecoderFfmpeg.cpp,
          server/asobj/NetStreamFfmpeg.cpp:
          Add comments by commented img_convert()s to use sws_scale() when
          implementing.
	* Change default renderer to agg for 0.8.0 release
	* Revert default renderer back to OpenGL.

2007-05-31 Sandro Santilli <strk@keybit.net>

	* libbase/embedVideoDecoderFfmpeg.{cpp,h}:
	  Make convertRGB24 a public static function.
	* server/asobj/NetStreamFfmpeg.cpp: use
	  embedVideoDecoderFfmpeg::convertRGB24, dropping the
	  duplicated implementation.

2007-05-31 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/asobj/NetStreamFfmpeg.cpp, 
	libbase/embedVideoDecoderFfmpeg.cpp: Use libswscale instead of
	img_convert for YUV->RGB conversion, because it is deprecated and
	has been removed from recent ffmpeg.

2007-05-30 Sandro Santilli <strk@keybit.net>

	* configure.ac: add missing quote in martin's commit (no ChangeLog
	  entry for it, btw)
	* server/asobj/README.NetStream: add design notes for NetStream.

2007-05-30 Sandro Santilli <strk@keybit.net>

	* server/video_stream_instance.cpp (display): update call to
	  get_video.
	* server/asobj/NetStream.{cpp,h}: change get_video to return by
	  auto_ptr to encode ownership transfer.
	* server/asobj/NetStreamFfmpeg.h: update refreshVieoFrame() dox.

2007-05-30 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStream.cpp: fix NetStream.bufferTime getter to
	  return value in seconds, not milliseconds.

2007-05-30 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStreamFfmpeg.cpp: Fixed seeking to work when not
	  seeking to 0.
	* server/asobj/SoundFfmpeg.cpp: Silence a compiler warning.

2007-05-30 Sandro Santilli <strk@keybit.net>

	* libbase/FLVParser.h: document timestamp units for media frames
	  and isTimeLoaded().
	* server/asobj/NetStreamFfmpeg.{cpp,h}: document units for time
	  members; (advance): fix isTimeLoaded() call, thanks Martin Guy
	  for noticing.

2007-05-30 Sandro Santilli <strk@keybit.net>

	* libbase/FLVParser.{cpp,h}: drop setLoadThread method, require
	  a LoadThread to be passed on construction.
	* server/asobj/NetConnection.{cpp,h}: drop connectParser, substitute
	  with getConnectedParser().
	* server/asobj/: NetStreamFfmpeg.cpp, NetStreamGst.cpp: use
	  NetConnection::getConnectedParser() for initializing an FLV parser.

2007-05-30 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetConnection.h: add documentation about which calls
	  are blocking and which not.
	* server/asobj/NetConnection.cpp (openConnection): return false if
	  already connected

2007-05-29 Martin Guy <martinwguy@yahoo.it>

	* server/asobj/NetStreamFfmpeg.cpp: Two casts to quiet compiler warnings
	* configure.ac: Add rpm/deb help for AGG
	* configure.ac: Warn if libcurl is missing

2007-05-30 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStreamFfmpeg.cpp (decodeFLVFrame): Don't modify m_bufferTime
	  internally: should only be done on user request. (advance):
	  bufferFull condition is when parser loaded current+buffer time.
	  (av_streamer): add bufferTime/Length info in Decoding iteration
	  message - this shows that the playback is NOT waiting for bufferTime
	  to be reached before starting again (bug).

2007-05-30 Sandro Santilli <strk@keybit.net>

	* libbase/FLVParser.{h,cpp}: document which methods lock and which
	  not, add locking in getBufferLength().
	* server/asobj/NetStream.{h,cpp}: fix documentation for bufferLength
	  method (return milliseconds, not seconds); have
	  NetStream.bufferLength return in fractional seconds, as expected;
	  Change bufferTime to take milliseconds, convert from seconds
	  in the AS method (so we can accept fractional seconds..);
	  make locking debugging messages a compile-time option.

2007-05-30 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/LoadThread.cpp: Close the download thread even if
	  download wasen't completed.

2007-05-29 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/LoadThread.cpp: Don't lock the mutex and try to join the 
	  download thread when calling complete(), instead do that in the
	  destrutor. Fixes some blocking (with the no-decode-thread-patch
	  for NetStreamFfmpeg).

2007-05-29 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStreamFfmpeg.{cpp,h}: don't lock
	  the mutex in seek() even, also intended to be called by
	  the VM..

2007-05-29 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStreamFfmpeg.{cpp,h}: Don't lock the mutex
	  in pause(), play() and close(), all intended to be called
	  by the locking advance(). More dox about locking in the header.
	* testsuite/actionscript.all/rtmp.as: remove any
	  trace of "rtmp" from the code to show that bug #19886
	  is unrelated to RTMP.

2007-05-29 Sandro Santilli <strk@keybit.net>

	* backend/sound_handler.h: add numSoundsStarted() and
	  numSoundsStopped() methods to be used in testing, and
	  associated protected counts.
	* backend/: sound_handler_gst.cpp, sound_handler_sdl.cpp:
	  Increment started/stopped sound counters.
	* testsuite/FuzzyPixel.h: remove unused header.
	* testsuite/: Makefile.am, sound_handler_test.{cpp,h}:
	  drop sound_handler_test, testing will now be done against
	  the built sound_handler.
	* testsuite/MovieTester.{cpp,h}: initialize the currently
	  configured sound handler and use that for testing.

2007-05-29 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStreamFfmpeg.{cpp,h}: drop
	  the decode_wait_mutex, use decoding_mutex instead.
	  Document which function lock it and which not, adding
	  more locking. Seems to fix bug #19978, but exposes
	  a deadlock playing youtube with a full-offline setup
	  with reduced bandwidth.

2007-05-29 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* testsuite/misc-ming.all/DrawingApiTestRunner.cpp: testing for gray
	  is funny, but better let's be accurate ;) 
			
2007-05-29 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/DrawingApiTestRunner.cpp: reintruduce
	  the pixel-accurate test after Udo fix for #19828.

2007-05-29 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* backend/render_handler_agg.cpp: Fix coordinate translation and  
	  pixel hinting. Fixes bug #19828.

2007-05-29 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all: Makefile.am, key_event_test3.c, 
	  key_event_test3runner.cpp: new testcase for key listeners.

	
2007-05-29 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/key_event_test2runner.cpp: remove obsolete comments
	  
2007-05-29 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/key_event_test2.c, 
	  key_event_test2runner.cpp: add more tests.
	* server/movie_root.cpp: add comments for ::cleanup_key_listeners().
	  
2007-05-29 Martin Guy <martinwguy@yahoo.it>

	* server/asobj/NetStreamFfmpeg.cpp: Fix sign/unsign compiler warning
	* packaging/debian/control: Add missing build dependency for opengl-gtk

2007-05-28 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStream*.{cpp,h}: Updated a comment and made play()
	  return void to be closer to defined behavoir.

2007-05-28 Sandro Santilli <strk@keybit.net>

	* server/asobj/: NetStream.{cpp,h},
	  NetStreamFfmpeg.cpp, NetStreamGst.cpp:
	  Encode FLVParser ownership by using an auto_ptr;
	  cleanup startPlayback method in FFMPEG implementation
	  removing the "this" alias.

2007-05-28 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStream.h: drop playing() method (unclear
	  and unnecessary).
	* server/video_stream_instance.cpp (display): stop
	  calling NetStream::playing().

2007-05-28 Ann Barcomb <kudra@domaintje.com>

	* many files: Add a paragraph break before the line 'You should
	  have received...' in the copyright notice.
	* devtools/testsuite/copyright_notices.t: Minor code improvement
	* many files: Add current year to all copyright notices which were
	  lacking it.

2007-05-28 Sandro Santilli <strk@keybit.net>

	* server/video_stream_instance.{cpp,h}: add brief class description,
	  drop unused member.
	* testsuite/misc-ming.all/matrix_test.c: Really round numbers, don't
	  just truncate them up to 2nd decimal position.

2007-05-28 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all: Makefile.am, key_event_test2.c, 
	  key_event_test2runner.cpp: add tests for key listeners.
	* server/sprite_instance.cpp: call "unload" for characters removed
	  in ::resetDisplayList, partly fix the increasing key listeners
	  problem when loop back.
	
2007-05-28 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/matrix_test.c: round numbers
	  to 1/100 to reduce floating number based errors.

2007-05-27 Ann Barcomb <kudra@domaintje.com>

	* devtools/testsuite/copyright_notices.t: Added a script to look
	  for incorrect copyright notices.

2007-05-27  Rob Savoye  <rob@bertha.welcomehome.org>

	* macros/archflag.m4: Drop --with-gcc-arch, and use --with-cpu,
	which is more standard.
	* configure.ac: Add a --with-top-level option to specify where
	development packages are when cross configuring. Add --with-cpu to
	set the compiler flags correctly when cross compiling for similar
	architectures, like pentium->geode, which are supported by the
	same compiler.

2007-05-27 Bastiaan Jacques <bastiaan@bjacques.org>

	* libbase/{FLVParser.h, LoadThread.h, embedVideoDecoderFfmpeg.h,
	extension.h, tu_timer.h} server/{debugger.h, movie_root.h},
	server/sprite_instance.h, server/vm/VM.h: Mark symbols which are
	used across DSOs as DSOEXPORT. This allows compilation with
	-fvisibility=hidden.
	* macros/kde.m4: When detecting QT, also allow for the check for
	the possibility that the QTDIR environment variable points to
	the base QT directory, no strings attached (and no version
	numbers required).

2007-05-27 Ann Barcomb <kudra@domaintje.com>

	* doc/C/usermanual/installation/documentation_dependencies.xml:
	  Corrected information about FOP requirement.
	* doc/C/usermanual/installation/install.xml: Placeholder file.
	* doc/C/usermanual/installation.xml,
	  doc/C/usermanual/installation/building.xml: Started a section on
	  building Gnash.

2007-05-26 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStreamGst.cpp: Don't allow play url to be changed,
	  might not be correct behavoir... Fix some issues when closing 
	  NetStream before playback has been set up.

2007-05-26 Ann Barcomb <kudra@domaintje.com>

	* doc/C/gnashrc.xml: Corrected spelling
	* doc/C/usermanual/usage/gnashrc.xml: Propogated changes from
	  ../../gnashrc.xml r1.3357 to the new gnashrc file.
	* doc/C/usermanual/installation/cross_compiling.xml: Made the
	  cross compilation information more generic.

2007-05-26 Jurka <jurka@ejurka.com>

	* gui/gnash.cpp, libbase/FLVParser.cpp: Clear up printf-related
	warnings.

2007-05-26 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/FLVParser.cpp: When seeking the frame after the correct
	  one was returned.
	* server/asobj/NetConnection.cpp: Don't allow url prefix to be changed,
	  might not be correct behavoir...
	* server/asobj/NetStreamFfmpeg.cpp: Don't allow play url to be changed,
	  might not be correct behavoir... Fix some issues when closing 
	  NetStream before playback has been set up.

2007-05-26 Bastiaan Jacques <bastiaan@bjacques.org>

	* plugin/plugin.cpp: Initialise _width and _height to safe defaults,
	in case SetWindow is never called (for "hidden" flash movies).
	* gui/gnash.cpp: If the plugin attempts to create a 0x0 pixels window
	don't try to create a rendering GUI.
	* macros/kde.m4: Check if we actually need the kde subdirectory of the
	KDE prefix we got from kde-config.

2007-05-26 Ann Barcomb <kudra@domaintje.com>

	* doc/C/usermanual/installation/cross_compiling.xml,
	doc/C/usermanual/installation.xml: Added section on cross compiling
	* doc/C/usermanual/installation/configuration.xml: Resolved a TODO
	* doc/C/usermanual/installation/code_dependencies.xml: Marked a TODO
	* doc/C/usermanual/installation/sources.xml: RAM requirements
	* doc/C/usermanual/installation/sources.xml: Disk space requirements
	* doc/C/usermanual/installation/configuration/feature_configuration.xml,
	custompath_configuration.xml: Formatting
	* doc/C/usermanual/installation/configuration/sources.xml:
	  Include development snapshots as a download option

2007-05-25 Sandro Santilli <strk@keybit.net>

	* extensions/gnashrc: new file, with required variables
	  for running extensions tests.
	* extensions/fileio/Makefile.am: Provide a GNASHRC variable
	  to the generic-testrunner.sh
	* libbase/rc.cpp (loadFiles): load a GNASHRC if specified, after
	  all precedent files are loaded. See task #6937.

2007-05-25 Sandro Santilli <strk@keybit.net>

	* testsuite/libbase/: TCXXRc.cpp, gnashrc.in: test EnableExtensions.
	* doc/C/gnashrc.xml: document new EnableExtensions gnashrc
	  variable
	* libbase/rc.{cpp,h}: add support for EnableExtensions variable,
	  defaults to OFF. Cleanup const-correctness and static methods.
	* server/asobj/Global.cpp: Don't load extensions if disabled 
	  by gnashrc.

2007-05-25 Sandro Santilli <strk@keybit.net>

	* libgeometry/snappingrange.h: add intersects(Range2d)
	* testsuite/misc-ming.all/: Makefile.am,
	  loop_test2.c, loop_test2runner.cpp: Add a visual test
	  runner, showing that 2nd redesign attempt is really
	  bogus.

2007-05-25 Sandro Santilli <strk@keybit.net>

	* server/as_environment.cpp: don't print a separate error
	  when call stack limit is exceeded, leave that to the 
	  exception handler.
	* server/vm/ActionExec.cpp: implement number of iterations
	  limit (should be a timeout in second actually, but better
	  this then hanging forever). Fixes bug #19961.

2007-05-25 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/swf/tag_loaders.cpp: Move the assignment into the data
	pointer up to right after the corresponding memory is allocated,
	because the DO_{MONO,STEREO}_BLOCK macros use the temporary
	pointer to iterate the buffer. This was causing delete[] to be
	called on the pointer which had walked to the end of the buffer
	and, thus, crashing.

2007-05-25 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.{cpp,h}: drop unused remove_display_item
	  taking a std::string as argument..

2007-05-25 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStreamFfmpeg.h: Fix resampling for some FLVs,
	  fixes bug #19959.

2007-05-25 Sandro Santilli <strk@keybit.net>

	* libbase/log.cpp (timestamp): include PID in timestamp,
	  so its easier to read the gnash-dbg.log file after browsing
	  the web...

2007-05-24 Sandro Santilli <strk@keybit.net>

	* libbase/zlib_adapter.cpp: fix seek function to respect
	  tu_file interface. Fix inflater to no set an error condition
	  when inflate() just needs more calls to complete the request.
	  Fixes bug #19931.

2007-05-24 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/LoadThread.{cpp,h}: Made the download loop sleep when
	  read() wants to get a lock on the mutex.
	* libbase/curl_adapter.cpp: Decreased the sleeping time in fill_cache.
	* backend/{sound_handler.h,sound_handler_gst.h,sound_handler_sdl.h}:
	  Moved sound_data class to the base header.

2007-05-24 Sandro Santilli <strk@keybit.net>

	* server/stream.cpp (open_tag): print end tag position in verbose
	  parse mode; (close_tag): assertion checking (shows a bug in
	  zlib_adapter, see bug #19931).
	* libbase/tu_file.cpp (std_seek_func): assertion checking and minor
	  cleanups.
	* libbase/curl_adapter.cpp (CurlStreamFile::seek): use the _cached
	  member for checking wheter a seek will succeed or not (fseek
	  allows you to seek past the end of the file otherwise).

2007-05-24 Bastiaan Jacques <bastiaan@bjacques.org>

	* gui/Makefile.am: When building FLTK GUI, also include
	the X11 CFLAGS (when available).
	* gui/fltk.cpp: Only try to do X11 things with FLTK if
	X11 is actually available. Should fix compilation on
	OS X (bug #19618).
	* macros/x11.m4: Don't forget to set the x11 flag
	variable which is used to check if X11 was found.

2007-05-24 Sandro Santilli <strk@keybit.net>

	* server/: Makefile.am, impl.cpp, swf/DoActionTag.h,
	  swf/tag_loaders.cpp:
	  Move DoAction and DoInitAction tag stuff to its 
	  own file (both loader and parser).

2007-05-24 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (replace_display_object):
	  When the object being replaced is NOT a scriptable object,
	  move instead of replacing.
	* testsuite/misc-ming.all/: replace_buttons1test.c,
	  replace_buttons1test_runner.cpp, replace_sprites1test.c,
	  replace_sprites1test_runner.cpp: Expect less failures.

2007-05-24 Sandro Santilli <strk@keybit.net>

	* server/: dlist.{cpp,h}, sprite_instance.{cpp,h},
	  server/swf/PlaceObject2Tag.cpp, server/vm/action.cpp:
	  Drop the use_matrix/use_color_xform parameters, use
	  pointers for the actual matrix/color_xform so that NULL
	  signifies "don't use".

2007-05-24 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/replace_sprites1test.c: 
	  Add onClipEvent(unload) to both PLACE and REPLACE tag.

2007-05-24 Sandro Santilli <strk@keybit.net>

	* backend/sound_handler_gst.cpp: warn only once about fluendo plugin
	  being too old.
	* server/parser/shape_character_def.cpp (read): 
	  Fix typo reporting false malformations in the SWF.

2007-05-24 Sandro Santilli <strk@keybit.net>

	* server/character.h: add isActionScriptReferenciable() 
	  method to find "scriptable objects". See:
	  http://www.gnashdev.org/wiki/index.php/ScriptableCharacters
	* server/sprite_instance.cpp (get_member, get_relative_target):
	  When requested name matches a NON scriptable instance, return
	  self.
	* server/video_stream_instance.h: implement wantsInstanceName()
	  [ used by isActionScriptReferenciable ]
	* testsuite/misc-ming.all/replace_shapes1test.c: expect less failures.
	* testsuite/misc-ming.all/shape_test.c: don't expect any more failure

2007-05-24 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am,
	  replace_buttons1test.c, replace_buttons1test_runner.cpp:
	  New test for buttons replacement.
	* testsuite/misc-ming.all/replace_sprites1test.c:
	  Add new test checking for _x.

2007-05-24 Sandro Santilli <strk@keybit.net>

	* server/dlist.cpp (replace_character): always call ::construct
	  on the new character.
	* backend/sound_handler_sdl.h: fix const-correctness
	  of active_sound (btw, do we really need two different
	  definitions of that class for SDL and GST ?).

2007-05-24 Sandro Santilli <strk@keybit.net>

	* server/button_character_instance.cpp: protect vector
	  elements dereferencing by assertions. I have a segfault
	  triggered by a new uncommitted testcase replacing buttons...

2007-05-24 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.{cpp,h}: remove unused
	  sprite_instance::mouse_state typedef and member.
	* server/parser/BitmapMovieDefinition.h,
	  server/parser/movie_def_impl.h,
	  server/parser/movie_definition.h,
	  server/parser/sprite_definition.h,
	  testsuite/DummyMovieDefinition.h:
	  Const-corrected get_playlist.

2007-05-24 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/replace_shapes1test.c:
	  Add more tests, updated comments.
	* testsuite/actionscript.all/MovieClip.as:
	  Add test for _root.getDepth() being static-0.

2007-05-24 Sandro Santilli <strk@keybit.net>

	* backend/sound_handler.h, backend/sound_handler_gst.cpp,
	  backend/sound_handler_gst.h, backend/sound_handler_sdl.cpp,
	  backend/sound_handler_sdl.h, server/execute_tag.h,
	  server/sprite_instance.cpp, server/sprite_instance.h,
	  server/parser/sound_definition.cpp,
	  server/parser/sound_definition.h,
	  server/swf/DisplayListTag.h, server/swf/PlaceObject2Tag.cpp,
	  server/swf/PlaceObject2Tag.h, server/swf/RemoveObjectTag.cpp,
	  server/swf/RemoveObjectTag.h, server/swf/tag_loaders.cpp,
	  testsuite/sound_handler_test.cpp, testsuite/sound_handler_test.h:
	  Const-corrected execute_tag::execute and execute_state, and
	  cascading changes
	* testsuite/misc-ming.all/loop_test7.c: fix wrong expected failures.

2007-05-24 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am,
	  loop_test6.c, loop_test7.c:
	  Add a clone of "Jumping backward to the end of a character's
	  lifetime" test this time with onUnload defined.

2007-05-24 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: replace_shapes1test.c,
	  replace_sprites1test.c: SWFMovie_replace returns 0 on success
	  and non-0 on failure. Fixed code to reflect that (I'm not sure
	  I like this interface, anyway this is what we have in current
	  Ming head).

2007-05-23 Sandro Santilli <strk@keybit.net>

	* server/swf/: tag_loaders.cpp, DefineFontAlignZonesTag.{cpp,h},
	  DisplayListTag.h, PlaceObject2Tag.{cpp,h},
	  RemoveObjectTag.{cpp,h}:
	  Move one namespace up (gnash::SWF - strip tag_loaders);
	  Provide a static public loader() function for use by 
	  register_tag_loader (moved implementation from tag_loaders.cpp
	  to the classes themselves).
	* server/impl.cpp: update loaders registration to call the new
	  public static methods of ReplaceObjectTag and PlaceObject2Tag.

2007-05-23 Sandro Santilli <strk@keybit.net>

	* server/execute_tag.h: drop is_remove_tag() method.
	* server/sprite_instance.{cpp,h}: drop unused
	  execute_remove_tags() method.
	* server/Makefile.am, server/swf/: DisplayListTag.h,
	  PlaceObject2Tag.h, RemoveObjectTag.{cpp,h}
	  tag_loaders.cpp: Add a DisplayListTag subclass of
	  execute_tag, and make RemoveObject and PlaceObject subclasses
	  of it.

2007-05-23 Ann Barcomb <kudra@domaintje.com>

	* doc/C/usermanual/installation/feature_configuration.xml,
	  doc/C/usermanual/installation/configuration.xml: Incorporated
	  some changes from r1.38 of doc/C/sources.xml.

2007-05-23 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, loop_test6.c:
	  New test for "Jumping backward after a character's lifetime".
	  Reveals a conceptual bug in last step of all redesign attempts
	  for displaylist reconstruction (execute *all* frame tags
	  from start to target frame).

2007-05-23 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, replace_shapes1test.c,
	  replace_sprites1test.c, replace_shapes1test_runner.cpp,
	  replace_sprites1test_runner.cpp: Modified coordinates and size
	  of shapes to help writing test runners. Wrote real test
	  runners checking for rendering and bounds invalidation.
	* testsuite/MovieTester.cpp (render): don't force redraw
	  always (don't cheat) - do only when asked to do so..

2007-05-23 Sandro Santilli <strk@keybit.net>

	* server/character.h: Extended TimelineInfo to store information
	  about wheter a character was placed by a REPLACE tag.
	* server/sprite_instance.cpp: implemented 3rd redesign attempt
	  for DisplayList reconstruction compile-time enableable by
	  setting NEW_TIMELINE_DESIGN to 3. Defined to 2 by defualt
	  which gives us 2nd redesign attempt. See wiki.
	  3rd redesign is promising and give us lots of unexpected
	  successes, but also some unexpected failures for the new
	  testcases for REPLACE tag. 

2007-05-23 Sandro Santilli <strk@keybit.net>

	* server/dlist.{cpp,h}: Add new reset() method taking
	  enough parameters (I hope) to remove what needs to
	  on jump-back; drop obsoleted clear_unaffected function.
	* testsuite/misc-ming.all/: replace_shapes1test.c,
	  replace_sprites1test.c: Fix implementation (don't
	  use Ming internal methods); add new tests and comments
	  about why Gnash fails.

2007-05-23 Bastiaan Jacques <bastiaan@bjacques.org>

	* cygnal/cygnal.cpp: Don't include <libintl.h> directly; instead,
	rely on our own gettext.h to do the right thing.
	* gui/fltk.cpp: Update the FLTK GUI to the new Gnash key handling 
	API. Make sure the window is listening for key events even if it
	is not the first window to receive key notifications.
	* macros/gnashpkgtool.m4: Don't forget to set the "found" flag
	for CFLAGS when --with-pkg-incl is used to find the include path.
	* libbase/FLVParser.cpp: Fix more memory bugs by adding padding
	zero bytes. Should fix bug #19898.

2007-05-23 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* backend/sound_handler_sdl.cpp: Made it a bit more thread-safe by
	  locking when attaching/detaching a aux_streamer.
	  Fixed a crash when removing attached sounds from the aux_streamer list.
	* libbase/FLVParser.{h,cpp}: Added audioFrameDelay(), and a fixes.
	* libbase/curl_adapter.cpp: Changed min and max sleep.
	* server/asobj/NetStreamFfmpeg.{h,cpp}: Cleanup! Splitted the big
	  decode function (read_frame) into 3 functions. Changed a few names
	  to make more sence. Improved syncing, and made it depend on audio 
	  if available, not video. Plus some overall improvements.

2007-05-23 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/shape_test.c: add tests for shapes.
	* testsuite/misc-ming.all/Makefile.am: activate some testcases.
	 	
2007-05-22 Martin Guy <martinwguy@yahoo.it>

	* configure.ac: add help text for ffmpeg-devel RPM package
	* server/swf/tag_loaders.cpp: Fix NELLYMOSER bombing out

2007-05-22 Sandro Santilli <strk@keybit.net>

	* server/swf/tag_loaders.cpp (place_object_2_loader): don't
	  add a TimelineDepth if read depth is out of static depth zone 
	  boundaries (warn user about it too...).
	* gui/Player.cpp (run): use movie url for window title (-u).
	  Useful when reading stdin...
	* server/parser/shape_character_def.cpp (read): don't force
	  fill and line style of glyphs to have a corresponding style
	  definition, just warn if the value in a styleChangeRecord is
	  neither 0 or 1. Set style to 0 when invalid.

2007-05-22 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/loop_test-Runner.cpp: don't expect
	  failure in invalidated bounds after Udo commits.
	* testsuite/misc-ming.all/replace_sprites1test.c: Change expected
	  Gnash behaviour (previous one was based on 3rd displaylist reset
	  design implementation).

2007-05-22 Sandro Santilli <strk@keybit.net>

	* configure.ac: add MING_SUPPORTS_REPLACE_TAG conditinal variable,
	  based on version (0.4.0.beta5).
	* testsuite/misc-ming.all/: Makefile.am, replace_shapes1test.c,
	  replace_sprites1test.c: Add a couple of test for REPLACE tags.
	  Needs a Ming version that supports it, checked by
	  MING_SUPPORTS_REPLACE as set by ./configure.

2007-05-22 Ann Barcomb <kudra@domaintje.com>

	* doc/C/usermanual/installation/configuration.xml: List interesting
	  options before custom path options
	* doc/C/usermanual/installation/feature_configuration.xml: Added
	  missing title (it had been left in configuration.xml).

2007-05-22 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* server/character.{h,cpp}: Added preprocessor code to analyze 
	  calls to set_invalidated() more easily.
	* server/cxform.h: Implemented == operator
	* server/dlist.cpp: inherit invalidated bounds when replacing a
	  character
	* server/sprite_instance.cpp: avoid call to set_invalidated()
    (of parent) when replacing a char	  				
		 
2007-05-22 Ann Barcomb <kudra@domaintje.com>

	* doc/C/usermanual/*: Added files for the new user manual.
	* doc/C/app_authors.xml: Added a file which is used in the user manual
	  but might be cross-referenced by other documents.

2007-05-22 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* testsuite/misc-ming.all/NetStream-SquareTest.c: add missing end quote
	* testsuite/actionscript.all/XML.as: fix broken string

2007-05-21 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, displaylist_depths_test11.c:
	  New timeline control test.
	* server/parser/Timeline.h: fix getFrameDepths to really return
	  depths. Add output operator.

2007-05-21 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* backend/sound_handler_sdl.cpp: Only try to detach video-sound
	  input, if it exists.
	* server/asobj/NetStreamFfmpeg.cpp: Shutdown the decoding thread
	  proberbly.

2007-05-21  Rob Savoye  <rob@bertha.welcomehome.org>

	* libbase/Makefile.am: Build the installable libltdl before
	libgnashbase.

2007-05-21 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/displaylist_depths_test9.c: add
	  a construct event handler for the static character placed
	  and replaced (duplicated), and tests for its run.

2007-05-21  Rob Savoye  <rob@bertha.welcomehome.org>

	* libbase/Makefile.am: Don't include LIBLTDL in libgnashbase.la.

2007-05-21 Sandro Santilli <strk@keybit.net>

	* server/parser/: movie_definition.h, movie_def_impl.h,
	  sprite_definition.h: add getTimelineDepths() methods
	  and implementations.

2007-05-21 Sandro Santilli <strk@keybit.net>

	* server/parser/: Makefile.am, Timeline.h: new class for
	  timeline control.
	* server/parser/: movie_definition.h, movie_def_impl.{cpp,h},
	  sprite_definition.{cpp,h}: new addTimelineDepth() and
	  removeTimelineDepth() interfaces in base class, implementation
	  in subclasses.
	* server/swf/tag_loaders.cpp (remove_object2_tag): add getDepth()
	  method; call movie_definition::addTimelineDepth when a PlaceObject
	  tag is parsed and movie_definition::removeTimelineDepth when
	  a RemoveObject is parsed.
	* server/swf/PlaceObject2Tag.h: add getDepth() method, more dox
	  and 3 new inspectors to know wheter it's a place, replace or move
	  tag.

2007-05-21 Sandro Santilli <strk@keybit.net>

	* libbase/log.h: removed useless 'while (0) {};' snippet from
	  IF_VERBOSE_ASCODING_ERRORS and IF_VERBOSE_MALFORMED_SWF

2007-05-21 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/loop_test5.c:
	 	more for "Timeline control".
	 	
2007-05-21 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/Makefile.am: build libgnashmingutils
	  as a convenience library; have Dejagnu.swf users depend on
	  the local copy, not the one moved one dir up.
	* libbase/log.{cpp,h}: make LogFile output operators
	  private, provide a sipler thread-safe log() method.
	  Have all printf-like log_*() method use this new method.
	  Fixes bug bug #19906.
	* cygnal/stream.cpp, server/parser/action_buffer.cpp,
	  server/parser/action_buffer.h, server/vm/ActionExec.cpp,
	  testsuite/server/PropertyListTest.cpp: remove any
	  use of LogFile::operator<<, substitute with log_*() calls.

2007-05-21 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/loop_test4.c:
	 	add a another check, comments
	 	
2007-05-21 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/loop_test4.c:
	 	new testcase for timeline control.
	 	
2007-05-21 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/place_object_test2.c:
	 	testcase for placeObject2.
	 	
2007-05-20  Rob Savoye  <rob@bertha.welcomehome.org>

	* libbase/log.h: Add empty braces around a while(0) to shut up GCC
	4.3.

2007-05-20 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/displaylist_depths_test9.c:
	 	more tests, all passed.
		
2007-05-19 Markus Gothe <nietzsche@lysator.liu.se>

	* server/asobj/NetStream.cpp: Got rid of make_pair in favor of
	  std::pair<>();
	* server/cxform.h: include <string>

2007-05-19 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/tu_timer.cpp: Fixed a compiler warning.
	* server/asobj/NetStreamFfmpeg.{h,cpp}: Changed the way the decoding
	  loops works. We now use condition variables to pause the decoding 
	  loop. We now disconnect from the soundhandler when pausing.

2007-05-18 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, loop_test2.c, loop_test3.c:
	  New Timeline control test. GNASH FAILS THESE ONES !!

2007-05-18 Sandro Santilli <strk@keybit.net>

	* server/dlist.h: document the addAll() and add() methods.
	* server/asobj/NetStreamGst.cpp: provide a buildFLVPipeline() calling
	  the video/audio versions internally and locking the pipelineMutex.
	  Lock the pipelineMutex from buildPipeline() too. Document locking
	  in header.
	* testsuite/misc-ming.all/: loop_test-Runner.cpp, loop_test.c:
	  Make loop_test.swf self-contained. Use the runner for checking
	  invalidated bounds and rendering.

2007-05-18  Rob Savoye  <rob@bertha.welcomehome.org>

	* backend/sound_handler.cpp: Include cstring so memcpy is
	defined.
	* libbase/Makefile.am: Add makefile rules from libltd.

2007-05-18 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, displaylist_depths_test10.c:
	  Add test for "Skipping frames backward".
	* Makefile.am, configure.ac: detect 'swfmill'
	* testsuite/misc-swfmill.all/: .cvsignore, Makefile.am:
	  new testsuite dir for swfmill
	* testsuite/misc-swfmill.all/hello.xml: small example on
	  how to produce an swf. Build with 'make hello.swf'.

2007-05-18 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/getTimer_test.c,
	  server/vm/VM.{h,cpp}, server/vm/ASHandlers.cpp,
	  gui/fb.cpp: cleanup "ActionGetTimer" related stuff.
	* server/movie_root.h
	  remove unused get_timer, set_timer.
	  
2007-05-17  Martin Guy  <martinwguy@yahoo.it>

	* configure.ac: Change package help message format
	  and fix typo MYSQC_CFLAGS
	* backend/sound_handler.h: Remove old adpcm_expand() decl
	* macros/x11.m4: Two typoes "if x${a} != xfoo"
	* utilities/parser.cpp: Shut compiler up
	* backend/sound_handler_gst.cpp, testsuite/sound_handler_test.cpp:
	  Remove never-implemented stub declaration.
	* server/swf/tag_loaders.cpp: Rewrite of sample-reading code to decode
	  all linear formats in one place.
	* backend/sound_handler_{sdl,gst}.cpp: Remove now unnecessary attempts
	  at decoding other linear audio formats.
	* backend/sound_handler_gst.cpp, testsuite/sound_handler_test.cpp:
	  Replace never-implemented stub declarations, symptom of a deeper ill.
	* backend/sound_handler.h,
	  backend/sound_handler_gst.cpp,
	  backend/sound_handler_gst.h,
	  backend/sound_handler_sdl.cpp,
	  backend/sound_handler_sdl.h,
	  testsuite/sound_handler_test.cpp,
	  testsuite/sound_handler_test.h,
	  server/asobj/SoundMad.cpp:
	  Add two params to convert_raw_data so that it is SDL-independent
	* backend/sound_handler.h,
	  backend/sound_handler.cpp,
	  backend/sound_handler_gst.cpp,
	  backend/sound_handler_gst.h,
	  backend/sound_handler_sdl.cpp,
	  backend/sound_handler_sdl.h,
	  testsuite/sound_handler_test.cpp,
	  testsuite/sound_handler_test.h:
	  convert_raw_samples is now just a static fn of sound_handler::
	* backend/sound_handler.cpp: Speed convert_raw_data and handle stereo
	  upsampling correctly
	* backend/sound_handler_sdl.cpp: Remove bug 19750 that garbled
	  SOUNDSTREAM audio.
	* server/swf/tag_loaders.cpp: Bug fix: calculate # samples correctly.
	* macros/ffmpeg.m4,configure.ac: Workaround /usr/include/ffmpeg reported
	  by pkg-config; move libavformat absence test to final report.

2007-05-17  Rob Savoye  <rob@bertha.welcomehome.org>

	* libbase/Makefile.am: Build libltdl optionally by duplicating the
	  way libltdl/Makefile used to buuld this library.

2007-05-17 Sandro Santilli <strk@keybit.net>

	* macros/: boost.m4, x11.m4: avoid explicit -L/usr/lib.

2007-05-17  Rob Savoye  <rob@bertha.welcomehome.org>

	* libbase/Makefile.am: Add ltdl.h to noinst_HEADERS.
	* po/Makefile.am: Use DESTDIR when installing. 
	* testsuite/server/Makefile.am: Link in FFMPEG is configured to do so.
	* libbase/Makefile.am: Add path for ltdl.h.

2007-05-17 Markus Gothe <nietzsche@lysator.liu.se>

	* configure.ac: Check if LD supports --as-needed.
	* server/asobj/Date.cpp: Clean up and fixed uneeded ftime() use.

2007-05-17 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStreamGst.cpp (unrefElements): don't attempt
	  to unref NULL objects, set objects to NULL after unreffing. Add
	  TODO item.
	* testsuite/misc-ming.all/NetStream-SquareTest.c:
	  Add self-contained tests.
	* testsuite/misc-ming.all/NetStream-SquareTestRunner.cpp:
	  Adjust to simply run the self-contained tests.

2007-05-17 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/getTimer_test.c:
		make the time dependent tests be more tolerant
	
2007-05-17 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all: getTimer_test.c, Makefile.am
	  add a new testcase; activate action_execution_order_test9.c
	* server/vm/VM.{h,cpp}: add a getStartTime() for VM.
	* server/vm/ASHandlers.cpp: use new "getStartTime()" interface,
	  fix ActionGetTimer;
	* libbase/tu_timer.{h,cpp}: change time unit for non-win32 version
	  "get_ticks()";
	  
2007-05-16  Rob Savoye  <rob@bertha.welcomehome.org>

	* macros/boost.m4: Look for shared libs with version numbers after
	the suffix, for OpenBSD.

2007-05-16 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStream.{h,cpp}, 
	  server/asobj/NetStream{Gst,Ffmpeg}.{h,cpp}: Updated documentation.
	* libbase/FLVParser.{h,cpp}, server/asobj/NetStream.{h,cpp}: 
	  Implemented bufferLength.

2007-05-16 Sandro Santilli <strk@keybit.net>

	* libbase/FLVParser.h: class documentation.

2007-05-16 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStreamGst.{h,cpp}: Splitted buildFLVPipeline
	  into buildFLVVideoPipeline and buildFLVSoundPipeline.

2007-05-16 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am,
	  NetStream-SquareTestRunner.cpp, Video-EmbedSquareTestRunner.cpp:
	  Stub video test runners.

2007-05-16 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStreamGst.{cpp,h}: Split startPlayback() into 
	  smaller function (buildFLVPipeline and buildPipeline). Made sure
	  gstreamer elements are cleaned up if setup fails.

2007-05-16  Rob Savoye  <rob@bertha.welcomehome.org>

	* configure.ac: Eval lists so the embedded variables get
	expanded on all systems. Turn on --as-needed for all
	builds. Define LIBLTDL variables and DLOPEN again.
	* backend/Makefile.am: Don't use no-undefined -export-dynamic for
	a library.
	* libbase/Makefile.am: Build standalone libltdl now so we can work
	with an installed one too, which appears to be necessary on 64 bit
	systems.
	* macros/boost.m4: Rewrite to support Boost 3.4, which of course
	changed the library names. Get all libraries with of the right
	type, and sort through the variants to choose the correct one,
	preferably ending in *-mt.so.
	* macros/kde.m4: Define newlist, so we don't stomp the value of
	libslist, which produces bizarre side effects when cross
	compiling.
	* macros/libltdl.m4: Our build of libltdl.la lives in libbase
	instead of libltdl. NOTE: This will unfortunately have to be done
	again if this file is updated in the future from the version
	included on libtool.
	* gui/Makefile.am: -framework Carbon should be defined in
	$OPENGL_LIBS.

2007-05-16 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStreamGst.{cpp,h}: define and use 
	  mutex-protected pipeline control methods.

2007-05-16 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStreamGst.cpp: always check return code
	  from gst_element_factory_make. Handling in case of failure
	  is not verified to be correct. Tgc, could you check it out ?
	* gui/Makefile.am: don't put LDFLAGS in LIBADD, remove
	  spurious character likely slipped in due to Markus
	  fighting with his new keyboard ;)

2007-05-15 Markus Gothe <nietzsche@lysator.liu.se>
	
	* po/se.po: Initial start of Swedish translation.
	* gui/aqua*: Stubs for getting a native OS X UI.
	
2007-05-15 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStreamGst.{h,cpp}: add a resetPipeline() private
	  method doing some checks on the return code (some situations are 
	  still unhandled); use resetPipeline() when needed.
	* server/asobj/NetStream.cpp: warn once about unimplemented stuff.

2007-05-15  Rob Savoye  <rob@bertha.welcomehome.org>

	* configure.ac: Use C++ compiler instead of C compiler so the
	SIZET_FMT test works correctly with GCC 4.3.x. Move libltdl tests
	to top level. Don't configure in the libltdl directory. 
	* gnash/Makefile.am: Don't list libltdl as a SUBDIR.
	* gnash/autogen.sh: Only run libtoolize once.
	* backend/sound_handler_sdl.cpp: Rearranage header order for
	braindead platforms.
	* libbase/Makefile.am: Built ltdl into libbase. Drop linking with
	--no-undefined --export-dynamic.
	* libgeometry/Makefile.am: Built ltdl into libbase. Drop linking
	with --no-undefined --export-dynamic.
	* macros/ffmpeg.m4: Don't add ffmpeg to include path. Fix test for
	avformat.h to be more portable.
	* po/Makefile.am: Install all the translations in a loop.
	* server/URLAccessManager.cpp: Include iconv.h. Use lower case for
	winsock2.h.
	* server/asobj/NetStreamFfmpeg.cpp: Use lower case for winsock2.h.
	* server/asobj/xmlsocket.cpp: Use lower case for winsock2.h.
	* utilities/parser.cpp, processor.cpp: Include libintl.h and
	locale.h for braindead platforms.
	* macros/libltdl.m4: Add autoconf support from libltdl.

	
2007-05-15 Sandro Santilli <strk@keybit.net>

	* server/swf/tag_loaders.cpp (inflate_wrapper): fix infinite loop
	  on inflate errors.
	* server/parser/morph2_character_def.cpp (read): don't abort
	  if number of edges in start and end shapes are not equal.
	  Just raise an SWF error.
	* server/stream.{cpp,h} (skip_bytes): return a boolean value
	  for success/failure.
	* server/swf/PlaceObject2Tag.cpp (readPlaceAction): check
	  return from stream::skip_bytes.
	* libbase/jpeg.cpp: fix typo introduced in last commit.
	* server/swf/PlaceObject2Tag.cpp (readPlaceActions): don't abort when
	  reserved flag != 0.

2007-05-15 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStream.{cpp.h}, server/asobj/NetStreamFfmpeg.{cpp,h},
	  server/asobj/NetStreamGst.{cpp,h}: Moved shared code from 
	  NetStreamFfmpeg and NetStreamGst to the NetStream base class.

2007-05-15 Sandro Santilli <strk@keybit.net>

	* libbase/jpeg.{cpp,h}: cleanups and robustness (first pass).

2007-05-15 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* backend/sound_handler_{sdl,gst}.cpp: Use the 
	  IF_VERBOSE_MALFORMED_SWF macro.
	* libbase/log.h: Added gnash:: to RcInitFile calls.
	* server/swf/tag_loaders.cpp: Use stream::read() instead of loops.

2007-05-15 Sandro Santilli <strk@keybit.net>

	* libbase/GnashException.h: add missing <string> include.

2007-05-15 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/action_execution_order_test9.c:
	  improved comments.
	  
2007-05-15 Sandro Santilli <strk@keybit.net>

	* server/stream.{cpp,h} (set_position): document and change return
	  type to signal failures.
	* server/font.cpp (readDefineFont, readDefineFont2_or_3): use
	  stream::set_position return code to detect SWF malformations.

2007-05-15 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* backend/sound_handler_{gst,sdl}.cpp: Make soundhandlers more robust.
	* server/swf/tag_loaders.cpp: Remember to pass the mp3 data and size.

2007-05-15 Sandro Santilli <strk@keybit.net>

	* server/movie_instance.cpp (advance): safely handle movies 
	  with 0 total frames (malformed SWF).
	* gui/gui.cpp (advance_movie): handle no looping when the
	  total frame count is 0 (malformed SWF).
	* server/dlist.cpp (swapDepth): fix an out-of-bound access.

2007-05-15 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/duplicate_movie_clip_test2.c:
	  more tests.
	* testsuite/misc-ming.all/action_execution_order_test9.c:
	  new testcase.
	  
2007-05-14 Sandro Santilli <strk@keybit.net>

	* server/parser/movie_def_impl.cpp (read_all_swf): handle premature
	  SWF::END tag.
	* libbase/tu_file.{cpp,h}: changed set_position signature to return
	  an int (0 for success TU_FILE_SEEK_ERROR on error).
	* server/stream.cpp (end_tag): check return from
	  tu_file::set_position().

2007-05-14 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, NetStream-Square.c,
	  NetStream-SquareTest.c, Video-EmbedSquare.c,
	  Video-EmbedSquareTest.c: Renamed video tests to conform
	  to the tests naming convention (end with "test"). Enabled
	  build of the SWF. Test runners still missing.
	  Get FLV path on command line.

2007-05-14 Sandro Santilli <strk@keybit.net>

	* server/font.cpp: more robustness improvements.
	* server/font.cpp (readDefineFont, readDefineFont2_or_3): pass
	  shape_character_def the real tag we're parsing.
	* server/parser/shape_character_def.cpp (read): when parsing
	  DEFINEFONT tags provide a dummy solid white fill style to
	  act as a placeholder for consistency checking.

2007-05-14 Sandro Santilli <strk@keybit.net>

	* server/fill_style.{cpp,h}: document default constructor and type.
	* server/vm/ASHandlers.cpp (CommonGetUrl): check url security also
	  when invoking firefox.
	* server/font.cpp (readDefineFont, readDefineFont2_or_3): use 
	  symbolic names for tag type.
	* server/parser/shape_character_def.cpp (read): temporarely 
	  disabled the "don't set line and fill styles if not defined yet".
	  It seems to break a lot of movies. We should find out why though,
	  as I'd think styles must *first* be defined, and *after* referred.

2007-05-14 Sandro Santilli <strk@keybit.net>

	* backend/render_handler_agg_style.h (is_solid): check argument
	  with an assertion before accessing the m_styles vector.
	* server/parser/shape_character_def.cpp (read): don't set line and
	  fill styles to unavailable values. Drop a weird an likely bogus
	  modification of tag_type when  a flagHasNewStyle is set and the
	  tag is DEFINESHAPE.

2007-05-14 Sandro Santilli <strk@keybit.net>

	* utilities/Makefile.am: don't set LDFLAGS twice.
	* server/parser/shape_character_def.{cpp,h}: add ShapeRecordFlags
	  enum to use symbolic names while parsing. Don't change tag type
	  when encountering the flagHasNewStyles set and the tag type
	  is DEFINESHAPE (for which supposedly that flag is reserved);
	  keep parsing instead and print a message about SWF malformacy.
	* gui/Player.cpp (run): exit with a failure if input movie has
	  collapsed dimensions (malformed SWF most likely).
	* server/asobj/xml.{cpp,h}: change extractNode interface to return a
	  bool, so it can implement a custom ignoreWhite thing (the libxml2
	  XML_PARSE_NOBLANKS seems to be not working. Add getXMLOptions()
	  and getIgnoreWhite() utility methods (privates). Fixes bug #19865.
	* testsuite/actionscript.all/XML.as: more tests for ignoreWhite.

2007-05-14 Sandro Santilli <strk@keybit.net>

	* server/asobj/xmlnode.cpp (stringify): represent empty nodes with the
	  "<openclose />" format.
	* server/asobj/xml.{cpp,h}: parseDoc made private; add clear()
	  method for dropping childs and attibutes; clear() on parseXML() or
	  load() calls.
	* testsuite/actionscript.all/XML.as: add a cleaner test for parseXML
	  not appending new definitions. Misses the same for load()

2007-05-14 Sandro Santilli <strk@keybit.net>

	* utilities/Makefile.am: put GNASH_LIBS in LDADD and external
	  libs in LDFLAGS. Drop '-dlopen self'. Please review.

2007-05-14  Rob Savoye  <rob@bertha.welcomehome.org>

	* macros/mtasc.m4: Patch #9531, fix variable name for MTASC.
	* libbase/noseek_fd_adapter.cpp: Include cstring to get C string
	functions used for char * manipulation.
	* libbase/URL.cpp: Include cstring to get C string functions used
	for char * manipulation. 
	* libbase/embedVideoDecoderFfmpeg.cpp: Include cstring to get C
	string functions used for char * manipulation.
	* libbase/curl_adapter.cpp: Include cstring to get C string
	functions used for char * manipulation. 

	* server/gnash.h: Include memory for auto_ptr.
	* libamf/amf.h: Include cstring for C string functions.
	* libamf/amf.cpp: Use lower case for win32 headers, as that's what
	Mingw32 uses.
	
2007-05-14 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/displaylist_depths_test7.c: fix description
	  to match actual implementation. Don't expect a wrong behaviour.

2007-05-14 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: duplicate_movie_clip_test2.c,
	  displaylist_depths_test9.c: don't expect any failure. 
	* server/as_environment.cpp (find_target): strip leading colon chars
	  in path components (fixes ActionDuplicateClip bug).
	* testsuite/misc-ming.all/Makefile.am: fixed bad typo (missing
	  backslash) which triggered NO warning from ./autogen.sh
	  but still resulted in bogus Makefile.in produced (sic!).

2007-05-14 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/FLVParser.cpp: Fixed a out-of-bound error (bug #19866).
	* testsuite/media/square.flv: Added. Used for testing.
	* testsuite/misc-ming.all/NetStream-Square.c: Added. Created simple
	  SWF which plays square.flv using NetStream.
	* testsuite/misc-ming.all/Video-EmbedSquare.c: Added. Created simple
	  SWF which plays an embedded video (ripped from square.flv).

2007-05-14 Sandro Santilli <strk@keybit.net>

	* po/Makefile.am: create destination directories before trying to
	  install things there.

2007-05-14  John Gilmore  <gnu@toad.com>

	Internationalization, further cleanup:
	
	* po/Makefile.am:  Pass proper flags to xgettext to handle _(...).
	* po/LINGUAS:  Remove, superseded by Makefile.am's "translations".
	* backend/sound_handler_gst.cpp, cygnal/cygnal.cpp, cygnal/http.cpp,
	  cygnal/statistics.cpp, cygnal/stream.cpp, gui/gtk.cpp,
	  gui/gtk_glue_gtkglext.cpp, gui/kde.cpp, gui/stl_agg_glue.cpp,
	  libamf/amf.cpp, libamf/rtmp.cpp, libbase/rc.cpp,
	  libbase/sharedlib.cpp, server/movie_root.cpp, utilities/parser.cpp,
	  utilities/processor.cpp: Insert header
	  comment and fix up copyright spacing.
	* backend/sound_handler_gst.cpp, cygnal/cygnal.cpp, cygnal/http.cpp,
	  cygnal/statistics.cpp, cygnal/stream.cpp, gui/Player.cpp,
	  gui/gtk.cpp, gui/gtk_glue_gtkglext.cpp, gui/stl_agg_glue.cpp,
	  libamf/amf.cpp, libamf/rtmp.cpp, libbase/network.cpp, libbase/rc.cpp,
	  libbase/sharedlib.cpp, server/as_function.cpp, server/debugger.cpp,
	  server/movie_root.cpp, utilities/parser.cpp, utilities/processor.cpp:
	  Pass messages through _(...).
	* backend/sound_handler_gst.cpp, backend/sound_handler_mp3.cpp,
	  cygnal/README, cygnal/cygnal.cpp, cygnal/http.cpp,
	  cygnal/statistics.cpp, cygnal/stream.cpp, gui/Player.cpp,
	  gui/gtk.cpp, gui/gtk_glue_gtkglext.cpp, gui/stl_agg_glue.cpp,
	  libamf/amf.cpp, libamf/rtmp.cpp, libbase/network.cpp,
	  libbase/rc.cpp, libbase/sharedlib.cpp, server/as_function.cpp,
	  server/debugger.cpp, server/dlist.cpp, server/movie_root.cpp,
	  utilities/parser.cpp, utilities/processor.cpp:
	  Clean up messages (remove \n's and !s, change wording, use
	  log_XXX functions rather than dbglogfile <<, use proper log_XXX
	  function, fix typos, etc).
	* backend/sound_handler_mp3.cpp: New 2007 Free Software Foundation
	  copyrights applied (to formerly public domain code)
	* cygnal/cygnal.cpp, cygnal/http.cpp, cygnal/statistics.cpp,
	  cygnal/stream.cpp, gui/gtk_glue_gtkglext.cpp, gui/kde.cpp,
	  gui/stl_agg_glue.cpp, libbase/sharedlib.cpp: Update copyright
	  to 2007.
	* cygnal/http.cpp (HTTP::sendGetReply),
	  cygnal/stream.cpp (sendfile_thread),
	  libamf/amf.cpp (AMF::encodeElement, AMF::extractElementLength,
	  AMF::parseBody, AMF::extractVariable),
	  server/debugger.cpp (Debugger::dumpStackFrame): Insert FIXME
	  about likely bug.
	* gui/kde.cpp (qwidget::qwidget):  Translate strings for the
	  pop-up menu items.
	* libbase/network.cpp (Network::writeNet):  Remove dead code.
	* AUTHORS, gui/gtk.cpp (authors):  Add myself to authors list.
	
2007-05-14 Sandro Santilli <strk@keybit.net>

	* server/rect.{cpp,h} (read): check for min/max values swapped
	  reporting SWF malformation and setting the rect to NULL if
	  that happens.
	* server/parser/movie_def_impl.cpp (readHeader): report SWF
	  malformation if movie bounds were malformed.

2007-05-14 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/: displaylist_depths_test9.c, Makefile.am:
	  new scenario for Timeline Control, gnash passes.
	  But luckly, caught a bug in ActionDuplicateClip :)
	* testsuite/misc-ming.all/action_execution_order_test8.c: indent
	* testsuite/misc-ming.all/: duplicate_movie_clip_test2.c, Makefile.am:
	  new testcase for duplicateMovieClip.
	  
2007-05-13  Rob Savoye  <rob@bertha.welcomehome.org>

	* po/Makefile.am: Add install-data-hook target so the .gmo files
	get installed. Build and install German translation.
	* po/de.po: German translation by benjamin.goose@lrz.uni-muenchen.de.
	* doc/C/sources.xml: Fix unclosed <para> tags.
	* macros/ffmpeg.m4: Only print warning and reset
	ac_cv_path_ffmpeg_incl if avformat.h doesn't exist.
	
2007-05-13 Sandro Santilli <strk@keybit.net>

	* macros/boost.m4: typo fix (might need another go at testing)
	* testsuite/actionscript.all/Number.as: skip conversion-to-number
	  tests if Ming doesnt' support ASM.
	* testsuite/actionscript.all/XML.as: add tests exposing two bugs
	  with XML (parseXML appending newly parsed stuff and ignoreWhite
	  being unsupported).

2007-05-12 Martin Guy <martinwguy@yahoo.it>

	* server/stream.{h.cpp}: Punch a block-read primitive through the
	  stream layer.
	* server/parser/sound_definition.cpp: Move ADPCM code elsewhere
	* server/swf/tag_loaders.cpp: Decode all linear formats into native 16,
	  move ADPCM code here where it's used.

2007-05-12 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* backend/sound_handler_gst.cpp: Make sure sounds are stopped
	  when done being played. Should fix bug #19628.
	* libbase/FLVParser.{h,cpp}: Switched from referring to the last
	  frame we used, to the next frame we're going to use.
	* libbase/curl_adapter.cpp: Fix use of usleep() on windows.
	* macros/opengl.m4: Fixed detection on windows.
	* macros/boost.m4: Re-commited Deannas boost patch with a small fix.

2007-05-12 Sandro Santilli <strk@keybit.net>

	* server/character.h (isDynamic): the root movie, not having
	  been placed in a parent displaylist, has NO TimelineInfo
	  associated. Consider this in the assertion aimed at dropping
	  the _dynamicallyCreated flag.
	* libbase/tu_file.cpp (std_tell_func): don't require not to 
	  be at EOF on tell() call. See bug #19861.

2007-05-12 Sandro Santilli <strk@keybit.net>

	* server/execute_tag.h, server/swf/PlaceObject2Tag.{cpp,h},
	  server/swf/tag_loaders.cpp: Drop execute_tag::execute_state_reverse()
	  and execute_tag::get_depth_id_of_replace_or_add_tag) methods.
	* server/sprite_instance.{cpp,h}: (advance_sprite, execute_frame_tags):
	  call resetDisplayList in advance_sprite rather then delegate to
	  execute_frame_tags, to avoid an invocation during
	  restoreDisplayList(). (restoreDisplayList): fix comment for
	  step1, remove commented out code. Drop the m_is_reverse_execution
	  flag and associated getter. Drop execute_frame_tags_reverse() method.
	  Drop find_previous_replace_or_add_tag method. (goto_frame) Move
	  UdoG comment where it belonge [old design block], add comment about
	  possible problem with clearing the action queue after displaylist 
	  restoration.
	* testsuite/misc-ming.all/loop_test-Runner.cpp: Don't set action
	  verbosity.

2007-05-11 Sandro Santilli <strk@keybit.net>

	* server/dlist.{cpp,h}: Add another DisplayList mass-removal
	  function taking a vector of gnash::characters to remove.
	* server/character.h: Add support for attaching TimelineInfo
	  records to (timeline) instances.
	* server/sprite_instance.cpp: 
	  (add_display_object, replace_display_object):
	  add TimelineInfo record to placed timeline instance. 
	  (restoreDisplayList): implemented DisplayList reconstruction
	  algorithm as defined on the "Timeline control" wiki page.
	  (goto_frame): use restoreDisplayList when jumping-back, properly
	  set m_current_frame when jumping-forward, for proper TimelineInfo
	  construction.
	* testsuite/misc-ming.all/: displaylist_depths_test4.c,
	  displaylist_depths_test5.c, displaylist_depths_test6.c,
	  displaylist_depths_test7.c, displaylist_depths_test8.c:
	  Most new Timeline-focused testcases pass now.
	  PLEASE HELP MAKING MORE !!

2007-05-11  Rob Savoye  <rob@ute.welcomehome.org>

	* macros/curl.m4, sdl.m4: Drop extraneous results.
	* macros/x11.m4: Remove --enable test, remove extraneous results.

2007-05-11 Sandro Santilli <strk@keybit.net>

	* server/dlist.h (move_display_object): document the call to
	  accept_anim_move().
	* testsuite/misc-ming.all/displaylist_depths_test7.c: fix missing
	  failure "expectance" and associated comment.
	* testsuite/misc-ming.all/: Makefile.am, displaylist_depths_test8.c:
	  New case: "Jumping backward to the start of a character's lifetime
	  after dynamic transformation"

2007-05-11 Sandro Santilli <strk@keybit.net>

	* server/dlist.{cpp,h} (swapDepths): abort if target depth
	  equals depth of source character.
	* server/sprite_instance.cpp (sprite_swap_depths): raise
	  a debugging message and skip any depths swap if target depth
	  equals depth of source character.
	* testsuite/misc-ming.all/: Makefile.am, displaylist_depths_test7.c:
	  New scenario testing that swapDepth(currentdepth) has no effect.

2007-05-11 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/displaylist_depths_test6.c:
	  Jump to frame 5, to avoid a failure and success of
	  the same test in two different points in time, and *stop* there
	  (wiki updated).
	* server/dlist.{cpp,h}: drop dangerous swap_characters, add safe,
	  documented and correct swapDepths. (fixes displaylist_depths_test6).
	* server/sprite_instance.{cpp,h}: drop dangerous swap_characters,
	  add safe and swapDepths proxy to DisplayList's.

2007-05-11 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/Makefile.am: enabled
	  displaylist_depths_test6.swf runner
	* testsuite/misc-ming.all/displaylist_depths_test6.c:
	  Some comments cleanup, and an additional expected failure
	  (slightly unrelated to test focus, I'd say).

2007-05-11 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.h: improved documentation for the
	  add_display_object() method. I think this is where we're going
	  to add a TimelineInfo record (see Timeline Control page on the
	  wiki).

2007-05-11 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/: displaylist_depths_test6.c:
	  new scenario for Timeline Control
	  NOTE: Gnash fails this one !!
	  
2007-05-11 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, displaylist_depths_test5.c:
	  new scenario for Timeline Control (see wiki for more details).
	  NOTE: Gnash fails this one !!

2007-05-10 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, displaylist_depths_test4.c:
	  new scenario for Timeline Control (see wiki for more details).
	  NOTE: Gnash fails this one !!

2007-05-10 Sandro Santilli <strk@keybit.net>

	* testsuite/anaylse-results.sh: print an header before the actual
	  results; don't limit depth of search for summary files.
	* Makefile.am, add an anal rule to run the test results analyzer.
	  Run the analyzer at end of 'make check', so the report doesn't
	  scroll-up.
	* testsuite/Makefile.am: don't run the analyzer from testsuite/ dir
	  as it would miss some tests in upper directories.

2007-05-10 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, displaylist_depths_test2.c,
	  displaylist_depths_test3.c: Cleanup comments for test2 and add
	  new scenario for Timeline Control (see wiki for more details).

2007-05-10 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am,
	  SpriteButtonEventsTest-Runner.cpp, SpriteButtonEventsTest.c:
	  Produced a MovieClip versio of the ButtonEventTest.swf movie.
	  Seems to work fine, test automated.

2007-05-10 Sandro Santilli <strk@keybit.net>

	* server/event_id.h, server/vm/action.cpp: add
	  event_id::is_button_event() method
	* server/sprite_instance.{cpp,h}: add isEnabled() method,
	  (on_event): don't react to button events if not enabled.
	* testsuite/misc-ming.all: ButtonEventsTest-Runner.cpp,
	  ButtonEventsTest.c: add test for Button.enable flag.

2007-05-10 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/MovieClip.as: more and better tests for
	  MovieClip.enabled.
	* server/sprite_instance.cpp (attachMovieClipInterface): initialize
	  an 'enabled' property in MovieClip.prototype (fixes old and new
	  tests for it in MovieClip.as); 

2007-05-10 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/displaylist_depths_test2.c: target
	  SWF7, use getInstanceAtDepth() to verify Gnash succeeds the
	  test, despite the fact it's "soft references" implementation 
	  is bogus (thanks to zou for the tip!). We might still want a
	  MovieTester based runner to check for rendering in any case,
	  but less urgent...
	* server/sprite_instance.{cpp,h}: Implemented
	  MovieClip.getInstanceAtDepth() and MovieClip.getSWFVersion();
	  stubbed MovieClip.getTextSnapshot().
	* testsuite/actionscript.all/MovieClip.as: tested
	  MovieClip.getSWFVersion() and MovieClip.getInstanceAtDepth().

2007-05-10 Sandro Santilli <strk@keybit.net>

	* server/as_value.{cpp,h}: encoding of movieclip values
	  by target path made optional, to help future attempts
	  at changing it, due to conceptual bug found in it running
	  the displaylist_depths_test2.swf testcase. The default is
	  no change. Undefine MOVIECLIP_AS_SOFTREF to keep them by
	  pointer (still fails some testcases so not enabled).

2007-05-10 Martin Guy <martinwguy@yahoo.it>

	* configure.ac: Don't warn about ffmpeg/mad absence during tests;
	  they are checked and nogoed at the end.
	* configure.ac: Don't report SDL FLAGS and help message twice.
	* macros/ffmpeg.m4: Avoid spurious syntax errors when avcodec not found

2007-05-09 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, displaylist_depths_test2.c:
	  New test showing the effects of a swapDepth moving a static
	  instance to the dynamic zone when jumping back to a frame in which
	  the char is supposed to be at it's original depth.
	  Incredibly, Gnash passes all tests, except a couple which are due
	  to the way we implemented "soft references" and that makes it
	  hard to test for actual existance of the old instance.

2007-05-09 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* testsuite/misc-ming.all/DrawingApiTestRunner.cpp: fix ambiguous 
	  strk() call  

2007-05-09 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/Makefile.am: don't build the
	  alltests-v#-Runners on make check. We dont' use them currently.
	* testsuite/misc-ming.all/: Makefile.am, .cvsignore:
	  Enabled static_vs_dynamic testcases.
	* testsuite/misc-ming.all/static_vs_dynamic1.c: Don't expect a failure
	  as we're not failing :)

2007-05-09 Sandro Santilli <strk@keybit.net>

	* extensions/fileio/fileio.{cpp,h}: don't forget to setup
	  the FileIO exported interface; Fix some const-correctness
	  for the class methods; have seek() return the correct value;
	  cast arguments to the expected type. Needs more love, but
	  I won't give it *now* :)
	* configure.ac: drop unneeded LTVERSION_VERSION macro call.
	* gui/: fltk.cpp, gtk.cpp, sdl.cpp:
	  Check if createRenderHandler of the glue returns
	  NULL, and return false in that case.

2007-05-09 Sandro Santilli <strk@keybit.net>

	* testsuite/MovieTester.cpp (initTestingRenderers): try initializing
	  an AGG renderer for *each* known pixel format.
	* backend/render_handler_agg.{cpp,h} (create_render_handler_agg):
	  Take pixelformat by *const* pointer, do NOT abort when the given
	  pixelformat is unsupported, just return NULL.
	* testsuite/misc-ming.all/action_execution_order_test8.c:
	  Added description as reported on bug #19727.
	* testsuite/misc-ming.all/static_vs_dynamic2.c:
	  Moved description of the test on top.
	* gui/Makefile.am: fixed typo preventing 'dist' to work.
	* testsuite/misc-ming.all/action_execution_order_test8.c:
	  Fixed access to uninitialized memory (segfault).

2007-05-09 Andrew Guertin <bugzilla@dolphinling.net>

	* macros/ming.m4: cleaner fix for #19826 (don't redirect
	  stderr...)

2007-05-09 Sandro Santilli <strk@keybit.net>

	* macros/ming.m4: redirect stderr to /dev/null when using
	  passing the beta version to printf (would complain if
	  the version has no beta component). Closes bug #19826.

2007-05-09 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/static_vs_dynamic1.c, static_vs_dynamic2.c:
	  test what we discussed yestoday.
	  
2007-05-08 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/DrawingApiTestRunner.cpp: tolerate
	  a 1-pixel Y drift for the harilined black line, as introduced
	  by latest "pixel hinting" "fix" in AGG (see bug #19775);
	  Also, changed checked point for the diagonal violet line for
	  the same reason. See bug #19828 for more info.
	* extensions/dejagnu/Makefile.am, extensions/gtk2/Makefile.am,
	  extensions/mysql/Makefile.am: remove other direct references
	  to convenience libraries.
	* testsuite/Makefile.am, testsuite/server/Makefile.am:
	  Do not explicitly link convenience libraries under the server/
	  dir. Fixes bug #19821.
	* libbase/extension.cpp: print plugins path.
	* extensions/fileio/Makefile.am: export GNASH_PLUGINS to the buil tree
	  when running the test program.
	* testsuite/generic-testrunner.sh: export any GNASH variable in the
	  environment, so to allow generic test runners to specify a plugin
	  dir, and eventually a GNASHRC file (when we add support for it).
	* Makefile.am (dumpconfig): add info about which extensions are being
	  built (if not null extensions are scanned, would be better to 
	  just report wheter extensions are buil or not instead..)
	* configure.ac: define USE_EXTENSIONS if build of any extension is
	  enabled.

2007-05-08 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* backend/render_handler_agg.cpp: Fix vector alignment ("pixel
	  hinting"). Fixes bug #19775. 

2007-05-08 Sandro Santilli <strk@keybit.net>

	* libbase/LoadThread.h: threading enabled by default.
	* macros/ffmpeg.m4: set LIBS and CFLAGS to the detected or provided
	  values for the macro lifetime, so to more easily find any dependent
	  lib in custom dirs; do not discard user-provided libdir; be more
	  verbose about version checking.
	* server/asobj/NetStream.cpp (fix members initialization order).
	* server/asobj/NetStreamGst.{cpp,h}: Make start thread
	  use a compile-time option. Defaults to true for now,
	  but worth disabling for better testing (btw: why do
	  we need a "start" thread and a "continue" thread?)

2007-05-07 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/FLVParser.cpp: When seeking to 0 just go to
	  the first frames.
	* server/asobj/NetStream.{h,cpp}: Moved setBufferTime() to
	  the base class, implemented bufferTime().
	* server/asobj/NetStreamFfmpeg.{cpp,h}: Moved setBufferTime()
	  to the base class.
	* server/asobj/NetStreamGst.{cpp,h}: Moved setBufferTime() to
	  the base class. tried to improve seeking by using an offset
	  to avoid telling gstreamer about the seek.

2007-05-07 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStream{Ffmpeg,Gst}.cpp: After playback stops,
	  make it possible to restart video by seeking to 0 and setting
	  pause to false.

2007-05-07 Martin Guy <martinwguy@yahoo.it>

	* backend/sound_handler.h: Fix commentary about RAW and UNCOMPRESSED
	  formats.
	* configure.ac: Make absence of ffmpeg or libmad libraries a fatal error
	  when they are selected, instead of quietly turning media handling off.
	* configure.ac: Fix names of Debian packages required for ffmpeg.
	* configure.ac: Fix logic of missing ffmpeg library reporting code.

2007-05-07 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetConnection.cpp (openConnect): print FLV url before
	  setting loader stream so that it's visible before full download in
	  case threading is disabled.
	* libbase/log.h: fully qualify __Host_Function_Report__ so
	  GNASH_REPORT_FUNCTION can be used by classes outside of 'gnash'
	  namespace.
	* libbase/curl_adapter.cpp (fill_cache): avoid aggressive polling by
	  taking naps between iterations. "Smart" sleep times are taken
	  in consideration so we can tweak them.

2007-05-07 Sandro Santilli <strk@keybit.net>

	* libbase/LoadThread.{cpp,h}: Make thread usage a compile-time
	  configuration. Temporarely defaults to NOT using thread till
	  we fix bug #19811 and general CPU hogs during loading.

2007-05-07 Markus Gothe <nietzsche@lysator.liu.se>

	* configure.ac, gui/aqua*: Added aqua/carbon-stubs.

2007-05-06 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/LoadThread.cpp: Delete the thread after use so we don't
	  try to join it again. Fixes bug #19811.
	* server/asobj/NetStreamGst.cpp: Fixed pausing and play, bug #19797.

2007-05-06 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/sprite_instance.cpp: Stop all sounds when restarting 
	  a movie, fixes bug #19568.
	* server/asobj/NetStreamFfmpeg.cpp: Fixed return time.
	* server/asobj/NetStreamFfmpeg.h: Added a comment.
	* server/asobj/NetStreamGst.cpp: Moved gst-init to the
	  contructor, fixes bug #19795. Only create audio/video elements
	  if needed.

2007-05-04 Sandro Santilli <strk@keybit.net>

	* testsuite/samples/clip_as_button2-TestRunner.cpp: add pixel
	  color checking.
	* testsuite/actionscript.all/NetConnection.as: unexpected success..

2007-05-04 Sandro Santilli <strk@keybit.net>

	* libbase/FLVParser.h (FLVVideoFrame): add isKeyFrame() method;
	  use typedefs for video and audio frame containers.
	* libbase/FLVParser.cpp: use isKeyFrame(), easier to read.

2007-05-04 Sandro Santilli <strk@keybit.net>

	* libbase/FLVParser.cpp (seekAudio, seekVideo): fixed seeking and
	  hopefully made a bit more readable. The computed values are
	  now printed for further debugging. They seem correct to me, but
	  it seems they are not correctly used.
	* server/asobj/: NetStream.{cpp,h}, NetStreamFfmpeg.{cpp,h},
	  NetStreamGst.{cpp,h}: change play() method to take a std::string
	  ref instead of a char*; always pass environment when casting args
	  to numbers or strings.

2007-05-04 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetStream.cpp: stubbed missing methods and
	  properties.
	* libbase/tu_file.cpp (std_get_stream_size_func): use fstat to 
	  get stream size. (other funx for filesystem access): add some assertions
	  to prevent seeking past the end of the stream.
	* libbase/LoadThread.cpp (read): don't seek past the end of the
	  stream. Add a few assertions checking that _loadPosition is
	  never > then _streamSize.

2007-05-04 Markus Gothe <nietzsche@lysator.liu.se>

	* gui/aqua.cpp: Initial creation.

2007-05-04 Markus Gothe <nietzsche@lysator.liu.se>

	* macros/boost.m4: Fixed a bug in GNASH_BOOST_PATH.
	* server/asobj/SoundFfmpeg.h: Build on OS X.
	* backend/sound_handler_sdl.h: Build on OS X.

2007-05-03 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetConnection.{cpp,h}: change openConnection interface
	  to take url by ref (not by pointer) and nothing else (drop owner
	  arg). Stubbed documentation of the method (needs more info).
	* server/asobj/: NetStreamFfmpeg.cpp, NetStreamGst.cpp, Sound.cpp,
	  SoundFfmpeg.cpp, SoundGst.cpp, SoundMad.cpp:
	  Updated calls to openConnection.

2007-05-03 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetConnection.{cpp,h}: keep _loader by auto_ptr, some
	  comments and interfaces cleanup.
	* server/asobj/: NetStreamFfmpeg.cpp, NetStreamGst.cpp: update calls
	  to connectParser(), now taking by ref.

2007-05-03 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetConnection.{cpp,h}: Yay, another ActionScript class
	  layout version. As a side effect stubbed missing properties and
	  methods of the class + cleanups in the connect() method.

2007-05-03 Sandro Santilli <strk@keybit.net>

	* configure.ac: rewording of ffmpeg warnings. Shows a bug in ffmpeg.m4
	  failing to detect version and thus failing to accept it when
	  passed explicit --with-ffmpeg-incl and --with-ffmpeg-lib.
	* server/asobj/: NetStream.{cpp,h},
	  NetStreamFfmpeg.cpp, NetStreamGst.cpp:
	  Use an enum for status codes, avoid notifying multiple
	  times the same status.

2007-05-03 Sandro Santilli <strk@keybit.net>

	* gui/gui.cpp: Add RENDER_ONE_FRAME_EVERY macro to skip
	  rendering of a given fraction of movie frames (for debugging).
	* server/video_stream_instance.cpp (display): call
	  clear_invalidated().

2007-05-03 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* server/video_stream_instance.cpp: implemented proper 
	  add_invalidated_bounds()

2007-05-03 Sandro Santilli <strk@keybit.net>

	* server/asobj/Makefile.am, server/parser/Makefile.am,
	  server/vm/Makefile.am: -release makes no sense for
	  convenience libraries.
	* testsuite/misc-ming.all/DrawingApiTest.as: reintroduced
	  visual hitTest checks (not automated yet). This time
	  they don't break the exising test.
	* testsuite/MovieTester.{cpp,h}: add redraw() method,
	  by default only force a redraw on *first* advance.

2007-05-03 Markus Gothe <nietzsche@lysator.liu.se>

	* backend/render_handler_ogl.cpp: Make it work with __APPLE_CC__.

2007-05-03 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (add_empty_movieclip):
	  call set_invalidated as the newly added character might
	  replace a previously existing one. See bug #19683.
	* server/video_stream_instance.{cpp,h},
	  server/parser/video_stream_def.{cpp,h}:
	  Encode ownership of embedded videodecoder by using std::auto_ptr,
	  and document it.
	* server/asobj/NetConnection.cpp (getBytesTotal): return total bytes,
	  not "loaded" bytes... - fixes YouTube buffering bar.

2007-05-03 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* backend/render_handler_agg.cpp: by default use world invalidated
	  bounds (not Null) 	
	* server/character.cpp: negative scaling values are legal (related to 
	  bug #18874, but not fixing it) 	
	* backend/render_handler_agg.cpp: use absolute scaling values when
	  calculating stroke width, fixes 18874  	

2007-05-03 Andrew Guertin <bugzilla@dolphinling.net>

	* backend/: sound_handler.h, sound_handler_gst.cpp,
	  sound_handler_sdl.cpp: Makes Nellymoser not an "unknown" format in
	  the error message, just unsupported, Makes GST's unknown format
	  error message better (copied SDL's), Adds an assertion that
	  ADPCM and UNCOMPRESSED should never be passed to the sound
	  handler, Adds a comment to sound_handler.h

2007-05-02 Sandro Santilli <strk@keybit.net>

	* testsuite/Makefile.am: explicitly list other gnash libs.
	* testsuite/libgeometry/Range2dTest.cpp: tolerate some floating
	  point drift.

2007-05-02 Markus Gothe <nietzsche@lysator.liu.se>

	* libbase/Makefile.am: Get sure we link against gettext if found.

2007-05-02  Rob Savoye  <rob@bertha.welcomehome.org>

	* po/Makefile.am: We don't need $(srcdir) since we're specifing
	the directory.
	* server/asobj/Makefile.am: Make libgnashasobjs a a convienience
	library. 
	* server/parser/Makefile.am: Make libgnashparser a a convienience
	library. 
	* server/vm/Makefile.am: Make libgnashvm a a convienience
	library. 
	* utilities/Makefile.am: Don't link in all the other libraries.
	* gui/Makefile.am: Don't link in all the other libraries.

	* libbase/curl_adapter.cpp: Don't redefine snprintf() for win32.
	* libbase/noseek_fd_adapter.cpp: Don't redefine snprintf() for
	win32.
	* libbase/log.h: Include io.h for win32.
	* libbase/network.cpp: Use inet_ntoa() instead of the newer
	inet_ntop(). Include ws2tcpip.h for win32.
	* libbase/tu_timer.cpp: Use lowercase mmsystem.h.
	* libbase/tu_types.h: Don't use __FUNCDNAME__ to redefine
	__PRETTY_FUNCTION__for all win32 builds.
	* macros/boost.m4: Remove extraneous boost directory when
	searching for header files.

2007-05-02 Sandro Santilli <strk@keybit.net>

	* libbase/curl_adapter.cpp (fill_cache): stop uselessly calling
	  fstat(); don't call curl_multi_perform if not needed.
	* libbase/log.cpp: call the logfile singletone getter only once.
	* libbase/image.{cpp,h}: move documentation of the update() method
	  from cpp to h file. This is the most time-expensive routine in 
	  libgnashbase when playing youtube.
	* libbase/LoadThread.{cpp,h}: isPositionConfirmed inlined and
	  const-corrected.

2007-05-02 Martin Guy <martinwguy@yahoo.it>

	* libbase/tu_config.h,libbase/jpeg.cpp,server/swf/tag_loaders.cpp,
	  compatibility_include.h: Having jpeglib is compulsory, so
	  remove TU_CONFIG_LINK_TO_JPEGLIB
	* Revert attempt to use endian.hpp. It broke someone's build. QED.
	* gui/fb.cpp: Fix compiler warnings
	* libbase/tu_config.h,server/swf/tag_loaders.cpp: Allow compilation
	  without zlib, auto-switching TU_CONFIG_LINK_TO_ZLIB on HAVE_ZLIB_H
	  (works with renderer=agg/opengl, gui=fb/sdl, media=gst/mad/none;
	  gtk/kde, cairo, ffmpeg require zlib in their own right)
	* configure.ac: Reformat messages
	* libbase/tu_config.h,libbase/zlib_adapter.{cpp,h},server/tools.cpp,
	  server/{impl.cpp,parser/movie_def_impl.cpp,swf/tag_loaders.cpp},
	  compatibility_include.h: eliminate TU_CONFIG_LINK_TO_ZLIB;
	  use HAVE_ZLIB_H directly.
	* configure.ac: Suggest packages to install when zlib-dev is missing
	* configure.ac,macros/ffmpeg.m4: Fix quotation in ffmpeg detection and
	  skip version checking to avoid syntax errors during "configure"
	  if the library is not found.
	* server/asobj/SoundMad.cpp: Fix compiler warnings.
	* gui/sdl.cpp: Regularize bizarre indentation
	* gui/sdl.cpp: A closer hack at making movies run at correct speed.
	  Before: always at 100 frames per second + cpu time.
	  After: Still not perfect: in non-interactive movie, visuals are a
	  fraction of a second ahead of MP3 soundtrack.

2007-05-02 Sandro Santilli <strk@keybit.net>

	* backend/sound_handler_gst.cpp, gui/Player.cpp, libamf/amf.cpp,
	  libbase/log.h, server/as_function.cpp, server/swf/tag_loaders.cpp,
	  server/button_character_instance.cpp, server/character.cpp,
	  server/sprite_instance.cpp, server/asobj/NetStreamGst.cpp:
	  Drop log_warning, till we find a semantic for it.

2007-05-02 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (sprite_getBounds): remove TESTING
	  warning, I'm pretty confident about this function now.

2007-05-01  Rob Savoye  <rob@bertha.welcomehome.org>

	* libamf/Makefile.am: Add BOOST_CFLAGS so we can find endian.hpp.

2007-05-01 Sandro Santilli <strk@keybit.net>

	* server/asobj/: NetStream.{cpp,h}, NetStreamFfmpeg.{cpp,h},
	  NetStreamGst.{cpp,h}: move all onStatus handling to base class
	  and made thread safe.

2007-05-01 Sandro Santilli <strk@keybit.net>

	* server/movie_root.h: add getWidth() and getHeight()
	* server/asobj/Stage.{cpp,h}: implement Stage.width and
	  Stage.height.
	* testsuite/actionscript.all/Stage.as: small test for
	  Stage.width and Stage.height (not automated)

2007-04-30 Sandro Santilli <strk@keybit.net>

	* testsuite/swfdec/swfdec_gnash_tester: allow 11 loop-backs.
	* testsuite/swfdec/PASSING: function1.swf now succeeds.

2007-04-30 Sandro Santilli <strk@keybit.net>
		
	* testsuite/libamf.all/Makefile.am: proper clean rule.
	* testsuite/misc-ming.all/Makefile.am: proper clean rule.
	* doc/C/Makefile.am: distribute actionscript.xml and related
	  files.

2007-04-30 Martin Guy <martinwguy@yahoo.it>

	* backend/sound_handler_sdl.cpp: Fix volume scaling in 8->16 bit
	  raw data conversion (closes bug #19747)
	  and convert cascaded ifs to a case.

2007-04-30 Sandro Santilli <strk@keybit.net>

	* Makefile.am: don't put 'po' in EXTRA_DIST, as it's already
	  in SUBDIRS.
	* server/StringPredicates.h: include cctype.
	  See: http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=417210.
	* po/Makefile.am: don't update the .po files on every .gmo
	  production. Produce the .gmo in the build tree, not in the
	  source tree.

2007-04-30 Martin Guy <martinwguy@yahoo.it>

	* libbase/tu_types.{h,cpp}, server/swf/tag_loaders.cpp:
	  Eliminate remnants of _TU_LITTLE_ENDIAN_
	* configure.ac: Drop now-redundant endian header detection
	* libamf/amf.{h,cpp}: swapBytes is now file-local and uses libboost

2007-04-30 Sandro Santilli <strk@keybit.net>

	* autogen.sh: only process configure.ac in root dir and under libltdl,
	  running a find annoingly descends in just generated dist dirs.
	* testsuite/samples/Makefile.am: distribute gotoFrameOnKeyEvent.swf.
	* testsuite/actionscript.all/array.as: add test for deleting an
	  array element, and for array indexes being proper properties
	  (fails in gnash).
	* configure.ac: if ffmpeg version doesn't match the required one
	  set media handling to none.
	* testsuite/misc-ming.all/action_execution_order_test8.c: add
	  more output trying to understand the problem better.
	* server/parser/shape_character_def.cpp (compute_bounds): harline
	  strokes don't add anything to the bounds (no need to expand to
	  circle, same as for hidden strokes).
	* testsuite/misc-ming.all/Makefile.am: 
	  Activated action_execution_order_test{7,8}.

2007-04-30 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/action_execution_order_test7.c:
	  a simple and normal one that we should pass.
	* testsuite/misc-ming.all/action_execution_order_test8.c:
		another one for execution order.
	  
2007-04-29 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, DrawingApiTest.as: add
	  tests for hitTest (not automatically run, but works fine so far).
	* server/button_character_instance.{cpp,h}: implement pointInShape().

2007-04-28 Sandro Santilli <strk@keybit.net>

	* server/vm/ASHandlers.cpp (ActionWith): skip with() blocks
	  given a parameter not casting to an object.
	* testsuite/actionscript.all/with.as: 
	  Add tests explaining why the tests in previous
	  commit are failing in SWF5 version.

2007-04-28 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/actionscript.all/with.as:
	  add more tests

2007-04-28 Sandro Santilli <strk@keybit.net>

	* server/as_environment.{cpp,h}: stop descending
	  the CallStack looking into the callers locals!
	* testsuite/actionscript.all/Function.as: success
	  with SWF5 and (missing) scope chain.

2007-04-27  Rob Savoye  <rob@pawnee.welcomehome.org>

	* gui/fltk.cpp: Cast the key::code so it compiles on Darwin.
	* macros/agg.m4: Don't inherit the -rpath setting fropm
	pkg-config, it screws up the linux on Darwin.
	* macros/incllist, libslist: Look in $with_top_level for support
	packages no in the $prefix path.
	* macros/pthreads.m4: Add -mthreads for mingw32.
	* macros/x11.m4: If X11 is found, also add libSM and libICE if
	they are found to resolve dependencies on Darwin.
	* server/Makefile.am: Remove -no-undefined as it cause dependency
	problems on Darwin.
	* server/vm/Makefile.am: Remove -no-undefined as it causes
	inter-library dependency problems on Darwin.
	* server/parser/Makefile.am: Remove -no-undefined as it causes
	inter-library dependency problems on Darwin.
	* server/asobjsMakefile.am: Remove -no-undefined as it causes
	inter-library dependency problems on Darwin. Add libgeo to the
	link line.
	* server/vm/VM.cpp: Don't use the gnash:: namespace with setting
	the global singleton, it won't compile on Darwin.

2007-04-27 Sandro Santilli <strk@keybit.net>

	* server/swf/PlaceObject2Tag.cpp (readPlaceActions): fix check for
	  all reserved bits being zero (removed an annoying false malformed
	  swf error).
	* gui/gtk.cpp: comment out function tracing for key and mouse events.

2007-04-27 Martin Guy <martinwguy@yahoo.it>

	* configure.ac: Add verbose text for missing gstreamer-dev help

2007-04-27 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-mtasc.all/README: some info about the MTASC
	  testing framework.
	* testsuite/actionscript.all/Global.as: check that _global._global
	  is undefined.
	* testsuite/actionscript.all/Function.as: add another test for
	  nested functions and scope chain.

2007-04-27 Sandro Santilli <strk@keybit.net>

	* server/as_environment.{cpp,h}: changed the ScopeChain
	  typedef to be just a vector of as_objects.
	* server/swf_function.{cpp,h}: take a vector of as_objects
	  as ScopeChain, rather then with_entry vector...
	* server/vm/ActionExec.{cpp,h}: only expose the ScopeChain,
	  not the 'with' stack. When constructed for a function, push
	  the function's activation object to the ScopeChain.
	* server/vm/ASHandlers.cpp: update calls to ActionExec and
	  swf_function when it comes to setting the ScopeChain.
	* testsuite/actionscript.all/Function.as: the scope chain test kai
	  added now succeeds.
	* testsuite/swfdec/PASSING: function-scope-6.swf and function-scope-7.swf
	  now succeed.

2007-04-27 Sandro Santilli <strk@keybit.net>

	* libgeometry/snappingrange.h: add contains(SnappingRange2d) method;
	  fixed contains(Range2d) to take a const ref rather then a value.
	* testsuite/libgeometry/snappingrangetest.cpp: add tests for
	  contains(SnappingRange2d).
	* testsuite/misc-ming.all/DrawingApiTestRunner.cpp: add test for
	  renderer and invalidated bounds.

2007-04-27 Sandro Santilli <strk@keybit.net>

	* gui/gui.cpp: add a DEBUG_MOUSE_COORDINATES define, for making
	  writing test runners easier.
	* testsuite/swfdec/swfdec_gnash_tester: use the .trace.org files when
	  avaiable, as in that case it means that the .trace are just swfdec
	  results (Ben is cheating !)
	* testsuite/swfdec/PASSING: double.swf fails again.

2007-04-27 Sandro Santilli <strk@keybit.net>

	* server/as_value.{cpp,h}: add a static doubleToString(double) function
	  moved here from a static in Number.cpp, given its good quality.
	* server/asobj/Number.cpp: use as_value::doubleToString() for
	  returning text value. Drop the string representation cache, no
	  more needed.
	* testsuite/swfdec/PASSING: double.swf now succeeds

2007-04-27 Sandro Santilli <strk@keybit.net>

	* libbase/triangulate_impl.h: include config.h.
	* libbase/network.{cpp,h}: (writeNet): take a const string ref, not a
	  copy.
	* cygnal/: http.cpp, netstats.cpp, statistics.cpp, stream.cpp:
	  Hush compiler.

2007-04-27 Zou Lunkai <zoulunkai@gmail.com>

	* server/asobj/Key.{cpp,h}:
	  cleanups; don't invoke user defined onKeyPress(), it's just a 
	  normal function.
	* server/movie_root.cpp.h, server/sprite_instance.cpp:
		cleanups and add some comments. don't set m_has_key_event when there 
		is a user defined onKeyPress() function.
	* testsuite/misc-ming.all/key_event_testrunner.cpp:	  
		more tests.
	  
2007-04-26  Rob Savoye  <rob@ute.welcomehome.org>

	* Makefile.am: Add po to EXTRA_DIST.
	* configure.ac: Set a conditional for gettext. Build po/Makefile
	now.
	* libbase/Makefile.am: Build all libraries with a release number,
	and add --export-dynamic and -no-undefined. Add gettext.h.
	* backend/Makefile.am: Build all libraries with a release number,
	and add --export-dynamic and -no-undefined.
	* server/Makefile.am: Build all libraries with a release number,
	and add --export-dynamic and -no-undefined.
	* libgeometry/Makefile.am: Build all libraries with a release
	number, and add --export-dynamic and -no-undefined.
	* server/vm/Makefile.am: Build all libraries with a release
	number, and add --export-dynamic and -no-undefined.
	* server/parser/Makefile.am: Build all libraries with a release
	number, and add --export-dynamic and -no-undefined.
	* server/asobjs/Makefile.am: Build all libraries with a release
	number, and add --export-dynamic and -no-undefined.
	* extensions/dejagnu/dejagnu.cpp: Use instrusive pointers instead
	of hard pointers for handlers.
	* extensions/fileio/fileio.cpp: Use instrusive pointers instead
	of hard pointers for handlers.
	* extensions/mysql/mysql_db.cpp: Use instrusive pointers instead
	of hard pointers for handlers.
	* extensions/gtk2/gtkext.cpp: Use instrusive pointers instead
	of hard pointers for handlers.
	
2007-04-26 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/Function.as: add a test
	  showing an incompatibility of flash with ECMA262 when
	  it comes to the 'arguments' object in functions activation
	  object.

2007-04-26 Sandro Santilli <strk@keybit.net>

	* server/as_value.cpp (equals): compare m_object_value when both 
	  operatns are either functions or objects.
	* server/as_environment.{cpp,h} (get_variable, get_variable_raw,
	  findLocal): accept an additional argument to return the target
	  object the variable was found in.
	* server/vm/ActionExec.{cpp,h}: provide an additional getVariable
	  method accepting an as_object pointer to return the target object
	  a variable was found in.
	* server/vm/ASHandlers.cpp (ActionCallFunction): set the 'this'
	  pointer to the object found to contain the function.
	* testsuite/actionscript.all/Function.as: more successes.

2007-04-26 Sandro Santilli <strk@keybit.net>

	* server/as_environment.cpp (get_variable_raw): elements of 
	  the 'with' stack take precedence over locals.
	  See test in Function.as.
	* testsuite/actionscript.all/Function.as: add test for 'with'
	  stack taking precedence over locals when getting variables.

2007-04-26 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/Function.as: test for 'this' in
	  local function.
	* server/as_environment.{cpp,h}: refactor local variables
	  so they are stored into a proper object. Will help introducing
	  a VariableRef class that associates a Property to an as_object.

2007-04-26 Sandro Santilli <strk@keybit.net>

	* server/as_environment.h, server/movie_root.h,
	  server/sprite_instance.h, server/vm/action.cpp:
	  Remove some unused code, remove Id tags from headers.

2007-04-26 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/key_event_testrunner.cpp: no more
	  failures expected (thanks kai).
	* server/as_value.cpp (to_primitive): fix missing return
	  from non-void function.

2007-04-26 Zou Lunkai <zoulunkai@gmail.com>

	* server/asobj/Key.h
	  change "Event_id.h" to "event_id.h"
	* server/event_id.h
	  forgot to commit it in last commit
	
2007-04-26 Zou Lunkai <zoulunkai@gmail.com>

	* server/vm/action.cpp:
	  add is_key_event() method
	* server/asobj/Key.{h, cpp}:
	  change notify_listeners() to public; set_key_down() and set_key_up()
	  don't trigger event handler now.
	* server/button_character_instance.cpp:
	* server/edit_text_character.cpp:
	  replace *_keypress_listener() to *_key_listener()
	* server/character.{h, cpp},server/movie_root.{h, cpp}
	  trigger onClipKeyUp and onClipKeyDown event handlers
	* server/sprite_instance.{h, cpp}
	  bypass user defined key events in on_event(), let the global key object 
	  take over user defined key events.	
	* testsuite/misc-ming.all/key_event_testrunner.cpp
	  enable all checks

2007-04-26 Sandro Santilli <strk@keybit.net>

	* server/as_value.{cpp,h}: to_primitive() made private, and had
	  calling any user-defined valueOf for objects; (equals): only
	  return false when to_primitive() returns the same type we were 
	  already.
	* testsuite/actionscript.all/Function.as: two more successes.

2007-04-26 Sandro Santilli <strk@keybit.net>

	* server/as_value.cpp (equals): don't abort on object==movieclip !
	* testsuite/actionscript.all/Function.as: add more tests 'this'
	  reference in 'with' and 'function' scope (see bug #19704).

2007-04-26 Sandro Santilli <strk@keybit.net>

	* server/array.h, server/as_environment.cpp, server/as_function.h,
	  server/as_object.cpp, server/as_object.h, server/character.cpp,
	  server/character.h, server/edit_text_character.cpp,
	  server/edit_text_character.h, server/asobj/Boolean.cpp,
	  server/asobj/Color.cpp, server/asobj/ContextMenu.cpp,
	  server/asobj/CustomActions.cpp, server/asobj/Error.cpp,
	  server/asobj/LoadVars.cpp, server/asobj/Microphone.cpp,
	  server/asobj/Mouse.cpp, server/asobj/Number.cpp,
	  server/asobj/Selection.cpp, server/asobj/SharedObject.cpp,
	  server/asobj/Stage.h, server/asobj/TextSnapshot.cpp,
	  server/asobj/Video.cpp, server/asobj/gen-asclass.pl,
	  server/asobj/gen-asclass.sh, server/asobj/string.cpp,
	  testsuite/server/GetterSetterTest.cpp:
	  Changed get_text_value interface to return by std::string
	  value. Closes bug #19695.
	
2007-04-25  John Gilmore  <gnu@toad.com>

	* README, README_CVS:  Improve configuration instructions.
	  More work is needed to make it match the code.
	* po/.cvsignore:  Ignore all generated .gmo files.

2007-04-25 Sandro Santilli <strk@keybit.net>

	* README_CVS: some info for CVS users.
	* doc/C/asspec/date.xml: fixed typos preventing the asspec
	  from building.
	* doc/C/asspec/movieclip.xml: add docs and conformancy for
	  a few methods.

2007-04-25 Martin Guy <martinwguy@yahoo.it>

	* ChangeLog,server/debugger.{cpp,h},server/vm/ActionExec.cpp:
	  spello dissasemble -> disassemble
	* macros/lib-ld.m4(removed),macros/lib-link.m4:
	  remove repeated test for GNU ld (libtool does this).
	  Closes bug #19623
	* libamf/amf.cpp,libbase/tu_swap.h,server/parser/action_buffer.cpp,
	  server/swf/tag_loaders.cpp:
	  Replace compile-time endianness checking with runtime because
	  it costs almost nothing and reduces maintenance forever.
	  As a side-effect, also now handles architectures with
	  middle-endian IEEE754 doubles and detects non-IEEE arches.
	  Only the Mozilla devkit stuff now detects endianness
	  using its own set of built-in rules.

2007-04-24 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (sprite_hit_test): implement
	  hitTest() - not all call types tested.

2007-04-24 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp: globalToLocal and localToGlobal
	  implemented.
	* testsuite/actionscript.all/MovieClip.as: test localToGlobal
	  and globalToLocal.

2007-04-24 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp: stubbed localToGlobal and setMask
	* testsuite/actionscript.all/MovieClip.as: test availability of
	  localToGlobal and setMask.
	* testsuite/misc-ming.all/: Makefile.am, DrawingApiTest.as,
	  DrawingApiTestRunner.cpp: Prepared a test for invalidated
	  bounds checking. Gnash clearly fails, but no actual automated
	  tests added to the test runner yet.

2007-04-24 Sandro Santilli <strk@keybit.net>

	* server/vm/ActionExec.{cpp,h}: add delObjectMember() method.
	* server/vm/ASHandlers.cpp (ActionDelete): hopefully fixed -
	  at least as far as we can tell...
	* testsuite/actionscript.all/delete.as: more tests for ActionDelete.

2007-04-24  Rob Savoye  <rob@ute.welcomehome.org>

	* configure.ac: Remove --enable-extension. Add --with-extensions=
	that takes a comma delimited list of extension so you can seclect
	with ones you want to build.
	* Makefile.am: Always add the extensions directory.
	* extensions/Makefile.am: Use new conditionals to select builds
	directories.
	* cygnal/cygnal.cpp: Include posix_time.hpp.
	* extensions/fileio/fileio.cpp: Use intrusive pointers instead of
	explicit pointers.

2007-04-24 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* libgeometry/Range2d.h: added expandToCircle()
	* server/rect.h: added expand_to_circle()
	* server/parser/shape_character_def.cpp: corrected compute_bound()
	  to respect outline widths
	* testsuite/libgeometry/Range2dTest.cpp: added test for 
	  expandToCircle()
	    	
2007-04-24 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: DrawingApiTest.as,
	  DrawingApiTestRunner.cpp: Add a circle drawing and
	  test for collision detection of curved fills.

2007-04-24 Sandro Santilli <strk@keybit.net>

	* server/shape.{cpp,h} (point_test): only check for the
	  "interior" of the shape, forget its boundaries.
	* testsuite/misc-ming.all/DrawingApiTestRunner.cpp: one
	  more success.

2007-04-24 Sandro Santilli <strk@keybit.net>

	* server/shape.{cpp,h}: const-corrected point_test and
	  wihinSquareDistance();
	* server/sprite_instance.cpp (sprite_lineStyle): alpha value is given
	  in percent, always pass the env to number converters.
	* testsuite/misc-ming.all/DrawingApiTest.as: add test checking that
	  valueOf is invoked on arguments.
	* testsuite/misc-ming.all/DrawingApiTestRunner.cpp: more successes.

2007-04-24 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (on_event): call user-defined function
	  even if clip-events have been found.
	* testsuite/misc-ming.all/action_execution_order_extend_test.c:
	  one more success.
	* testsuite/swfdec/PASSING: event-order.swf now succeeds.
	* testsuite/swfdec/gen_run_swfdec_testsuite.sh: match full lines
	  in the PASSING file, to avoid partial mathes.
	* server/shape.cpp: substitute hash_wrapper with std::map,
	  cleanups.

2007-04-24 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/Makefile.am
	  activate testcases committed yestoday
	* testsuite/misc-ming.all/key_event_test.c
	  fix a typo
	* server/swf/PlaceObject2Tag.{h,cpp}
		minor clean up, keep the "all_event_flags" for future use.
	  
2007-04-23 Sandro Santilli <strk@keybit.net>

	* server/DynamicShape.{h,cpp} (lineStyle): add a line style even
	  if it is for specifying a thickness of 0 (hairline);
	  add a resetLineStyle() function for dropping any style.
	* server/sprite_instance.{cpp,h}: add resetLineStyle() for
	  drawing api.
	* server/parser/shape_character_def.cpp (point_test_local):
	  Use a tolerance of a single twip distance when detecting
	  collision of hairlined strokes.
	* testsuite/misc-ming.all/DrawingApiTest.as: add more comments, and
	  an hairlined line.
	* testsuite/misc-ming.all/DrawingApiTestRunner.cpp: more tests.

2007-04-23 Sandro Santilli <strk@keybit.net>

	* server/shape.{cpp,h}: add path::withinSquareDistance.
	* server/types.cpp (point::distance): return 0 for 0 squaredDistance
	  (not 1).
	* server/parser/shape_character_def.cpp (point_test_local):
	  test for point falling in the shape stroke, taking thickness
	  in consideration.
	* testsuite/misc-ming.all/DrawingApiTestRunner.cpp: more
	  tests.

2007-04-23 Sandro Santilli <strk@keybit.net>

	* server/shape.{cpp,h}: add primitive distance functions
	  for point-segment
	* testsuite/server/: Makefile.am, EdgeTest.cpp: add tests 
	  for point-segment distance.

2007-04-23 Sandro Santilli <strk@keybit.net>

	* server/: gnash.h, types.cpp: add point::distance() and
	  squaredDistance()
	* testsuite/server/: Makefile.am, PointTest.cpp: point tests.

2007-04-23 Sandro Santilli <strk@keybit.net>

	* server/cxform.{cpp,h}: add output operator and toString method.
	* server/DynamicShape.cpp (moveTo): do not reset current
	  fill style on move. Fixes some of the tests in DrawingApiTest.swf
	  and masks_test.swf.
	* testsuite/misc-ming.all/: DrawingApiTestRunner.cpp,
	  masks_testrunner.cpp: some more successes.

2007-04-23 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: DrawingApiTest.as,
	  DrawingApiTestRunner.cpp: add rendering tests.
	  Add a drawing in which move() is called after beginFill()
	  to confirm the fill is not reset after move().

2007-04-23 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, masks_test.c,
	  masks_testrunner.cpp: Add a MovieTester based test runner
	  for the masks_test movie. Shows a bug in either the renderer
	  or in the core preventing rendering of dynamic clips.
	* libgeometry/snappingrange.h: add unconditional visitor; add
	  cast operator; add contains(Range2d); add scale(factor).
	* testsuite/MovieTester.{cpp,h}: add a getInvalidatedRanges function;
	  drop getInvalidatedBounds one.
	* testsuite/libgeometry/snappingrangetest.cpp: test contains(Range)
	  and cast to int.
	* testsuite/misc-ming.all/simple_loop_testrunner.cpp: update
	  to use the new getInvalidatedRanges.

2007-04-23 Sandro Santilli <strk@keybit.net>

	* libgeometry/snappingrange.h: define the SnappingRanges2d<> in
	  the gnash::geometry namespace. Keep InvalidatedBounds in the
	  gnash namespace, for simplicity.
	* testsuite/misc-ming.all/simple_loop_testrunner.cpp: 
	  Use contains, not intersects, when testing invalidated bounds.

2007-04-23 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/event_handler_scope_test.c
	  testcase for scope in event handlers
	* testsuite/misc-ming.all/key_event_test.c, key_event_testrunner.cpp
	  testcase for key events
	  
2007-04-21 Sandro Santilli <strk@keybit.net>

	* server/: movie_root.{cpp,h}, sprite_instance.{cpp,h},
	  asobj/LoadVars.cpp: nuke ptr_list use so that boost 1.32
	  (version in Debian stable) is still usable.

2007-04-21  John Gilmore  <gnu@toad.com>

	* plugin/plugin.cpp:  In the child process, before executing
	  gnash, close all the file descriptors we inherited from the
	  browser (except stdout and stderr).

2007-04-20 Sandro Santilli <strk@keybit.net>

	* testsuite/MovieTester.{cpp,h}: reworked the
	  pixel checking interface to not force moving
	  the pointer (as moving the pointer might trigger
	  movie events, as was happening with the ButtonEvent
	  test).
	* testsuite/misc-ming.all/ButtonEventsTest-Runner.cpp:
	  All tests pass now.
	* testsuite/misc-ming.all/attachMovieTestRunner.cpp:
	  Updated to work with the correct interface.

2007-04-20 Sandro Santilli <strk@keybit.net>

	* testsuite/MovieTester.{cpp,h} (advance): advance
	  first, *then* render. Cache invalidated bound to
	  avoid loosing them.
	* testsuite/misc-ming.all/attachMovieTestRunner.cpp:
	  Add renderer tests.
	* testsuite/misc-ming.all/ButtonEventsTest-Runner.cpp:
	  Take the covering clip in consideration while testing
	  the renderer - there are a few xfailed that I'd like
	  to fix.

2007-04-20 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* backend/render_handler.h (getAveragePixel):
	  fix computation of max x/y values.
	* server/character.h: character are not masks by default
	* server/character.h, server/sprite_instance.cpp: when placing
	  new characters, disable clip_depth (zero is a valid depth)  	

2007-04-20 Sandro Santilli <strk@keybit.net>

	* testsuite/FuzzyPixel.h: const-correctness
	* testsuite/MovieTester.{cpp,h}: prepared for working
	  with all render handlers, implemented support for
	  a single one (AGG only for now); provided 
	  check_pixel and xcheck_pixel macros.
	* testsuite/misc-ming.all/ButtonEventsTest-Runner.cpp:
	  Test pixel checker (doesn't work).

2007-04-20 Sandro Santilli <strk@keybit.net>

	* server/types.{cpp,h}: add toShortString, for neater output.
	* libgeometry/snappingrange.h: add output operator.
	* server/debugger.cpp, server/parser/action_buffer.cpp,
	  server/vm/ActionExec.cpp: don't force creation of the
	  SWFHandlers singleton too early, this hopefully means
	  at time of initialization the VM version will be known.
	* backend/render_handler.h: remove unused parameter warnings.
	  [  I'm afraid this will confuse doxygen :(  ]

2007-04-20  John Gilmore  <gnu@toad.com>

	More internationalization.
	* po/POTFILES.in:  Add all files with gettext-able messages.
	* po/gnash.pot:  Update to include current gettext-able messages.
	* po/{es,fr}.po:  First few languages that have a few translations.
	* po/LINGUAS:  Add es and fr (with only a few translations in each).
	* README:  Gettext program is now a required prerequisite for clean
	  builds of gnash.  (We use the msgfmt program for compiling
	  translations.)

2007-04-20 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* backend/render_handler.h: Prototype for initTestBuffer()
	* backend/render_handler_agg.{cpp,h}: implement initTestBuffer() 
		
2007-04-20 Sandro Santilli <strk@keybit.net>

	* testsuite/: Makefile.am, FuzzyPixel.{cpp,h}, 
	  MovieTester.{cpp,h}: framework for renderers
	  testing, needs changes in render_handler to complete.
	  See task #6785.

2007-04-20 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/masks_test.c: draft masks test.
	* doc/C/asspec/movieclip.xml:
	  Dumped a bit of info about _name. Hopefully Ann will give it some
	  formatting.
	* testsuite/misc-ming.all/: Makefile.am, ButtonEventsTest-Runner.cpp:
	  Allow execution of the test runner from a foreign dir.

2007-04-20 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/actionscript.all/MovieClip.as
	  change undefined to a null string.
	  change check to xcheck, add warnings
	  
2007-04-19 Sandro Santilli <strk@keybit.net>

	* server/as_value.cpp (equals): comment out debugging line.
	* testsuite/actionscript.all/MovieClip.as: check that
	  changing a _parent._name changes own _target.
	  WARNING: our soft references are bogus !!

2007-04-19 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* server/character.{h,cpp}, server/sprite_instance.{h,cpp}: 
	  moved getTarget(), getTargetPath(),
	  get_text_value() to character class so that button instances
	  can deal with "targets" too.
	* server/character.{h,cpp}: implemented "_target" getter-setter	  
	* server/button_character_instance.cpp: added _target getter-setter 
	
2007-04-19 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/Number.as:
	  Re-enabled a big block of tests accidentally left
	  cut out. Expect less failures also ! :)

2007-04-19 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* testsuite/misc-ming.all/matrix_test.c: use Math.round() to
	  really be tolerant	

2007-04-19 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/matrix_test.c: tolerate an 
	  error of 1/100 when testing _rotation.

2007-04-19 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* testsuite/libamf.all/test_*.cpp: added dummy main() function
	  for the case when HAVE_DEJAGNU_H is not set	

2007-04-19 Bastiaan Jacques <bastiaan@bjacques.org>

	* configure.ac: Some platforms apparently define SIZET_FMT as
	signed long; add a test for it. Also, use gnashpkgtool.m4 to
	look for dejagnu.h as it is not guaranteed to be in the default
	compiler search path, especially on non-GNU platforms.

2007-04-19 Martin Guy <martinwguy@yahoo.it>

	* testsuite/actionscript.all/Date.as: Change case-[in]dependent
	  method existence detection strategy to see if it fixes v5 testrun.
	* testsuite/libamf.all/test_{object,string,variable}.cpp,
	  testsuite/server/DisplayListTest.cpp,
	  testsuite/misc-ming.all/{PlaceObject2Test,root_stop_test}.c,
	  testsuite/misc-ming.all/action_execution_order_test6.c:
	  Drop/comment unused variables.
	* server/as_value.cpp: Remove vestiges of rejected fix to
	  Number(<function>) (reported as a bug instead)
	* testsuite/actionscript.all/Date.as: Remove tests that fail, including
	  those due the above bug.

2007-04-19 Sandro Santilli <strk@keybit.net>

	* server/asobj/string.cpp: add valueOf own property to String
	  prototype.
	* server/as_value.{h,cpp}: add equalsSameType() function;
	  fix bugs in to_number for function values (version-sensitive it
	  seems); modify equality and inequality operators to follow
	  strict equality semantic.
	* testsuite/movies.all/gravity_embed-TestRunner.cpp: be aware when
	  comparing as_value types, comparisons are strict now!
	* testsuite/swfdec/PASSING: divide-7.swf and object-math-7.swf now
	  succeed.
	* testsuite/actionscript.all/Global.as: small test for isNaN
	  availability
	* testsuite/actionscript.all/Number.as: tests for
	  convertion-to-number.
	* testsuite/actionscript.all/String.as: test valueOf being a property
	  of String.prototype.

2007-04-19 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/duplicate_movie_clip_test.c
	  more tests.
	* libbase/tu_types.h
	  drop SDL integer types 
	* server/cxform.h
	  replace inttypes.h with tu_types.h, hopefully more portable
	* server/vm/action.cpp
	  type definition, get rid of compiler warning
	  
2007-04-18 Sandro Santilli <strk@keybit.net>

	* server/BitmapMovieInstance.cpp: make sure
	  the bitmap character is not considered a mask (sic).
	* testsuite/MovieTester.{cpp,h}:
	  Added interfaces for testing pixel values.
	  Next step would be actually initializing
	  a renderer during testing (if requested, maybe?)

2007-04-18 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* backend/render_handler.h: renamed get_pixel() to getPixel() and
	  changed from void to bool return value
	* backend/render_handler.h, backend/render_handler_agg.cpp: 
	  implemented getAveragePixel()
	
2007-04-18 Sandro Santilli <strk@keybit.net>

	* testsuite/MovieTester.h: add click() method.
	* server/BitmapMovieInstance.cpp: place the
	  bitmap character in the "static depth" zone
	  to forbid removal (might still be not enough).
	* testsuite/misc-ming.all/loadMovieTest.c: have
	  the clear button remove the clips, not just clear them
	* testsuite/misc-ming.all/loadMovieTestRunner.cpp:
	  check use of the 'scribble' and 'clear' buttons.

2007-04-18 Martin Guy <martinwguy@yahoo.it>

	* server/asobj/NetStreamFfmpeg.cpp: Fix compile-breaking typo.
	* server/swf/tag_loaders.cpp: Reformat bizarre indentation caused
	  by someone editing with hard tabs set to 4.
	* server/asobj/Date.cpp: Fix signed/unsigned compiler warning.
	* libbase/container.h, doc/C/actionscript/as_value.xml:
	  Expunge the last references to tu_string.
	* libbase/tu_file.h: Purge endian dependence, add \brief to methods.
	* backend/sound_handler_sdl.cpp: Remove commented-out stuff
	* server/swf/tag_loaders.cpp: Remove commented-out stuff

2007-04-18 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* server/character.h, server/dlist.cpp, server/swf/PlaceObject2Tag.cpp:
	  make masks work again, introduce isMask()   
		
2007-04-18 Martin Guy <martinwguy@yahoo.it>

	* configure.ac: Introduce HAVE_LONG_TIMEZONE if extern long timezone
	  exists, and HAVE_TM_GMTOFF if struct tm has member tm_gmtoff.
	* doc/C/asspec/date.xml: first draft
	* server/asobj/Date.cpp: Complete its implementation
	* server/asobj/Global.cpp: Use definitions of NAN and INFINITY from	
	  as_value.h
	* server/as_value.h: add definition for INFINITY, as for NAN
	* server/as_value.cpp: Reject accidental "Infinity" and "-Infinity"
	  string-to-number conversions (should give NaN);
	  Use NAN from as_value.h;
	  Conversion of an AS function to a number gives NaN, not 0.
	* testsuite/actionscript.all/Date.as: Add extensive constructor tests

2007-04-18 Sandro Santilli <strk@keybit.net>

	* server/matrix.{cpp,h}: add transform_by_inverse(point&).
	* server/character.h: add pointInBounds, pointInShape() and
	  pointInVisibleShape() new methods; document
	  get_topmost_mouse_entity.
	* server/edit_text_character.{h,cpp}: implement pointInShape.
	* server/generic_character.{h,cpp}: implement pointInShape.
	* server/sprite_instance.{h,cpp}: implement pointInShape
	  and pointInVisibleShape; fix get_topmost_mouse_entity
	  implementation.
	* server/parser/character_def.h: document point_test_local.
	* testsuite/misc-ming.all/duplicate_movie_clip_test.c: don't 
	  expect a failure.
	* testsuite/misc-ming.all/loadMovieTestRunner.cpp: add two
	  small tests checking that the new two small buttons
	  are clickable. Needs more tests actually clicking those
	  buttons.

2007-04-18  John Gilmore  <gnu@toad.com>

	* Internationalization, phase 2.
	
	* These modules have had their printed messages passed through
	  _(...).  Those messages have also been cleaned up, thusly:
	    *  Stray \n's removed
	    *  Exclamation points and periods removed at ends of messages
	    *  Typos corrected, and English language wording adjusted.
	    *  Misplaced UPPER CASE shouting removed.
	    *  Many complaints about unknown types, values, etc, now include
	       the offending value, for ease of remote diagnosis.
	    *  C++-style << printouts converted to log_xxx calls.
	    *  Direct accesses to dbglogfile converted to log_xxx calls.
	    *  printf converted to log_xxx calls.
	    *  Function name debug prints converted to GNASH_REPORT_FUNCTION.
	  These changes should also make the messages easier to	translate.
	* Commented-out messages were also cleaned up as above.
	* Many modules have also had log_warning calls changed to log_msg,
	  log_error, log_aserror, log_swferror, or log_unimp, according to
	  the documentation checked in earlier by strk and gnu.
	  IF_VERBOSE_xxx macros were inserted around some calls that
	  lacked them.
	* Header comments (at the top of the file) added or adjusted, to
	  describe each file in its initial line, and to correct whitespace
	  in the copyright notices.  Eliminate trailing spaces and tabs.
	
	* The list of files affected by the above changes:
	  backend/sound_handler_sdl.cpp
	  extensions/mysql/mysql_db.cpp
	  gui/Player.cpp
	  gui/gnash.cpp
	  gui/gui.cpp
	  plugin/klash/klash.cpp
	  plugin/win32/plugin.cpp
	  server/PropertyList.cpp
	  server/StreamProvider.cpp
	  server/array.cpp
	  server/as_environment.cpp
	  server/as_function.cpp
	  server/as_object.cpp
	  server/as_value.cpp
	  server/button_character_instance.cpp
	  server/character.cpp
	  server/dlist.cpp
	  server/dlist.h
	  server/edit_text_character.cpp
	  server/fill_style.cpp
	  server/font.cpp
	  server/generic_character.cpp
	  server/impl.cpp
	  server/sprite_instance.cpp
	  server/text.cpp
	  server/textformat.cpp
	  server/video_stream_instance.cpp
	  server/asobj/Camera.cpp
	  server/asobj/Color.cpp
	  server/asobj/ContextMenu.cpp
	  server/asobj/CustomActions.cpp
	  server/asobj/Date.cpp
	  server/asobj/Error.cpp
	  server/asobj/Global.cpp
	  server/asobj/Key.cpp
	  server/asobj/LoadVars.cpp
	  server/asobj/LocalConnection.cpp
	  server/asobj/Microphone.cpp
	  server/asobj/Mouse.cpp
	  server/asobj/MovieClipLoader.cpp
	  server/asobj/NetConnection.cpp
	  server/asobj/NetStream.cpp
	  server/asobj/NetStreamFfmpeg.cpp
	  server/asobj/NetStreamGst.cpp
	  server/asobj/Number.cpp
	  server/asobj/Object.cpp
	  server/asobj/Selection.cpp
	  server/asobj/SharedObject.cpp
	  server/asobj/Sound.cpp
	  server/asobj/SoundFfmpeg.cpp
	  server/asobj/SoundGst.cpp
	  server/asobj/SoundMad.cpp
	  server/asobj/Stage.cpp	
	  server/asobj/System.cpp	
	  server/asobj/TextSnapshot.cpp	
	  server/asobj/Video.cpp	
	  server/asobj/gen-asclass.pl
	  server/asobj/gen-asclass.sh
	  server/asobj/string.cpp
	  server/asobj/xml.cpp
	  server/asobj/xmlnode.cpp
	  server/asobj/xmlsocket.cpp
	  server/parser/BitmapMovieDefinition.cpp
	  server/parser/action_buffer.cpp
	  server/parser/button_character_def.cpp
	  server/parser/edit_text_character_def.cpp
	  server/parser/morph2_character_def.cpp
	  server/parser/movie_def_impl.cpp
	  server/parser/shape_character_def.cpp
	  server/parser/sprite_definition.cpp
	  server/parser/sprite_definition.h
	  server/parser/text_character_def.cpp
	  server/swf/DefineFontAlignZonesTag.cpp	
	  server/swf/PlaceObject2Tag.cpp
	  server/swf/tag_loaders.cpp
	  server/vm/ASHandlers.cpp
	  server/vm/ActionExec.cpp
	  server/vm/action.cpp
          libbase/curl_adapter.cpp
	  libbase/extension.cpp
	  libbase/log.cpp
	  libbase/network.cpp
	
	* 2007 copyright notices were inserted in:
	  backend/sound_handler_sdl.cpp
	  extensions/mysql/mysql_db.cpp
	  gui/gnash.cpp
	  plugin/klash/klash.cpp
	  plugin/win32/plugin.cpp
	  server/generic_character.cpp
          libbase/curl_adapter.cpp
	
	* New 2006, 2007 Free Software Foundation copyrights applied (to
	  formerly public domain code):
	  server/font.cpp
	  server/text.cpp
	  server/parser/button_character_def.cpp
	  server/parser/edit_text_character_def.cpp
	  server/parser/morph2_character_def.cpp
	  server/parser/movie_def_impl.cpp
	  server/parser/shape_character_def.cpp
	 
	* backend/sound_handler_sdl.cpp: Move stray FORMAT_VORBIS comment.
	* gui/gui.cpp: Commented out "Resize request when no movie" error
	  that appears every time gnash is run.
	* plugins/klash/klash.cpp:  Translated pop-up menu items, about-box,
	  and updated copyright notice printed by --version and --help.
	* server/array.cpp (as_array_object::index_requested):  Avoid
	  c_str accessor when converting string to number.
	* server/dlist.{h,cpp}:  Change API of DisplayList::dump debug
	  function, so it can use log_xxx functions.
	* server/sprite_instance.cpp (sprite_attach_movie):  Comment out
	  log_msg about initializing properties.
        * server/asobj/gen-asclass.{pl,sh}:  Use log_unimpl in generated code.
	  Improve whitespace, and generate header line describing the file.
	* server/asobj/TextSnapshot.cpp:  Fix whitespace to test gen-asclass.
	* text_character_def.cpp:  Remove commented-out includes.
	* FLVParser.{cpp,h}:  Fix compiler warning (signed/unsigned).
	
	I'm sure that I've missed some messages that ought to get 
	translated (with _(...)).  Those will be fixed over time.
	All new messages should be created with _(...) so they can
	be translated.

2007-04-18 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/loadMovieTest.c: add
	  a couple of "buttons" to scribble on and clear
	  the loaded movies. Checks for this in the 
	  test runner should follow.
	* server/BitmapMovieInstance.h:
	  Override restart() to avoid cleaning up
	  the displaylist (since no frame tags will
	  recreate it).

2007-04-18 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/Makefile.am:
	  activate testcast path_format_test.c
	* testsuite/misc-ming.all/duplicate_movie_clip_test.c
	  new testcase for duplicateMovieClip().
	  
2007-04-17 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/loadMovieTest.c: stop prepending
	  'file://' to srcdir as it might be relative and file://
	  should not be used with relative uris.
	* testsuite/misc-ming.all/loadMovieTestRunner.cpp:
	  Don't cheat, run the test !

2004-04-17 Bastiaan Jacques <bastiaan@bjacques.org>

	* libbase/URL.cpp: Don't attempt to remove an item from the vector
	of strings if the vector is empty.
	* testsuite/libbase/URLTest.cpp: Add a test which shouldn't crash
	anymore.

2007-04-17 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* backend/render_handler_agg_style.h: Added DEBUG_LIMIT_COLOR_ALPHA 
	
2007-04-17 Sandro Santilli <strk@keybit.net>

	* gui/sdl.cpp (key_event): update call to notify_key_event
	  to provide no modifiers always (bogus, but at least compiles).
	* testsuite/actionscript.all/XML.as: add test
	  showing that removeNode doesn't recurse to
	  childrens.
	* server/asobj/xmlnode.{cpp,h}: fix removeNode
	  to not delete all childrens.

2007-04-17 Sandro Santilli <strk@keybit.net>

	* libbase/: tu_file.{cpp,h}, curl_adapter.cpp, zlib_adapter.cpp,
	  noseek_fd_adapter.cpp:
	  Add another callback for getting stream error. First pass at
	  documenting the tu_file interfaces (needs more work).
	  Updated implementations to provide the new error getter.
	* server/asobj/xml.cpp (XML::load): check stream status after
	  call to xmlReadIO. The libxml2 function seems immune to 
	  stream errors, but we can handle them and avoid parsing
	  anything if a stream error occurs (404 will be a stream error).

2007-04-17 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* backend/render_handler_agg: Replaced drawVideoFrame() to use AGG
	  functions, implemented nearest neighbor transformations, 
	  implemented masked video playback
	  
2007-04-17 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/get_frame_number_test.c:
	  more tests.
	* testsuite/misc-ming.all/path_format_test.c:
	  testcase to verify valid path format
	  
2007-04-16 Sandro Santilli <strk@keybit.net>

	* server/as_environment.cpp, server/as_value.cpp,
	server/as_value.h, server/debugger.cpp, server/debugger.h,
	server/edit_text_character.cpp, server/movie_root.h,
	server/sprite_instance.cpp, server/sprite_instance.h,
	server/timers.cpp, server/asobj/LoadVars.cpp,
	server/asobj/Object.cpp, server/asobj/Sound.cpp,
	server/asobj/Sound.h, server/asobj/Stage.cpp,
	server/asobj/string.cpp, server/asobj/xml.cpp,
	server/asobj/xmlnode.cpp, server/asobj/xmlsocket.cpp,
	server/vm/ASHandlers.cpp, testsuite/server/GetterSetterTest.cpp:
	 Drop as_value::to_std_string() - update all callers.
	 Deprecated sprite_instance::get_variable.
	 Cost-corrected debugger interfaces.

2007-04-16 Sandro Santilli <strk@keybit.net>

	* server/as_environment.{cpp,h}: add a parse_path method to
	  return an actual object when the given parameter is actually
	  a path.
	* server/vm/ASHandlers.cpp (ActionCallFunction): set 'this'
	  pointer to the object containing the function if the function
	  name is a path. Fixes bug #18698.
	* testsuite/actionscript.all/getvariable.as: success in
	  callFunction(path.to_function), a few more tests of that kind.

2007-04-16 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/getvariable.as: check 'this' pointer when
	  calling a function trough a path.
	* testsuite/server/Makefile.am: add libgnashamf.la to GNASH libs.
	* testsuite/generic-testrunner.sh, doc/C/internals.xml:
	  Add -f switch to specify the maximum number of frame advancements.
	* testsuite/misc-ming.all/Makefile.am: update
	  get_frame_number_testrunner to advance at most 20 times.
	* testsuite/misc-ming.all/get_frame_number_test.c: no more failures
	  expected.
	* server/sprite_instance.cpp (get_frame_number): check frame labels
	  also when convertion to number gives a non-integer value.
	* server/vm/ASHandlers.cpp (ActionGotoExpression): don't pretend
	  any path-looking string is necessarely a path, it can still be
	  a floating number or a frame label.

2007-04-16  John Gilmore  <gnu@toad.com>

	* libbase/log.h: Update documentation for log_* functions; rename
	  log_warning to log_unimpl (with temporary #define for a few days);
	  move gettext and _ definitions from gnash.h to log.h.
	* libbase/log.cpp:  Update log_* functions as above.
	* server/gnash.h:  Move gettext and _ to log.h.

2007-04-16 Sandro Santilli <strk@keybit.net>

	* libbase/log.h: draft documentation for the log_* functions.
	* testsuite/misc-ming.all/matrix_test.c: add test for skewX() matrix
	  (failures are just precision-related).
	* server/debugger.{cpp,h}: (matchWatchPoint) const-corrected
	* server/vm/ASHandlers.cpp: always pass an as_environment pointer
	  when converting as_value to a string, use to_string rather 
	  then to_std_string() when a reference is enough; (ActionDuplicateClip): 
	  properly cleanup the stack on error; (ActionGotoFrameExpression,
	  ActionCallFrame): properly handle unknown target.
	* testsuite/misc-ming.all/Makefile.am:
	  Activated get_frame_number and frame_label_test.

2007-04-16 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/frame_label_test.c:
	  a new testcase.
	* testsuite/misc-ming.all/get_frame_number_test.c:
	  more tests.
	* server/sprite_instance.cpp:
	  update call_frame_actions();
	* server/vm/ASHandlers.cpp:
	  properly process frame label in ActionCallFrame() and ActionGotoExpression().
	  
2007-04-15 Sandro Santilli <strk@keybit.net>

	* server/edit_text_character.cpp (display): move text glyphs
	  so to be inside bounds defined for the textfield character.
	  Fixes bug #17954. This is likely not the cleanest way to
	  do this, see comments.
	* server/matrix.{cpp,h}: provided setters for canonical 
	  parameters.
	* server/character.cpp: avoid direct access to matrix members.
	* server/sprite_instance.cpp: avoid direct acces to matrix members.
	* server/vm/ASHandlers.cpp: fix signedness compiler warnings.
	* testsuite/server/MatrixTest.cpp: add tests for scale concatenation.

2007-04-15 Bastiaan Jacques <bastiaan@bjacques.org>

	* libbase/container.{cpp,h}: Remove tu_string{,i}.
	* server/as_value.{cpp,h}: Replace tu_string with std::string.
	Remove wide string code that was both unused and inherently
	broken.
	* all over the place: Update to match changes in as_value.h.
	Also, eliminate tu_string usage entirely.

2007-04-15 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/MovieClip.as,
	  testsuite/misc-ming.all/matrix_test.c,
	  testsuite/server/MatrixTest.cpp: more successes
	  after Eric patch ! A few more tests added in
	  matrix_test.c too, and more will be needed.

2007-04-15 Eric Hughes <eh@narthex.us>

	* server/matrix.cpp (get_x_scale, get_y_scale): fixed implementations
	  to match the interpretation of matrix used in set_scale_rotation.

2007-04-14 Sandro Santilli <strk@keybit.net>

	* server/character.cpp (height_getset, width_getset): round
	  width and heights to nearest integer twip.
	* testsuite/swfdec/PASSING: height4.swf succeeds.
	* testsuite/misc-ming.all: Makefile.am, matrix_test.c: new test
	  for statically-defined matrix interpretation (just started, needs
	  many more tests).
	  
2007-04-14 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (sprite_getBounds): round bounds
	  to twips.
	* testsuite/actionscript.all/MovieClip.as: more successes.
	* testsuite/actionscript.all/check.as: Revert bastiaan patch,
	  changing semantic of most tests.

2007-04-14 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/asobj/{Loadvars,NetStream,Sound,xmlnode}.cpp: Use
	init_readonly_property for read-only properties.
	* server/parser/movie_def_impl.{cpp,h}: Since we're not using
	pthreads, there is no need to have our thread function
	match a specfic pattern; use one that fits our design.
	* testsuite/actionscript.all/check.as: Don't prepend # where
	it is not needed to avoid choking gcc3's C preprocessor.
	* testsuite/libamf.all/{test_number,test_string}.cpp,
	testsuite/misc.ming.all/{intervalTestRunner,
	loadMovieTestRunner}: Add needed includes for OpenBSD.

2007-04-14 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (sprite_getBounds): round bounds
	  to twips.
	* server/matrix.{h,cpp}: fix conceptual bug in Range2d transform
	  function.
	* testsuite/misc-ming.all/displaylist_depths_test.c,
	  testsuite/actionscript.all/MovieClip.as: more successes.

2007-04-12 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/parser/movie_def_impl.{cpp,h}: Replace pthread usage
	by boost threads.
	* libbase/Makefile.am: No longer include Thread.{h,cpp} in the
	build, because this pthread based class is unused and
	deprecated.
	* server/URLAccessManager.cpp: Comment out unused parameter.
	* server/shape.cpp: Comment out dead code.
	* server/textformat.cpp: make text_format DSOEXPORT, because
	it is used in another DSO.
	* all over the place: Remove all inclusions of pthread.h,
	because we're no longer directly using pthreads.
	* server/gnash.h, gui: version two of Antti Ajanki's GUI
	patches, this time the whole thing.
	* libbase/container.h: Remove the last pthread.h include.

2007-04-12 Sandro Santilli <strk@keybit.net>

	* server/asobj/string.cpp (fromCharCode): revert bastiaan change
	  breaking existing tests.
	* server/character.{cpp,h}: add set_x_scale and set_y_scale
	  methods to reduce code messing with matrices. Changed
	  {x,y}scale_getset and {width,height}_getset to use 
	  these two new functions.
	* testsuite/server/MatrixTest.cpp: add a few tests for
	  set_scale_rotation. I'm not sure the tests are correct
	  thought, I'd like to hear from Martin about that.

2007-04-12 Sandro Santilli <strk@keybit.net>

	* server/: button_character_instance.{cpp,h},
	  character.{cpp,h}, edit_text_character.{cpp,h},
	  generic_character.h, sprite_instance.{cpp,h}:
	  get_width() and get_height() made non-virtual
	  methods using getBounds() internally.
	  Fixed _width, _height, _xscale, _yscale and _rotation
	  getter/setter to call valueOf when available.

2007-04-12 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (duplicateMovieClip): 
	  Duplicate also the drawable.
	* testsuite/misc-ming.all/displaylist_depths_test.c:
	  More successes.

2007-04-12 Sandro Santilli <strk@keybit.net>

	* server/matrix.{cpp,h}: add transform and transform_by_inverse
	  for Range2d<float> type.
	* server/character.h: add a getBounds() virutual method.
	* server/: generic_character.h, button_character_instance.{cpp,h},
	  edit_text_character.h, video_stream_instance.h:
	  Implement getBounds.
	* server/character.cpp: fix width_getset and height_getset
	  to use the new getBounds interface.
	* server/sprite_instance.{cpp,h}: implement getBounds;
	  implement MovieClip.getBounds.
	* testsuite/actionscript.all/MovieClip.as: more tests for
	  getBounds, more successes.
	* testsuite/swfdec/PASSING: height2.swf and height3.swf tests
	  now succeed.

2007-04-12 Mathew Cucuzella <kookjr@gmail.com>

	* doc/C/internals.xml plugin.xml: Fix typos in documentation
          (patch #5820).

2007-04-11 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/asobj/string.cpp: from_char_code: create a wide string
	in case the user tries to create one.
	* gui: Reverted Antti's patches, because they appear to be
	lacking some changes in the gnash::key namespace. Fixes build.

2007-04-11 Markus Gothe <nietzsche@lysator.liu.se>

	* server/sprite_instance.cpp: uint32 -> uint32_t.

2007-04-11 Stephan Peijnik <sp@gnu.org>

	* gui/gtk.cpp: Changed Copyright years from 2005-2007 -> 2005, 2006,
	  2007. Fixed 'acces'-typo -> 'access'.

2007-04-11 Antti Ajanki <antti.ajanki@iki.fi>
	
	*  gui/gtk.cpp gui/gtksup.h gui/gui.cpp gui/gui.h
	*  gui/kde.cpp gui/kde_glue.h gui/kdesup.h:
	moves the handling of GUI shortcuts (Crtl+R for restarting the 
	movie, Ctrl+Q for quiting, etc.) form GtkGui to base class Gui. 
	This way all GUIs can inherit the same code instead of having 
	to duplicate it.
	adds keyboard handling for the KdeGui using this new interface.
	Currently KdeGui has no support for keyboard input. 

	The destructor of KdeGlue deletes _drawing_area object even though 
	it is not owned by KdeGlue. The _drawing_area is actually the 
	_qwidget object from KdeGui and is (correctly) deleted at the 
	destructor of 
	KdeGui. This double-free error causes a segfault when closing 
	Gnash. 

2007-04-11 Sandro Santilli <strk@keybit.net>

	* server/parser/shape_character_def.cpp (compute_bound):
	  skip anchor point of empty paths; include both control
	  and anchor point of any edge.
	* server/dlist.h: add a visitAll() method for unconditional
	  full scan.
	* server/sprite_instance.cpp: optimize WidthFinder, HeightFinder,
	  ScriptObjectFinder and CharacterExtractor to return void
	  (can be used by visitAll); (get_width, get_height): include
	  scan of DrawingAPI canvas.
	* testsuite/actionscript.all/MovieClip.as, 
	  testsuite/misc-ming.all/displaylist_depths_test.c:
	  few more successes.

2007-04-11 Ann Barcomb <kudra@domaintje.com>

	* devtools/lib/Gnash/Distribution.pm: made it more
	  difficult to mistakenly use the wrong root distribution
	  directory.

2007-04-11 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/MovieClip.as: add some tests
	  for _width,_height and getBounds (all failing!).

2007-04-11 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* server/cxform.h: include required inttypes.h
		
2007-04-11 Sandro Santilli <strk@keybit.net>

	* server/: Makefile.am, gnash.h, types.cpp, cxform.{cpp,h},
	  swf/PlaceObject2Tag.{cpp,h}, swf/tag_loaders.cpp:
	  Extract PlaceObject2Tag from tag_loaders
	  and cxform from gnash.h and types.cpp.
	* server/character.{cpp,h}: add getUserDefinedEventHandler
	  function, change static event handlers function to allow
	  for multiple handlers for the same event.
	* server/vm/ExecutableCode.h: add EventCode class.
	* server/swf_event.h: drop the 'function' member, provide better
	  members protection.
	* testsuite/actionscript.all/MovieClip.as: add tests for
	  user defined events not being proper properties.
	* testsuite/actionscript.all/dejagnu_so_init.as: delete the
	  user-defined onEnterFrame when finished with it.
	* server/execute_tag.h: add missing include.
	* server/event_id.h: add setKeyCode method, for better protection.
	* server/button_character_instance.cpp (on_button_event): look for
	  user-defined event handlers.
	* server/dlist.{cpp,h}, server/impl.h,
	  server/parser/shape_character_def.h,
	  server/parser/button_character_def.h:
	  Update after addition of new files
	* testsuite/misc-ming.all/action_execution_order_extend_test.c:
	  Two unexpected successes, one unexpected failures (due to scrabling
	  of event handling).
	* server/movie_root.{cpp,h}: add pushAction(ExecutableCode).
	* server/sprite_instance.{cpp,h}: stop using gettersetter for event
	  handlers
	* testsuite/misc-ming.all/displaylist_depths_test.c: test that
	  event handlers need to be duplicated too.

2007-04-11 Ann Barcomb <kudra@domaintje.com>

	* testsuite/actionscript.all/gen-index-wiki.sh doc/C/sources.xml:
	  Changed all references of 'gnash.lulu.com' to 'www.gnashdev.org'.

2007-04-11 Bastiaan Jacques <bastiaan@bjacques.org>

	* libbase/FLVParser.cpp: Append 8 "zero" bytes to the end of the frame
	buffer to prevent decoders from going past the end of our frame buffer.
	This adds NULL-termination, which is also expected by FFMPEG.
	* server/asobj/NetStreamFfmpeg.cpp: Initialize certain members to safe
	defaults so they will not be read in their uninitialised states.
	* backend/render_handler_agg.cpp: Stop relying on bounds passed from
	video definition for image buffer size (since we don't yet do proper
	scaling, that is a bad idea); fixes bug #19511. Also, cut off the
	video image if it extends beyond the width of our buffer.
	* gui/fltk.cpp: Fix compilation by adding statics for GUI methods
	that became nonstatic. Also fix some warnings.
	* all over the place: Replace SDL integer type names by standard ones.
	Thanks to Ann for writing a Perl script to do search-and-replace.

2007-04-11 Sandro Santilli <strk@keybit.net>

	* server/character.h: add protected set_event_handlers(), turn
	  get_event_handelrs into a protected member.
	* server/sprite_instance.cpp (duplicateMovieClip): simplified copying
	  of event handlers.

2007-04-11 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/ming_utils.h: define newSWFAction
	  to compileSWFActionCode when using older Ming versions.
	  Now we can use them interxchangeably (the newer newSWFAction
	  has to be preferred though).
	* testsuite/actionscript.all/MovieClip.as: add tests
	  showing that user-defined event handlers must be handled
	  differently then placeobject-defined ones. At least
	  for the sake of duplicating movieclips; add
	  MovieClip.duplicateMovieClip test.
	* testsuite/misc-ming.all/displaylist_depths_test.c:
	  Add tests for duplicateMovieClip, _width and cloning
	  static event handlers.

2007-04-11 Zou Lunkai <zoulunkai@gmail.com>

	* server/as_environment.cpp:
	  don't trim of the last "/" in parse_path(), fix parsing path in format "/:x".
	* testsuite/actionscript.all/getvariable.as:
	  add tests
	  
2007-04-10 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.{cpp,h}: add duplicateMovieClip method
	  for use by MovieClip.duplicateMovieClip and ActionDuplicateClip.
	* server/vm/ASHandlers.cpp (ActionDuplicateClip): use the new
	  sprite_instance::duplicateMovieClip method fixing a bogus assumption
	  about the parent to duplicate into.
	* testsuite/actionscript.all/MovieClip.as: add small test for
	  ActionDuplicateClip.

2007-04-10 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStreamFfmpeg.h: Fixed a bug in the 
	  AudioResampler, which made it only resample the first time.
	* libbase/LoadThread.cpp: Handle the case where the cache is
	filled and we have yet more data to load.

2007-04-10 Markus Gothe <nietzsche@lysator.liu.se>

	* cygnal/http.cpp cygnal/stream.cpp: Added 'return true'-stubs, closes
	  bug #19561.

2007-04-10 Sandro Santilli <strk@keybit.net>

	* server/swf/tag_loaders.cpp (readPlaceObject2): reduce
	  calls to IF_VERBOSE_PARSE.

2007-04-10 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/asobj/NetStreamFfmpeg.{cpp,h}: Don't call delete on a
	new[]-allocated pointer. Don't try to copy a byte-aligned
	data buffer into a "flat" one, and vice versa. Add a helper
	class called AudioResampler, which will do audio resampling
	if necessary.
	* server/xmlsocket.cpp: Use SIZET_FMT.
	* libbase/image.cpp: Document update().
	* libbase/image.h: Define a virtual destructor for the image_base
	class so deriving classes will have their destructors called
	when we decide to delete them. Fixes a _big_ memory leak.

2007-04-10  Rob Savoye  <rob@bertha.welcomehome.org>

	* configure.ac: Test the host to see if we're on a Darwin machine.
	* backend/render_handler_ogl.cpp: Build with the native Darwin
	port of OpenGL.
	* cygnal/netstats.cpp: Include date.hpp.
	* gui/Makefile.am: Add FFMPEG_LIBS for cross compiling.
	* macros/incllist, incllist: Don't search for Darwin specific
	paths, we're correctly using the -framework flag to GCC now.
	* macros/opengl.m4: For Darwin, use the OpenGL and AGL frameworks
	instead of include or linker paths.
	* macros/x11.m4: Find all the right include paths. Look for
	libXplugin too, which is Darwin specific, and in a weird place.
	* server/StreamProvider.cpp: Remove bogus USE_CURL setting.
	* server/StreamProvider.h: Include config.h.
	* server/asobj/Makefile.am: Use FFMPEG_CFLAGS too.
	* server/parser/Makefile.am: Use FFMPEG_CFLAGS too.
	* server/vm/Makefile.am:  Use FFMPEG_CFLAGS too.
	* utilities/Makefile.am: Add FFMPEG_LIBS.
	
2007-04-10 Sandro Santilli <strk@keybit.net>

	* libbase/log.h: allow switching off any VERBOSITY overhead
	  by using -DVERBOSE_WHAT=0.
	* server/as_environment.{cpp,h}: add the concept
	  of a default target to support setTarget() calls
	  (null target spec meaning will to reset the target
	   to its original value).
	* server/vm/ASHandlers.cpp (CommonSetTarget):
	  When target specification is an empty string
	  reset the target to its original value.
	  Use find_target rather then find_object to avoid
	  variables and character names clashes.

2007-04-10 Sandro Santilli <strk@keybit.net>

	* server/parser/movie_def_impl.cpp (read_all_swf): at
	  end of parsing, check consistency of number of frames 
	  advertised in header and number of frames read from the
	  stream. Update total frame count if needed and properly
	  wake up any frame reached condition waiters.
	* server/movie_instance.cpp (advance) check return from
	  ensure_frame_loaded.

2007-04-10 Sandro Santilli <strk@keybit.net>

	* server/parser/: movie_definition.h, movie_def_impl.{cpp,h},
	  sprite_definition.{cpp,h}: stop using TU legacy hashes
	  and strings: use std::string instead of C strings, use
	  references instead of pointers in a few places.
	* server/sprite_instance.{cpp,h}: use std::string instead
	  of C strings for frame labels, update other uses of changed
	  interfaces of parser.
	* server/swf/tag_loaders.cpp: update uses of changed interfaces
	  of parser.

2007-04-10 Sandro Santilli <strk@keybit.net>

	* server/parser/Makefile.am: add FFMPEG_CFLAGS to AM_CPPFLAGS
	  if using FFMPEG sound.
	* testsuite/actionscript.all/getvariable.as: add test for
	  literal 'invalid:Number' variable name.
	* libbase/log.cpp: stop adding CR to debugging output !!
	* server/stream.cpp (open_tag): print tag offsets as start
	  of the tag (including header). This is to match offsets
	  as printed by Ming's listswf for comparision purposes.
	* server/asobj/xmlnode.{h,cpp}: fix appendChild to properly
	  move the node; implement insertBefore and removeNode; fix
	  cloneNode to respect not copy childs if not deep; implement
	  parentNode gettersetter.
	* testsuite/actionscript.all/XML.as: add tests for insertBefore,
	  appendNode, cloneNode, removeNode and parentNode.
	* macros/ffmpeg.m4: fix --with-ffmpeg-incl to look for
	  avcodec.h under the 'ffmpeg' subdir (this is assumed
	  to exist in Gnash source code).

2007-04-10 Zou Lunkai <zoulunkai@gmail.com>

	* server/parser/shape_character_def.cpp:
	  fix reading fill_styles, actually it was a regression.
	  
2007-04-09 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/Makefile.am: activated
	  get_frame_number test.

2007-04-08  Rob Savoye  <rob@bertha.welcomehome.org>

	* macros/agg.m4, boost.m4, curl.m4, ffmpeg.m4, firefox.m4,
	glib.m4, gnashpkgtool.m4, gtk2.m4, gtkglext.m4, jpeg.m4, kde.m4,
	libXML.m4, ming.m4, mysql.m4, opengl.m4, pango.m4, pthreads.m4,
	sdl.m4, x11.m4: Use ${shlibext} instead of .so to be more
	portable.
	* macros/ffmpeg.m4: Look for avutil after avformat, as there is a
	dependancy on the order on some systems.
	* macros/x11.m4: Reverse the logic, we *do* want to look for the X11
	librsaries if the X11 headers are found earlier.
	* testsuite/samples/Makefile.am: Add GotoAndPlayTestRunner to CLEANFILES.
	* configure.ac: Improve openbsd host test. Test for Darwin libtool
	vs ar. Reset AR if it's the Darwin libtool. Set FL_MUTEX to 0 if
	lf_flmutext_register isn't found.
	* cygnal/cygnal.cpp: Include libintl.h.
	* libbase/curl_adapter.cpp: Use USE_CURL consistantly instead of
	HAVE_CURL and HAVE_CURL_CURL.
	* libbase/noseek_fd_adapter.cpp: Remove HAVE_STDIN_CURL_H test.
	* libbase/rc.cpp: Include cctype.
	* macros/incllist, libslist: Add Darwin Developer SDK directories.
	
2007-04-08 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/asobj/NetStreamFfmpeg{.cpp, .h}: Only use a single
	thread (rather than two extra threads) for decoding. Plug a
	memory leak (ByteIOCxt.buffer). Modularise some more code.

2007-04-08 Ann Barcomb <kudra@domaintje.com>

	* devtools/testsuite/c_casts.t: added this test at Bastiaan's
	  request.
	* devtools/lib/Gnash/Utils.pm: fix bug which caused wrong line
	  numbers to be reported.

2007-04-08 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/get_frame_number_test.c:
	  new testcase for get_frame_number() and goto_frame().
	* server/sprite_instance.{cpp,h}
	  update implementation of get_frame_number() and goto_frame(),
	  fix the above the testcase.
	
2007-04-08 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/XML.as: add tests for XML.attributes

2007-04-07 Sandro Santilli <strk@keybit.net>

	* server/asobj/xml.cpp (extractNode, parseDoc): properly setup
	  the node parent.
	* server/asobj/xmlnode.{cpp,h}: keep parent by intrusive_ptr.
	* testsuite/actionscript.all/XML.as: add tests for
	  nextSibling and previousSibling

2007-04-07 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStream{Ffmpeg,Gst}.cpp: Use the m_imageframe's
	  size to determine the size of the returned frame.

2007-04-07 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* packaging/redhat/gnash.spec: Use --enable-media instead of
	  --enable-sound.
	* server/video_stream_instance.cpp: Delete the image once displayed.
	* server/asobj/NetStream.h: Removed the obsolete getter/setters
	  for onStatus.
	* server/asobj/NetStreamFfmpeg.{h,cpp}: Removed the obsolete 
	  getter/setters for onStatus. Made get_video() threadsafe.
	  Removed \n from log/error messages.
	* server/asobj/NetStreamGst.{cpp,h}: Removed the obsolete 
	  getter/setters for onStatus. Made get_video() threadsafe.
	  Removed \n from log/error messages.
	* server/asobj/NetConnection.cpp: Removed \n from log/error messages.

2007-04-07 Sandro Santilli <strk@keybit.net>

	* server/vm/ASHandlers.cpp (ActionCallMethod): stop warning
	  about ActionCallMethod arg being not a function (seems
	  to be common behaviour for invoking constructors).

2007-04-07 Markus Gothe <nietzsche@lysator.liu.se>

	* backend/render_handler_ogl.cpp: Removed mipsmaps code, due to
	  major clean up and rewrite (since it's not used).

2007-04-07 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/NetStreamFfmpeg{.cpp, .h}: Fix a deadlock on non-glibc
	platforms by waiting for a thread rather than hoping for a
	certain execution order (which is fundamentally incompatible with
	threads). Cleanup: modularise some code and use string comparison
	rather than char-by-char comparison.

2007-04-06 Sandro Santilli <strk@keybit.net>

	* server/character.cpp: stop notifying unload event queuing
	* server/asobj/NetStreamGst.cpp: warn only once about fluendos
	  plugin being too old.

2007-04-06 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (ScriptObjectFinder): 
	  use character depth to tell wheter objects have to
	  be considered "script" objects or not. Fixes the
	  all.swf regression and doesn't change our testsuite
	  results.
	* testsuite/actionscript.all/MovieClip.as: test both
	  ActionRemoveClip and MovieClip.removeMovieClip; also
	  tests that there's no such think as a _global.removeMovieClip.
	* testsuite/misc-ming.all/displaylist_depths_test.c:
	  Add a bunch of new tests about removing from protected
	  depth ranges and using swapDepth to move between ranges.
	* server/sprite_instance.{h,cpp}: Add a removeMovieClip
	  public method for common use by ActionRemoveClip tag,
	  global removeMovieClip function and MovieClip.removeMovieClip
	  method; fix swapDepths to accept a depth as argument;
	  fix removeMovieClip to check for allowed depth bounds.
	* server/vm/ASHandlers.cpp (ActionRemoveClip): use the new
	  sprite_instance::removeMovieClip method.

2007-04-06 Sandro Santilli <strk@keybit.net>

	* server/: character.h, dlist.{cpp,h}, sprite_instance.{cpp,h}:
	  Character instance depth is a _signed_ value !
	  Add a character::staticDepthOffset constant to use for converting
	  displaylist tag defined depths to negative values.
	* server/swf/tag_loaders.cpp: convert displaylist tag defined depths
	  to negative values by adding character::staticDepthOffset
	* testsuite/misc-ming.all/: ButtonEventsTest-Runner.cpp,
	  testsuite/samples/clip_as_button2-TestRunner.cpp,
	  testsuite/movies.all/gravity_embedded-TestRunner.cpp:
	  loop_test-Runner.cpp, simple_loop_testrunner.cpp: fix the
	  test runners to take staticDepthOffset into account.
	* testsuite/actionscript.all/MovieClip.as: getNextHighestDepth()
	  test now succeeds.


2007-04-06 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, displaylist_depths_test.c:
	  Add a new interesting (failing) test showing that static characters
	  and dynamic characters use a completely different range
	  of depths !!
	* server/sprite_instance.cpp (sprite_get_depth): only convert
	  depths to negative values for static clips.
	* testsuite/actionscript.all/MovieClip.as: add a couple of
	  tests for getDepth() invoked against dynamic and static
	  clips.

2007-04-05  John Gilmore  <bug-gnu-gettext@gnu.org>

	Internationalize gnash.  Phase 1: use gettextize, update config files.

	* macros/{codeset.m4, gettext.m4, glibc2.m4, glibc21.m4,
	  iconv.m4, intdiv0.m4, intmax.m4, inttypes.m4, inttypes_h.m4,
	  inttypes-pri.m4, isc-posix.m4, lcmessage.m4, lib-ld.m4,
	  lib-link.m4, lib-prefix.m4, longdouble.m4, longlong.m4, nls.m4,
	  po.m4, printf-posix.m4, progtest.m4, signed.m4, size_max.m4,
	  stdint_h.m4, uintmax_t.m4, ulonglong.m4, wchar_t.m4, wint_t.m4,
	  xsize.m4}: New files, from gettext-0.14.6.
	* po: New directory for translated messages (Portable Object files)
	* po/{Makefile.in.in, boldquot.sed, en@boldquot.header,
	  en@quot.header, insert-header.sin, quot.sed,
	  remove-potcdate.sin, Rules-quot}: New files, from gettext-0.14.6.
	* ABOUT-NLS, config.rpath: New files, from gettext-0.14.6.
	* libbase/gettext.h:  New file, from gettext-0.14.6.
	* server/gnash.h: Include "gettext.h" for NLS.
	* po/Makevars: New file: settings for gnash's message translation.
	* po/POTFILES.in: New file: source files with translatable strings.
	* po/LINGUAS: New file: languages we have translations for.
	* Makefile.am (EXTRA_DIST): Add config.rpath.
	  (STD_DIRS): Add po.
	* configure.ac (AC_OUTPUT): Add po/Makefile.in.
	  (AM_GNU_GETTEXT):  Add, to configure gettext support.
	* cygnal/Makefile.am (localedir, INCLUDES),
	  gui/Makefile.am (localedir, INCLUDES),
	  utilities/Makefile.am (localedir, INCLUDES):  Define LOCALEDIR.
	* cygnal/cygnal.cpp (main), gui/gnash.cpp (main), 
	  utilities/{dumpshm,parser,processor}.cpp (main):
	  Set locale and initialize gettext upon startup.
	* utilities/{dumpshm,parser,processor}.cpp:  Flag strings with _
	  for translation, for testing.
	* po/gnash.pot:  Message string catalog for testing.
	* po/es.po:  Spanish-language message string catalog for testing.

2007-04-05 Zou Lunkai <zoulunkai@gmail.com>

	* server/asobj/Date.cpp
	fix passing parameter to utctime();
	
2007-04-05 Sandro Santilli <strk@keybit.net>

	* server/vm/ASHandlers.cpp (ActionRemoveClip): properly parse
	  the given argument rather then assuming that it refers to
	  a child of the current target movie. (fixes the softreference
	  tests).
	* testsuite/actionscript.all/MovieClip.as: add softreference
	  test (MovieClip values kept by absolute _target).
	* testsuite/actionscript.all/MovieClip.as: fix couple of stack
	  underruns.
	* server/sprite_instance.{cpp,h} (get_frame_number):
	  Changed signature to report invalid frame specifications;
	  simplified and clened implementation of Zou Lunkai.
	* server/vm/ASHandlers.cpp: updated calls to get_frame_number.
	* testsuite/swfdec/PASSING: gotoframe.swf now passes.

2007-04-05 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/Makefile.am: enabled run of
	  reverse_execute_PlaceObject2_test2runner and
	  action_execution_order_test6runner.
	* testsuite/misc-ming.all/ming_utils.c (get_dejagnu_actions):
	  property initialize the xpassed and xfailed counters.

2007-04-05 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/reverse_execute_PlaceObject2_test2.c
	add more tests of MovieClip events
	
2007-04-05 Sandro Santilli <strk@keybit.net>

	* server/timers.{cpp,h}: drop the as_environment member
	  for Timers as we can't ensure it will be kept alive.
	  We'll use a newly created environment for calling
	  the timer function.
	* server/asobj/: LoadVars.cpp, xmlsocket.cpp: update use of
	  timers.
	* server/as_environment.cpp (find_object_dotsyntax): 
	  more verbose debugging for cases in which a dot-syntax
	  path contains non-object members.

2007-04-05 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all: reverse_execute_PlaceObject2_test2.c
	another testcase for reverse execution of frame tags. 
	* testsuite/misc-ming.all/reverse_execute_PlaceObject2_test1.c
	add notes that reverse execution is likely to be deprecated.
	* testsuite/misc-ming.all/action_execution_order_test6.c
	do checks and stop movie at the last frame.
	
2007-04-04 Markus Gothe <nietzsche@lysator.liu.se>

	* server/asobj/TextFormat.{cpp,h} - Added stub for class TextFormat.

2007-04-04 Bastiaan Jacques <bastiaan@bjacques.org>

	* gui/gui.cpp, backend/render_handler_agg_style.h,
	server/{swf/DefineFontAlignZonesTag.cpp, textformat.cpp}: 
	Comment out unused variables. 
	* libamf/amf.cpp: Remove unneeded casts. Replace some
	C-style casts by C++-style ones. Don't modify const type;
	instead, use a temporary (el->data).
	* server/{movie_root.cpp, shm.cpp, sprite_instance.cpp,
	          vm/ActionExec.cpp, asobj/xmlsocket.cpp}: More
	use of SIZET_FMT.
	* server/{Boolean.cpp, Date.cpp}: Don't assign string
	literals to character pointers, which will soon be
	deprecated by GCC. Instead, use array declarations.
	* server/asobj/{NetStreamFfmpeg.cpp, SoundFfmpeg.cpp}:
	Don't compare unsigned with signed ints.
	* server/asobj/xml.cpp: Comment out include that is used
	by commented out code.
	* server/parser/movie_def_impl.h: Fix typo.

2007-04-04 Sandro Santilli <strk@keybit.net>

	* server/asobj/xml.cpp: fix parsing of text nodes
	* server/asobj/xmlnode.{cpp,h}: use std::string, not
	  C strings for name and value. Add an enum for NodeType.
	* testsuite/actionscript.all/XML.as: more tests for
	  the memory-parsed XML.

2007-04-04 Sandro Santilli <strk@keybit.net>

	* server/asobj/xmlnode.cpp: don't attacy XMLNode interface
	  to XMLNode instances.
	* server/asobj/xml.{h,cpp}: override get_member and set_member
	  to handled non-proper properties 'loaded' and 'status'
	* testsuite/actionscript.all/XMLNode.as: less failures
	* testsuite/actionscript.all/XML.as: more tests !

2007-04-04 Sandro Santilli <strk@keybit.net>

	* server/array.{cpp,h}: const-corrected push and unshift
	  methods.
	* server/asobj/xmlnode.cpp: implement childNodes getter/setter.
	* server/asobj/xml.cpp: cleanups.

2007-04-04 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/Makefile.am: enable
	  reverse_execute_PlaceObject2_test1runner in 'check' rule.
	* server/array.cpp: use a getter/setter for the 'length' property.
	* testsuite/actionscript.all/array.as: another success.

2007-04-04 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/reverse_execute_PlaceObject2_test1.c
	ensure that total() is called at the last step.
	
2007-04-04 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/array.as: more tests added.
	* server/asobj/xml.cpp: remove debugging lines, return undefined
	  from getBytesLoaded,getBytesTotal if the XML was not loaded.
	* server/asobj/xmlnode.cpp: remove debugging lines.
	* testsuite/actionscript.all/XML.as: all current tests pass now
	  (but we need more tests);

2007-04-04 Sandro Santilli <strk@keybit.net>

	* server/asobj/xmlnode.cpp (stringify): stop feeding NULL 
	  pointers to output operators !
	* server/asobj/xml.cpp (xml_new): support a string as first
	  argument to constructor.

2007-04-04 Sandro Santilli <strk@keybit.net>

	* server/asobj/xml.{cpp,h}: tu_string => std::string
	* server/asobj/xmlsocket.cpp: provide a builtin onData
	  event handler to XMLSocket instances.
	* testsuite/actionscript.all/XMLSocket.as: more successes.
	* server/URLAccessManager.{cpp,h}: add allowHost interface.
	* server/asobj/xmlsocket.cpp (connect): check host security.

2007-04-04 Zou Lunkai <zoulunkai@gmail.com>

	* server/sprite_instance.cpp
	first attempt to deprecate reverse execution of frame tags
	
2007-04-03 Sandro Santilli <strk@keybit.net>

	* server/edit_text_character.cpp (format_text): handle
	  TAB characters.
	* testsuite/misc-ming.all/ming_utils.c: embed a glyph for 
	  the TAB character in our font.
	* server/vm/ASHandlers.cpp: extend tag is not in testing
	  stage anymore, be more explicit about targetPath() arg
	  not casting to an object.
	* server/movie_root.{cpp,h}: limit the number of interval
	  timers to 255.
	* server/asobj/xmlsocket.{cpp,h}: more cleanups and fix for
	  polling from the socket.
	* libbase/network.{cpp,h}: do not allow assignment, cleanup
	  accessor functions to return by const refs.
	* server/asobj/xmlsocket.{cpp,h}: do not override inherited
	  members and methods. Enable some more debugging and added
	  more assertions.

2007-04-03 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/XMLSocket.as: some more
	  testing.
	* server/sprite_instance.{cpp,h}: split the
	  DisplayList reset code from execute_frame_tags()
	  to a resetDisplayList() method.

2007-04-03 Sandro Santilli <strk@keybit.net>

	* server/asobj/xmlattrs.{cpp,h}: use std::string
	  for name and value, access trough members, initialize
	  trought contructor.
	* server/asobj/xmlnode.{cpp,h}: keep XMLAttr by value,
	  not by pointer; implement the 'attributes' getter.
	* server/asobj/xml.cpp: update XMLAttr uses.
	* testsuite/actionscript.all/XML.as: more tests, less failures.
	* testsuite/media/gnash.xml: add a tag attribute.

2007-04-03 Sandro Santilli <strk@keybit.net>

	* server/asobj/xml.{cpp,h}: have XML be a subclass
	  of XMLNode. Many cleanups.
	* server/asobj/xmlnode.{cpp,h}: many cleanups.
	* testsuite/actionscript.all/XML.as: add more tests.
	* testsuite/actionscript.all/XMLNode.as: fix some bogus
	  existing tests.

2007-04-03 Sandro Santilli <strk@keybit.net>

	* server/parser/movie_def_impl.h (add_init_action): fix typo.
	* testsuite/actionscript.all/XML.as: a few more tests.
	* testsuite/media/gnash.xml: new data file for testing.
	* server/asobj/xml.{cpp,h}: allow reading XML from
	  a network stream (untested).

2007-04-03 Markus Gothe <nietzsche@lysator.liu.se>

	* server/as_value.h: Include <limits> for NAN.
	* backend/render_ogl.cpp: Fixed memory leak.

2007-04-02 Sandro Santilli <strk@keybit.net>

	* configure.ac: fix a couple of typos.
	* server/button_character_instance.cpp (on_event): queue
	  events, don't execute immediately
	* server/vm/ExecutableCode.h (GlobalCode): take a character
	  as target.
	* server/movie_root.{cpp,h} (pushAction): take a character
	  as target.
	* testsuite/samples/gotoFrameOnKeyEvent-TestRunner.cpp:
	  unexpected success.

2007-04-02 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* Makefile.am, configure.ac, gui/Makefile.am, gui/gnash.cpp, gui/gtk.cpp:
	  Changed the "--enable-sound" option to "--enable-media", and removed
	  the "--with-mp3-decoder" option.
	* server/asobj/NetStreamFfmpeg.cpp: Replaced a few assert(0) with
	  warnings.
	* server/asobj/NetStreamGst.cpp: Only create sound objects if a
	  soundhandler is present.

2007-04-02 Sandro Santilli <strk@keybit.net>

	* server/dlist.{cpp,h} (place_character): call unload()
	  on characters that are replaced.

2007-04-02 Sandro Santilli <strk@keybit.net>

	* gui/sdl.cpp (key_event): update call to notify_key_event.
	* server/vm/ExecutableCode.h: change FunctionCode to take
	  a generic character as target, not necessarely a sprite.
	* server/movie_root.{cpp,h}: update pushAction() for events
	  to take a generic character, add a notify_key_event method
	  for consistency.
	* server/asobj/Key.cpp: notify_key_event moved to movie_root.
	* server/gnash.h: remove notify_key_event prototype, it's now
	  a movie_root method.
	* gui/gtk.cpp: use gui::notify_key_event for key events.
	* gui/gui.{cpp,h}: add notify_key_event method.
	* server/character.{cpp,h}: move queueActionHandler from
	  sprite_instance here.
	* server/sprite_instance.{cpp,h}: cleanups.
	* testsuite/MovieTester.cpp: update call to notify_key_event.

2007-04-02 Sandro Santilli <strk@keybit.net>

	* testsuite/samples/: Makefile.am, gotoFrameOnKeyEvent-TestRunner.cpp:
	  First stub at an automated test runner for gotoFrameOnKeyEvent.
	  TODO item in comments.

2007-04-02 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/as_value{.cpp, .h}: Declare NAN in the header
	(and fix a typo in the declaration. Use that definition
	instead of by using 0.0 / 0.0 to avoid compiler warnings.
	* server/asobj/{Date.cpp, Math.cpp}: Don't redefine NAN.

2007-04-02 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/ming_utils.{c,h}: fix compiler warnings.
	* testsuite/samples/: gotoFrameOnKeyEvent.swf, README:
	  Add new tests used to debug keypress listeners and
	  goto_frame. Provided by Dongdong <dedodong@163.com>
	* server/movie_root.cpp (notify_keypress_listeners):
	  Skip event execution for unloaded characters
	  (they will be removed at next ::advance call)

2007-04-02 Sandro Santilli <strk@keybit.net>

	* server/dlist.{cpp,h} (remove_display_object): call
	  unload on removed character.
	* server/: character.h, sprite_instance.{cpp,h}:
	  Moved the isUnloaded()/_unloaded logic from sprite_instance
	  up to character.
	* server/movie_root.{cpp,h}: remove unloaded characters
	  from the keypress_listeners set (run at ::advance time).

2007-04-02 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (goto_frame): remember to call
	  set_invalidated() before running display list tags!
	  (UdoG: is this correct?)

2007-04-02 Zou Lunkai <zoulunkai@gmail.com>

	* server/sprite_instance.cpp, sprite_instance.h
	add is_reverse_execution() to check if is reverse executing frame tags;
	* server/tag_loaders.cpp
	set "replace_if_depth_is_occupied" to true when reverse executing PlaceObject2.
	fixed error messages with playing bombgame.swf, improved implementation of 
	reverse execution.

	  
2007-04-01 Sandro Santilli <strk@keybit.net>

	* server/swf/tag_loaders.cpp (define_bits_jpeg_loader,
	  define_bits_jpeg2_loader, define_bits_lossless_2_loader):
	  Handle duplicate character id. "Fixes" bug #19474.

2007-03-31 Sandro Santilli <strk@keybit.net>

	* gui/Makefile.am, testsuite/server/Makefile.am,
	  utilities/Makefile.am: add libgnashparser dependency.
	  Fixes bug #19450.

2007-03-31 Bastiaan Jacques <bastiaan@bjacques.org>

	* configure.ac, gui/gtk_glue_agg.cpp: Add configurable support
	for 16-bit GTK, for use on the OLPC. Simply specifying
	--with-pixelformat=rgb565 will activate this code.

2007-03-30 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStream{Ffmpeg,Gst}.cpp: Fixed the callback
	  to the onStatus eventhandler.

2007-03-30 Sandro Santilli <strk@keybit.net>

	* server/asobj/Mouse.cpp: cleanups.
	* libbase/network.cpp: minor cleanups in debugging lines.
	* server/asobj/xmlsocket.{cpp,h}: first pass at cleanup,
	  fix XMLSocket.connect() to return the correct value.
	* server/asobj/Global.cpp: initialize XMLSocket with the
	  most current interface.
	* testsuite/actionscript.all/: Makefile.am, XMLSocket.as:
	  initial test for XMLSocket (methods availability).

2007-03-30 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/FLVParser.cpp: Fixed a few bugs.
	* libbase/LoadThread.{h,cpp}: Changed to use a cache so we avoid
	  blocking to often when reading and loading at the same time.
	* server/asobj/NetConnection.{h,cpp}: Added loadCompleted().
	* server/asobj/NetStream.{h,cpp}: Added setEnvironment(), and
	  removed the getter/setter for onStatus.
	* server/asobj/NetStreamFfmpeg.{h,cpp}: Fixed a big mem-leak. Added
	  setEnvironment(), and added support for status/error messages.
	* server/asobj/NetStreamGst.{h,cpp}: Added setEnvironment(), and
	  added support for status/error messages.
	* testsuite/actionscript.all/NetStream.as: Corrected expected
	  results for onStatus, and added some for onCuePoint and onMetaData.

2007-03-30 Sandro Santilli <strk@keybit.net>

	* server/dlist.cpp (clear_except): don't copy display list (small
	  typo)
	* server/sprite_instance.cpp (ctor): initialize the _unloaded member.
	* testsuite/actionscript.all/NetStream.as: check that onStatus and
	  onSeek are not special builtin-properties.
	* server/timers.{cpp,h}: add support for passing arguments to
	  setInterval() callbacks.
	* testsuite/misc-ming.all/: intervalTest.as, intervalTestRunner.cpp:
	  All tests pass now.

2007-03-30 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: intervalTest.as, intervalTestRunner.cpp:
	  Add test for setInterval() calls with additinal args (Gnash fails).
	* server/asobj/xmlsocket.cpp: don't attempt to send
	  data when not connected !
	* testsuite/misc-ming.all/Makefile.am: prepared for
	  activation of reverse_execute_PlaceObject2_test1runner
	  (not activated as for Zou request).

2007-03-30 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all: reverse_execute_PlaceObject2_test1.c
	  add a new testcase for reverse execution of frame tags. The next
	  step is to improve it or deprecate it.
	  
2007-03-30 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/: check.as, targetPath.as:
	  Don't use asm { targetPath } when not supported by
	  detected Ming.

2007-03-30 Sandro Santilli <strk@keybit.net>

	* server/as_value.cpp (to_sprite): don't attempt to resolve
	  the path to a sprite if this value is not a MOVIECLIP type.
	* server/swf.h: document ACTION_TARGETPATH
	* server/sprite_instance.{cpp,h}: implement getTarget(), have
	  get_text_value() call getTarget() internally.
	* server/vm/ASHandlers.cpp: Implement ActionTargetPath.
	* testsuite/actionscript.all/: Makefile.am, targetPath.as:
	  Test ACTION_TARGETPATH (0x45).

2007-03-29  Rob Savoye  <rob@bertha.welcomehome.org>

	* configure.ac: Add --disable-menus since an embedded systems
	probably won't want them.
	* gui/gtk.cpp: Disable most of the menu items if they're
	disabled.
	* packaging/redhat/gnash.spec: Build with --disable-menus for the
	OLPC. 

	* doc/C/sources.xml: Fix mismatched sect tags.
	* doc/C/asspec: new directory to hold the ActionScript
	specification files, so as to not clutter the top level doc
	directory.
	* doc/C/accessibility.xml, array.xml, boolean.xml, button.xml,
	camera.xml, color.xml, contextmenu.xml, customactions.xml, date.xml,
	error.xml, function.xml, key.xml, loadvars.xml, localconnection.xml,
	math.xml, microphone.xml, mouse.xml, movieclip.xml,
	moviecliploader.xml netconnection.xml, netstream.xml, number.xml,
	selection.xml, sharedobject.xml, sound.xml, stage.xml, string.xml,
	system.xml, textfield.xml, textformat.xml, textsnapshot.xml, video.xml,
	xml.xml, xmlnode.xml, xmlsocket.xml: Moved to asspec directory.
	* doc/asspec/asspec.xml: New top level document for free
	ActionScript specification.
	* doc/C/gnash.xml: Remove AS Spec entities, they're now in
	asspec.xml. Use gnash-dev instead of gnash for questions.

2007-03-29 Markus Gothe <nietzsche@lysator.liu.se>

	gui/gtk.cpp: Indent the licensing notes. 

2007-03-29 Deanna Phillips <deanna>

	* server/vm/fn_call.h: include the stuff needed
	  for proper intrusive_ptr composition.

2007-03-29 Sandro Santilli <strk@keybit.net>

	* server/as_object.{cpp,h} add an optional argument
	  to init_property and init_readonly_proprety for setting
	  explicit flags, use same defaults as for init_member.
	* server/vm/ASHandlers.cpp (ActionEnum, ActionEnum2):
	  do not convert values to objects always.
	* testsuite/misc-mtasc.all/: Makefile.am, enum.as: 
	  Add test for ActionEnum2.
	* testsuite/server/Makefile.am: more linking fixes.

2007-03-29 Sandro Santilli <strk@keybit.net>

	* server/asobj/SharedObject.cpp: better stubs (nothing more).

2007-03-29 Sandro Santilli <strk@keybit.net>

	* server/movie_root.{cpp,h}: support for
	  setting scaleMode (allow scaling) and
	  notifying Stage listeners when disabled.
	* server/asobj/Stage.{cpp,h}: rework layout,
	  implement addListener, removeListener and
	  scaleMode.
	* testsuite/actionscript.all/Stage.as: add a few
	  tests for Stage. The notification-based tests
	  are not automatically run yet (will need a MovieTester
	  test runner, with new interfaces to it for resize request)
	* utilities/Makefile.am: add libgnashasobjs, now needed.

2007-03-29 Ann Barcomb <kudra@domaintje.com>

	* devtools/testsuite/tabs.t: added check for hard tabs in 
	  C++ source.

2007-03-29 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.{h,cpp} (goto_frame): push target
	  actions to the global list; (unload): set the _unloaded
	  flag; (m_goto_action_list): deprecated !
	* testsuite/misc-ming.all/consecutive_goto_frame_test.c:
	  don't expect a failure.
	* testsuite/swfdec/PASSING: goto3.swf succeeds.

2007-03-29 Sandro Santilli <strk@keybit.net>

	* server/asobj/string.cpp (string_split): fix compiler wanring
	  and handle SWF5 case.
	* testsuite/actionscript.all/String.as: expect less failures.
	* server/sprite_instance.{h,cpp} add queueActions() method.
	* server/swf/tag_loaders.cpp: fix compiler warnings.
	* testsuite/server/Makefile.am: link in libgnashparser for the
	  tests that turn out to need it since rob changed it from
	  noinst_LTLIBRARY to lib_LTLIBRARY.
	* configure.ac: provide MING_SUPPORTS_INIT_ACTIONS conditional.
	* testsuite/misc-ming.all/ming_utils.{h,c}: provide
	  MING_SUPPORTS_INIT_ACTIONS macro and use it to conditinally
	  buil the init acion interface.
	* testsuite/misc-ming.all/Makefile.am: provide MING_VERSION_CODE
	  macro, enable build of init_action_test when
	  MING_SUPPORTS_INIT_ACTIONS.

2007-03-28 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all: init_action_test.c
	  add a new testcase for DoInitAction.
	* testsuite/misc-ming.all/ming_utils.c, ming_utils.h
	  add a interface for adding init actions for sprites.
	  
2007-03-28  Rob Savoye  <rob@bertha.welcomehome.org>

	* autogen.sh: Make config-h.in atfer running libtoolize so
	Darwin builds stop failing.
	* configure.ac: Remove dash after cvs, it confuses rpmbuild.
	* backend/Makefile.am: List AGG headers in noinst_HEADERS.
	* macros/agg.m4: Set ac_cv_path_agg_incl based on agg_include_dir
	to save a few cycles.
	* macros/pthreads.m4: Don't set any flags for pthreads on
	Darwin. Test for the .dylib suffix too.
	* packaging/redhat/gnash.spec: Merge in changes from Redhat.
	* server/Makefile.am: Add BOOST and pthreads libs for cross
	builds.
	* server/asobj/Makefile.am: Make an installable library for
	dynamically linking on Darwin.
	* server/parser/Makefile.am: Make an installable library for
	dynamically linking on Darwin.
	* testsuite/misc-ming.all/Makefile.am: Add intervalTest.as to
	EXTRA_DIST so distcheck passes.
	* testsuite/misc-mtasc.all/Makefile.am: Add all .as files to
	EXTRA_DIST so distcheck passes. Add to CLEANFILES so distcheck
	passes. 
	* testsuite/samples/Makefile.am: Add to CLEANFILES so distcheck
	passes.
	* testsuite/libbase/Makefile.am: Link in libgnashvm too.
	* utilities/Makefile.am: Add CURLS_LIBS. Add sufix rule for for
	build swf from as files.

2007-03-28 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStreamGst.cpp: Make sure pipeline exists before
	  accessing it, and the same goes for the FLV parser.

2007-03-28 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (add_textfield): return void.
	* testsuite/actionscript.all/MovieClip.as: add tests for
	  createTextField().

2007-03-28 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (add_textfield): use edit_text_character,
	  not simple text_character (the latter has all the ActionScript
	  methods attached to it).
	* server/edit_text_character.{cpp,h}: keep definition
	  by intrusive_ptr.
	* server/edit_text_character.{cpp,h}: add stubs
	  for all known TextField methods.
	* server/asobj/Global.cpp: initialize the global
	  TextField class
	* testsuite/actionscript.all/: Makefile.am, TextField.as:
	  New testcase for TextField class (just checks availability
	  of stuff).

2007-03-28 Sandro Santilli <strk@keybit.net>

	* libbase/GnashException.h: Add ActionLimitException
	* server/as_environment.{cpp,h}: provide callStackDepth()
	  and cleanCallstack() methods, throw an ActionLimitException
	  when reaching 255 call stack depth.
	* server/vm/ActionExec.{cpp,h}: catch ActionLimitException
	  by aborting execution of current code.
	* server/vm/ASHandlers.cpp (ActionCallFunction): pass the
	  environment when converting function name to string.

2007-03-28 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* backend/sound_handler_gst.cpp: Don't calculate the numbers of 
	  buffers to feed to the pipeline, since it makes loaded sound
	  streams stop to early.
	* libbase/FLVParser.{h,cpp}: Made it thread-safe. Fixed a lot of
	  bugs. Added support for extacting size of h.263 video.
	* server/asobj/NetConnection.cpp: Set _loader to NULL after deletion.
	* server/asobj/NetStreamFfmpeg.cpp: Corrected some error messages and
	  error handling.
	* server/asobj/NetStreamGst.{h,cpp}: Use our internal FLVParser
	  when FLV is being played.

2007-03-28 Sandro Santilli <strk@keybit.net>

	* server/array.{cpp,h}: implement Array.splice(),
	  improve toString to actually call the user-provided
	  toString on all elements.
	* testsuite/actionscript.all/array.as: added testcases
	  for Array.splice().
	* testsuite/misc-ming.all/Dejagnu.c: use a larger window for traces.
	* testsuite/misc-ming.all/: FlashVarsTest.as, FlashVarsTest.html,
	  Makefile.am: added a test for querystring and flashparams parsing.
	* server/sprite_instance.cpp (loadMovie):
	  Parse the querystring given in the URL.

2007-03-28 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/as_value.h: Add as_value::to_number<type>(), which will
	cast the result of to_number() to the requested number type.
	* server/as_object{.h, .cpp}: Rename init_property(name, getter)
	to init_readonly_property(name, getter).
	* server/{button_character_instance.cpp, sprite_instance.cpp):
	Update callers to use init_readonly_property.
	* server/asobj/string.cpp: Reimplement the ActionScript String
	class using std::string. Also change the style to Rob's
	preffered one.
	* testsuite/actionscript.all/String.as: Add a few more
	testcases.

2007-03-28 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.{cpp,h}: add setVariables()
	  method taking a std::map.
	* gui/Player.cpp (run): parse URL query string
	  after parsing FlashVars, for proper handling precedence.
	  NOTE that this won't work when load starts from an internal
	  call (loadMovie, getUrl with target etc.)

2007-03-27 Markus Gothe <nietzsche@lysator.liu.se>

	* backend/render_handler_ogl.cpp: Added anti-aliasing for polygons
	  (i.e. fonts and such).

2007-03-27 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.{cpp,h}: add isUnloaded()
	  method to properly skip execution of queued
	  actions for unloaded sprites.
	* server/vm/: Makefile.am, ExecutableCode.h:
	  Add definition of a generic Executable Code
	  for use as element of the global Action Queue.
	* server/movie_root.{cpp,h}: add support for
	  a global Action Queue.

2007-03-27 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/as_object.h: Print the passed pointer type
	rather than the intrusive_ptr in which it is contained.

2007-03-27 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/Date.as:
	  Commented out a test that also fails with
	  the proprietary player (seems related to
	  DST, started failing when it entered in effect).
	  Anyone willing to fix the test is welcome.
	* server/sprite_instance.cpp (execute_frame_tags):
	  Execute init actions immediately. This might change
	  when we get actions execution order definitively right
	  but it's useful to commit now has a facility for keep
	  tracking youtube missing bits.

2007-03-25 Martin Guy <martinwguy@yahoo.it>

	* configure.ac: reformat all "package not installed" messages
	  to the same layout
	* configure.ac: Fail during configure if AGG libraries not detected;
	  AGG is no longer "experimental"
	* configure.ac: Regularise layout of AC_ARG_*

2007-03-25 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/MovieClip.as: print a warning
	  about possible confusion created by bugs in the proprietary
	  players.
	* testsuite/actionscript.all/NetConnection.as:
	  getURL doesn't exist, and connect returns
	  a boolean value.

2007-03-24 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/LoadThread.{cpp,h}: Changed so that it is possible to
	  check if the stream is valid.
	* server/StreamProvider.cpp: Check if local file exists before
	  creating the tu_file.
	* server/asobj/NetConnection.cpp: Changed to work with the
	  LoadThread changes. Added an assert for a valid URL.

2007-03-24 Sandro Santilli <strk@keybit.net>

	* server/swf/tag_loaders.cpp (readPlaceActions): gracely handle
	  malformed SWF produced by some old snapshot of Ming CVS.
	* testsuite/misc-ming.all/Makefile.am:
	  Don't try to build tests unsupported by 
	  the installed Ming version.

2007-03-24 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/as_function.cpp: Partially revert changes related to fn_call
	which mysteriously broke the testsuite.
	* server/vm/fn_call.h: Make nargs non-const and add a setter for offset
	so as_function can modify them.

2007-03-23 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetStreamFfmpeg.cpp: Fixed getting time when
	  decoder isn't initialized.

2007-03-23 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* backend/sound_handler_sdl.cpp: Count videos sounds.
	* libbase/FLVParser.{h,cpp}: Added. Our own homegrown FLV parser.
	* libbase/LoadThread.{h,cpp}: Use auto_ptr<tu_file> instead of tu_file,
	  and added the isPositionConfirmed() function.
	* libbase/Makefile.am: Added FLVParser.{h,cpp}.
	* macros/libXML.m4: A fix for when using --with-libxml-incl
	* server/video_stream_instance.cpp: Use Advance to investigate if a new
	  video frame is ready, and decide if the bouds should be invalidated.
	* server/asobj/NetConnection.{h,cpp}: Pass a auto_ptr<tu_file> to 
	  LoadThread. Always check if the loader exists before using it.
	  Added connectParser to make it possible for the parser to access the file.
	* server/asobj/NetStream.{h,cpp}: Implemented setBufferTime and onStatus.
	* server/asobj/NetStreamFfmpeg.{h,cpp}: Use the new FLVParser when we
	  play a FLV. Added more comments. Implemented setBufferTime, and made
	  things ready for onStatus.
	* server/asobj/NetStreamGst.{cpp,h}: Added stubs and small updates to 
	  keep up with NetStreamFfmpeg. Some work on supporting the -r1 switch.
	* server/asobj/SoundGst.cpp: Removed a printf.

2007-03-22 Sandro Santilli <strk@keybit.net>

	* testsuite/swfdec/PASSING: two more successes.
	* server/stream.{cpp,h} (read_uint): don't force return
	  to fit in a short. Fixes a regression for 3dtris.swf.

2007-03-22 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/as_object.cpp: in set_member_default(), only setValue()
	on properties that aren't read-only. Add an init_property()
	method specifically for read-only properties which takes only
	a setter. Also add a method asPropName() that converts property
	names to lowercase, which is a very common pattern in this
	class.
	* server/button_character_instance.cpp,
	server/character{.cpp, .h}, server/character_instance.cpp:
	Use the new init_property() for read-only properties. Don't
	check if read-only properties are being set in getters.
	* server/vm/fn_call.h: Make fn_call more robust: rename
	first_arg_bottom_index to _stack_offset, which I think is more
	descriptive. Make _stack_offset and _env private properties; add
	accessors for them. Make nargs a const property. Add doxygen
	comments for all members.
	* all over the place: Adjust all users of fn_call members.
	Make sure all callers use the new accessors and that no caller
	tries to set now-const properties.

2007-03-22 Sandro Santilli <strk@keybit.net>

	* server/asobj/Number.cpp: don't attach Number interface
	  to the Number class itself.
	* testsuite/actionscript.all/Number.as: more tests
	  for valueOf,toString (many still fail for SWF5).

2007-03-22 Sandro Santilli <strk@keybit.net>

	* server/font.cpp, server/stream.cpp, server/swf/tag_loaders.cpp:
	  Fixed signedness warnings after stream interface update.

2007-03-22 Sandro Santilli <strk@keybit.net>

	* server/stream.{cpp,h}: fix signedness of integers.
	* server/parser/button_character_def.cpp (read):
	  Survive malformation of button2 events action tags.

2007-03-22 Sandro Santilli <strk@keybit.net>

	* server/as_value.{h,cpp}: drop all methods transparently
	  calling to_number w/out passing an as_environment.
	* server/asobj/Global.cpp, server/asobj/xml.cpp,
	  server/vm/ASHandlers.cpp: properly update to explicitly
	  invoke as_value::to_number() when needed.

2007-03-22 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all: action_execution_order_test6.c, Makefile.am.
	  add a new testcase for passing-by MovieClip events.

	  
2007-03-22 Sandro Santilli <strk@keybit.net>

	* testsuite/swfdec/PASSING: comparisons-7.swf now passes.
	* testsuite/actionscript.all/Number.as: add tests for
	  comparison operators (unfortunately Ming never outputs
	  ActionGreater, but swfdec testsuite contains it).
	* server/vm/ASHandlers.cpp (ActionNewLessThen, ActionGreater):
	  return undefined if numeric conversion returns NaN.
	* server/as_value.h: drop 'operator<', is not appropriate as
	  it insists in returning a bool, while we might eventually
	  get an undefined value.

2007-03-21 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/check.as: define
	  MING_SUPPORTS_ASM_GETPROPERTY.
	* testsuite/actionscript.all/MovieClip.as: add test for
	  getproperty call w/out an explicit target.
	* server/impl.cpp (create_library_movie): include SWF version info,
	  at least it's now shown with a bare -v.
	* server/vm/ASHandlers.cpp (ActionGetProperty):
	  An empty string as target means we pick the current top
	  of scope stack. (SWFHandlers ctor): add comments for
	  hard-coded numbers properties should have.

2007-03-21 Sandro Santilli <strk@keybit.net>

	* server/vm/ASHandlers.cpp (ActionSubString): when length argument
	  is negative take it as full string length.
	* testsuite/actionscript.all/String.as: add tests for 'substring'
	  action with negative length parameter.

2007-03-21 Sandro Santilli <strk@keybit.net>

	* server/as_function.cpp (extends): when VM version is > 5
	  set 'prototype.__constructor__'  in addition to
	  'prototype.constructor'
	* server/swf_function.cpp (getSuper): user __proto__.__constructor
	  rather then __proto__.constructor.
	* testsuite/actionscript.all/: Function.as, Inheritance: more
	  successes.

2007-03-21 Sandro Santilli <strk@keybit.net>

	* testsuite/swfdec/PASSING: new successes: onload-childparent.swf,
	  registerclass-previous.swf.
	* server/vm/ASHandlers.cpp (ActionCallFunction):
	  When function is an object, invoke it's 'constructor';
	  Properly set the 'this' pointer.
	* testsuite/actionscript.all/Function.as: more successes.


2007-03-21 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/action_execution_order_extend_test.c:
	  fix calling _root.note
	  
2007-03-20 Martin Guy <martinwguy@yahoo.it>

	* configure.ac:
	  Remove duplicate of presence tests for JPEG KDE QT.
	  Say what to install for KDE QT MYSQL.
	* configure.ac macros/kde.m4:
	  Fix broken QT detection on Debian.

2007-03-20 Ann Barcomb <kudra@domaintje.com>

	* server/asobj/gen-asclass.pl: Produces exactly the same output
	  as gen-asclass.sh with some extra features.

2007-03-20 Sandro Santilli <strk@keybit.net>

	* server/builtin_function.h (ctor): add a 'constructor'
	  property pointing to self.
	* testsuite/actionscript.all/LocalConnection.as: add tests
	  for existance of functions that somehow slipped into Gnash.
	* server/as_function.{cpp,h}: add getFunctionConstructor()
	  public static method.
	* server/swf_function.cpp: passing Function as the constructor
	  property of user-defined functions.
	* testsuite/actionscript.all/Function.as: more successes.
	* testsuite/actionscript.all/Inheritance.as: more successes.

2007-03-20 Sandro Santilli <strk@keybit.net>

	* server/as_function.{cpp,h}: add a constructInstance()
	  function taking care of proper ActionScript instances
	  initialization.
	* server/asobj/: Boolean.cpp, Number.cpp, string.cpp
	  (init_{boolean,number,string}_instance): use 
	  the new as_function::constructInstance() method
	  to correctly initialize instances.
	* server/vm/ASHandlers.cpp (construct_object): simply
	  forward the call to as_function::constructInstance().
	* testsuite/actionscript.all/Function.as: more successes.

2007-03-20 Antti Ajanki <antti.ajanki@iki.fi>

	* gui/{kde.cpp, kdesup.h}, plugin/klash/klash_part.cpp: When
	embedding a Gnash into Konqueror, skip window creation. This also
	fixes a problem with scaling.	

2007-03-20 Ann Barcomb <kudra@domaintje.com>

	* doc/C/actionscript/new_as_class.xml: Change documentation to
	  intrusive_ptr (see Sandro's previous commits).

2007-03-20 Sandro Santilli <strk@keybit.net>

	* server/as_value.cpp, server/asobj/Boolean.cpp,
	  server/asobj/Boolean.h, server/asobj/Number.cpp,
	  server/asobj/Number.h, server/asobj/gstring.h,
	  server/asobj/string.cpp: Implement init_boolean_instance
	  and change init_{number,string}_instance to return
	  by intrusive_ptr (rather then auto_ptr).
	  Do automatic boolean to Boolean conversion in as_value::to_object.
	* testsuite/actionscript.all/Function.as:
	  Couple of more successes.

2007-03-20 Sandro Santilli <strk@keybit.net>

	* server/array.cpp, server/as_environment.cpp,
	server/as_function.cpp, server/as_object.cpp,
	server/as_object.h, server/as_value.cpp, server/as_value.h,
	server/button_character_instance.cpp, server/character.cpp,
	server/debugger.cpp, server/edit_text_character.cpp,
	server/shm.cpp, server/sprite_instance.cpp,
	server/sprite_instance.h, server/swf_function.cpp,
	server/swf_function.h, server/textformat.cpp, server/timers.cpp,
	server/timers.h, server/video_stream_instance.cpp,
	server/video_stream_instance.h, server/asobj/Boolean.cpp,
	server/asobj/ContextMenu.cpp, server/asobj/Date.cpp,
	server/asobj/Global.cpp, server/asobj/Key.cpp, server/asobj/Key.h,
	server/asobj/LoadVars.cpp, server/asobj/LocalConnection.cpp,
	server/asobj/MovieClipLoader.cpp,
	server/asobj/NetConnection.cpp, server/asobj/NetConnection.h,
	server/asobj/NetStream.cpp, server/asobj/NetStream.h,
	server/asobj/NetStreamGst.cpp, server/asobj/Object.cpp,
	server/asobj/Sound.cpp, server/asobj/string.cpp,
	server/asobj/xml.cpp, server/asobj/xmlnode.cpp,
	server/asobj/xmlsocket.cpp, server/vm/ASHandlers.cpp,
	server/vm/fn_call.h, server/vm/with_stack_entry.h,
	testsuite/server/GetterSetterTest.cpp:
	Reduce use of "dumb" pointers, using intrusive_ptr instead.
	A side-effect is the player2.swf premature deletion assertion
	is not triggered anymore now.

2007-03-20 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/LocalConnection.as: Fix the test to NOT
	  rely on Gnash extensions. Actually check that the extensions are
	  *not* there, as we want to be compatible !!

2007-03-20 Ann Barcomb <kudra@domaintje.com>

	* server/asobj/Key.cpp, MovieClipLoader.cpp, xml.cpp, xmlnode.cpp,
	  xmlsocket.cpp: Change casts and asserts to ensureType.

2007-03-20 Ann Barcomb <kudra@domaintje.com>

	* server/asobj/ContextMenu.cpp, Date.cpp, LoadVars.cpp, string.cpp,
	  NetConnection.cpp, NetStream.cpp, Sound.cpp, gen-asclass.sh:
	  Changed instances of ensureClass to use inherited ensureType.

2007-03-20 Ann Barcomb <kudra@domaintje.com>

	* doc/C/actionscript/new_as_class.xml: syntax of 'ensure'
	  changed to correspond with Bastiaan's last commit.

2007-03-20 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/as_object.h: Add ensureType<classname>, which is intended to
	replace the class-specific ensureClass functions. Suggested by Ann.
	Demangle the object name in the exception message if GCC >= 3 is being
	used.
	* server/asobj/Boolean.cpp: Switch ensureClass to ensureType.
	* server/vm/ASHandlers.cpp: In ActionDelete(), don't pop an object off
	the AS stack in the hopes that it magically has a property which might
	be the object that is to be deleted. Instead, traverse the stack using
	delVariable().
	* server/as_object.h: Remove the ensureType for raw pointers in favour
	of the one for intrusive pointers; the former is now unused.
	* server/asobj/NetStreamFfmpeg.cpp: Update for changes in ensureType.
	* server/asobj/LocalConnection.cpp: Don't initialise Gnash-only methods
	that were intended for debugging.

2007-03-19 Sandro Santilli <strk@keybit.net>

	* server/as_value.{cpp,h}: simplify union by using
	  a single pointer value, toward using a smart pointer
	  there.
	* testsuite/actionscript.all/Function.as: expect a couple
	  of successes I missed on last commit.

2007-03-19 Ann Barcomb <kudra@domaintje.com>

	* server/as_object.h: corrected Doxygen comments about
	  get_member() versus gettersetter methods.

2007-03-19 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/Function.as: add more tests
	  for 'constructor', '__constructor__' and super.
	  A lot of them fail and the test is still not complete.

2007-03-19 Ann Barcomb <kudra@domaintje.com>

	* doc/C/actionscript/new_as_class.xml: document the changed syntax
	  for returning a value (see Bastiaan's commit).

2007-03-19 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/vm/fn_call.h: Remove fn_call::result. Instead, all methods and
	functions called by ActionScript must return as_value. Thanks to Ann 
	for the suggestion and for help with regular expressions.
	* all over the place: Switch all ActionScript-called methods over to
	return as_value. Adjust all related methods. Also make fn_call::nargs
	unsigned.
	* server/as_value.h: Add additional constructors taking longs as
	arguments to account for platforms that define size types as longs.

2007-03-19 Ann Barcomb <kudra@domaintje.com>

	* doc/C/actionscript.xml, doc/C/actionscript/*, doc/C/Makefile.am:
	  Split main.xml into multiple files.

2007-03-19 Sandro Santilli <strk@keybit.net>

	* server/timers.cpp (timer_setinterval):
	  Accept call in the form setInterval(obj, methodname, timer);
	  warn about unsupported args (right-most arguments).

2007-03-19 Ann Barcomb <kudra@domaintje.com>

	* doc/C/actionscript.xml, doc/C/gnash.xml, doc/C/actionscript/main.xml,
	  doc/C/Makefile.am: ActionScript has been removed from the Gnash
	  manual.  A new ActionScript manual has been created.  Most of
	  material has been rewritten and incorporates Sandro's
	  feedback on the previous version.

2007-03-19 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/ming_utils.h: Add Ming defines available onl
	in CVS; some of the new testcases depend on these. Suggested by
	Benjamin Otte.

2007-03-19 Bastiaan Jacques <bastiaan@bjacques.org>

	* testsuite/actionscript.all/LoadVars.as: Don't assume that the system on
	which testcases are run has a HTTP server running on localhost that meets
	our specifications. Instead, read object property data from a local file
	and update the expected output to match.

2007-03-19 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/action_execution_order_test4.c:
	  add tests about onClipEvent(onConstruct) and user defined onLoad for _root
	  
2007-03-18 Bastiaan Jacques <bastiaan@bjacques.org>

	* testsuite/libamf.all/test_number.cpp: Don't overflow the data buffer.

2007-03-18 Antti Ajanki <antti.ajanki@iki.fi>

	* gui/kde.cpp: Since the GUI callbacks are no longer statics, adjust
	our usage of them to match.

2007-03-17 Sandro Santilli <strk@keybit.net>

	* server/swf_function.cpp (call operator): don't
	  provide 'super' if SWF version is < 6.

2007-03-17 Markus Gothe <nietzsche@lysator.liu.se>

	* libamf/amf.h: Fixed a naming issue on non-GCC.
	* server/asobj/Date.cpp: Fixed namespace-issue for 'trunc'

2007-03-16 Sandro Santilli <strk@keybit.net>

	* server/vm/ASHandlers.cpp: more usage of as_value::to_debug_string().
	* server/as_value.{cpp,h}: add to_debug_string(), have output
	  operator use it.
	* server/as_environment.{cpp,h}: use debugging output for as_values
	  when dumping stack,registers and locals.

2007-03-16  Rob Savoye  <rob@bertha.welcomehome.org>

	* testsuite/libamf.all/string-variable.amf:  Binary test case for
	string variables.
	* testsuite/libamf.all/number-variable.amf: Binary test case for
	numeric variables.
	* testsuite/libamf.all/test_variable.cpp: Test case for encoding
	and decoding variable assignments which as used in AMF objects.
	* libamf/amf.cpp, amf.h: Add support for encoding variables. Make
	extractVariables actually set the fields of the element so they
	have some value when returned.
	
	* libamf/amf.cpp, amf.h: Use capitols for enum values. Fix
	encoding and decoding of numbers, strings, and objects.
	* libamf/rtmp.cpp, rtmp.h: Use capitols for enum values. 
	* libamf/Makefile.am: Remove amftest.cpp, it's now in testsuites
	where it belongs.
	* testsuite/Makefile.am: Add libamf.all directory.
	* testsuite/libamf.all/Makefile.am: Build test cases, do "make
	check".
	* testsuite/libamf.all/test_number.cpp: Test case for AMF numbers.
	* testsuite/libamf.all/test_object.cpp: Test case for AMF objects.
	* testsuite/libamf.all/test_string.cpp: Test case for AMF strings.
	* testsuite/libamf.all/f03f.amf: Binary test file for number format.
	* testsuite/libamf.all/connect-object.amf: Binary test file for
	object format. 
	* testsuite/libamf.all/connect-string.amf: Binary test file for
	string format.

2007-03-16 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/: Function.as, Inheritance.as:
	  Some more tests for __constructor__.
	* server/vm/ASHandlers.cpp (construct_object): set up the
	  undocumented and non-standard __constructor__ member.
	* server/asobj/Object.cpp (object_registerClass): don't forget
	  to return a boolean value !
	* server/sprite_instance.cpp: allow overriding the _name property.
	* testsuite/swfdec/PASSING: more successes.

2007-03-16 Sandro Santilli <strk@keybit.net>

	* server/as_value.{cpp,h}: depreciate operator+=, implement valueOf
	  calling.
	* server/vm/ASHandlers.cpp (ActionNewAdd): pass environment over
	  calls to as_value::to_number, for properly calling valueOf.
	* testsuite/actionscript.all/Number.as: more tests for valueOf
	* testsuite/misc-ming.all/: .cvsignore, Makefile.am:
	  Automate run of the new testcases.

2007-03-16 Zou Lunkai <zoulunkai@gmail.com>

	* tesrttsuite/misc-ming.all/action_execution_order_test4.c.
	* testsuite/misc-ming.all/action_execution_order_test5.c.
	  add 2 more testcases to verify actions execution order.
	  
2007-03-13 Sandro Santilli <strk@keybit.net>

	* server/as_value.h (to_number): null and undefined are converted
	  to NaN for SWF7 up; drop is_inf,is_finite and is_nan methods,
	  handle in the caller.
	* server/asobj/Global.cpp: proved _global.NaN and _global.Infinity
	  values; fix isFinite() and isNaN().
	* testsuite/actionscript.all/Number.as: more tests for the NaN and
	  Infinity values.
	* server/as_value.cpp (to_tu_string): both -0.0 and 0.0 number values
	  get converted to the string "0".
	* testsuite/actionscript.all/Boolean.as: do not expect failures for
	  string to boolean conversion for SWF7 up.
	* server/as_value.cpp (to_bool): have NaN numbers evaluate to
	  false; add version-specific versions to_bool_v5(), to_bool_v6() and
	  to_bool_v7(); add to_std_string_versioned.
	* testsuite/server/: DisplayListTest.cpp, GetterSetterTest.cpp,
	  MatrixTest.cpp, PropertyListTest.cpp, as_prop_flagsTest.cpp: 
	  include check.h last, to avoid 'check' macro to clash with boost
	  headers (ptr_container stuff).
	* server/sprite_instance.cpp: add support for MovieClip.loadVariables.
	* server/Makefile.am, server/LoadVariablesThread.{cpp,h},
	  server/asobj/LoadVars.cpp: extracted what was previously called LoadRequest
	  in LoadVars.cpp, for general use, cleanups.
	* server/vm/ASHandlers.cpp (CommonGetUrl): add support for the
	  loadVariables flag.
	* testsuite/misc-mtasc.all/function.as: add more test for
	  the arguments object.
	* server/vm/ASHandlers.cpp (ActionNewAdd, ActionTrace): pass an environment when
	  converting as_value to string, to properly invoke any toString
	  method.
	* server/character.cpp (parent_getset): _parent is undefined (not
	  null) for _root sprite.
	* testsuite/actionscript.all/String.as: add tests for automatic
	  calling of the toString() method.
	* testsuite/actionscript.all/Function.as: add tests for toString
	  method.
	* server/as_function.h: override get_text_value() to properly return
	  '[type Function]'.
	* server/as_value.cpp (convertion to string): Invoke any toString method
	  associated with objects, if caller properly passes an as_environment
	  to use in the call.
	* testsuite/swfdec/PASSING: many more successes.
	* server/as_value.h: add constructor by const std::string ref.
	* server/vm/VM.{h,cpp}: add getPlayerVersion()
	* server/asobj/System.{h,cpp}: cleanups, use getPlayerVersion()
	  for System.capabilities.version
	* server/sprite_instance.cpp (attachMovieClipProperties): initialize
	  the $version member.
	* testsuite/actionscript.all/MovieClip.as: more tests for the '$version'
	  built-in variable; new test for _parent of root being undefined (not
	  null).
	* server/as_object.{cpp,h}: add a third argument for init_member to
	  override protection (can be omitted to use previous default).
	  
2007-03-13 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/System.as: add checks for $version.
	* testsuite/swfdec/PASSING: 3 more tests succeed.
	* server/sprite_instance.cpp (get_text_value): remove the trailing
	  dot from name of top-level movies.

2007-03-12  John Gilmore  <gnu@toad.com>

	* configure.ac:  Suggest agg-2.5 rather than 2.4 if
	agg_gradient_lut.h is missing.
	* configure.ac:  Sandro's fix to "ming version" test that failed if
	ming was not installed.
	
2007-03-12 Sandro Santilli <strk@keybit.net>

	* server/as_object.cpp (init_member): fix typo setting flags
	  for buiting methods all wrong.
	* testsuite/actionscript.all/delete.as: don't expect the failures
	  on function prototype deletion anymore.
	* server/button_character_instance.{cpp,h}: implement
	  ::construct() to postpone characters instance name assignmnet
	  at stage placement time.

2007-03-12 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* server/character.h: introduce wantsInstanceName() to provide
	  a clean way to tell which objects need an instance name	
	* server/button_character_instance.{h,cpp}: Give childs a name;
	  implement get_relative_target() for buttons; define that
	  buttons should get instance names	
	* server/edit_text_character.h: text fields need instance names
	  too
	* server/sprite_instance.{h,cpp}: implement and use 
	  wantInstancename()
				 

2007-03-12 Sandro Santilli <strk@keybit.net>

	* server/as_prop_flags.h: add equality and inequality operators.
	* testsuite/actionscript.all/delete.as: add test verifying that
	  delete on object references won't affect other references
	  on the same object; add test to check that a user-defined
	  function's prototype is not deletable (fails in Gnash!).
	* server/vm/ASHandlers.cpp (ActionCallFunction, ActionCallMethod,
	  ActionNewMethod): rather then pushing undefined values for
	  missing argument values on the stack, warn about the type of
	  SWF malformation and modify the number of args by using at most
	  what's on the stack.
	* testsuite/swfdec/PASSING: callfunction-stack.swf
	  now succeeds.

2007-03-12 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/asobj/Boolean.cpp: Add ensureBoolean() to guard
	  casts.

2007-03-12 Sandro Santilli <strk@keybit.net>
 
	* testsuite/actionscript.all/Global.as: argh, it
	  seems that _global is a non-Object object :!? 
	* testsuite/swfdec/PASSING: 3 newly added swfdec tests
	  succeed in Gnash.
	* testsuite/misc-ming.all/Makefile.am: activated the
	  new action execution order tests.

2007-03-11 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/action_execution_order_test1.c.
	* testsuite/misc-ming.all/action_execution_order_test2.c.
	* testsuite/misc-ming.all/action_execution_order_test3.c.
	  3 new testcases to verify action execution order.
	  
2007-03-11 Deanna Phillips <deanna>

	* cygnal/stream.cpp: Added #include <unistd.h>

2007-03-10  Rob Savoye  <rob@bertha.welcomehome.org>

	* macros/boost.m4: Only select one library! So please leave the
	break lines in after the libraries are matched in the file
	system. Check for date_time in the same way to handle the weird
	naming of boost libraries.

2007-03-10 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/Makefile.am: 
	  Import Dejagnu.swf from the same dir the SWF is in, to work
	  around player8+ lame security model.
	* server/array.{cpp,h}: provide an override for
	  Object.toString().
	* testsuite/swfdec/PASSING: array.swf now passes.

2007-03-10 Sandro Santilli <strk@keybit.net>

	* testsuite/swfdec/PASSING: expect 5 more successes.
	* testsuite/swfdec/swfdec_gnash_tester: allow 11 advances rather
	  then 10 (this is likely due to Gnash current additional advance
	  required for proper construction of initial stage). Makes 5 more
	  tests from the swfdec testsuite pass (including gotoframe!!).
	* server/sprite_instance.cpp (add_display_object):
	  Only syntetize instance names for sprite instances
	  (fixes swfdec's names.swf testcase).

2007-03-09 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/LoadThread.h: Documented the class.

2007-03-09 Sandro Santilli <strk@keybit.net>

	* testsuite/swfdec/swfdec_gnash_tester: 
	  Fixed to allow loopbacks.

2007-03-09 Stuart Anderson <anderson@netsweng.com>

	* testsuite/misc-ming.all/Makefile.am: fix check rule
	  when building with Ming < 0.4.0-beta2.

2007-03-09 Sandro Santilli <strk@keybit.net>

	* configure.ad: Add MAKESWF_SUPPORTS_PREBUILT_CLIPS conditional.
	* extensions/dejagnu/dejagnu.cpp, extensions/fileio/fileio.cpp:
	  Use builtin_function and init_member for members initialization.
	* server/as_value.{cpp,h}, server/vm/ASHandlers.cpp,
	  server/vm/action.cpp: Drop C_FUNCTION as_value type.
	  WARNING: attempts to initialize as_values with
	  a function pointer will now result in BOOLEAN values !!
	  The compiler will warn you about this, but make sure
	  you enable warnings.
	* server/: sprite_instance.cpp, textformat.cpp,
	  video_stream_instance.cpp, edit_text_character.cpp:
	  Use builtin_function for function as_values.

2007-03-09 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/LoadThread.{h,cpp}: Added implementation of a download thread.
	* libbase/Makefile.am: Included LoadThread.{h,cpp}.
	* libbase/curl_adapter.cpp, libbase/noseek_fd_adapter.cpp, 
	  libbase/tu_file.{h,cpp}, libbase/zlib_adapter.cpp: Removed 
	  get_cur_stream_size(), instead used LoadThread::getBytesLoaded().
	* server/asobj/NetConnection.cpp: Use LoadThread.
	* server/asobj/NetStream.{h,cpp}, server/asobj/NetStreamFfmpeg.{h,cpp},
	  server/asobj/Sound.{h,cpp}, server/asobj/SoundFfmpeg.{h,cpp}: Fixed
	  compilation with newer FFMPEG versions.

2007-03-09 Sandro Santilli <strk@keybit.net>

	* server/asobj/xmlsocket.cpp: use call_method() and call_method0()
	  rather then duplicate its implementation.
	* server/asobj/xml.cpp: use call_method() rather then 
	  duplicate its implementation.
	* server/as_environment.cpp: include index in registers dump.
	* server/vm/ASHandlers.cpp (ActionEnumerate, ActionEnumerate2):
	  Make 'for (i in <non-object-value>)' an ASCODING error.
	* server/: sprite_instance.{cpp,h}, character.{cpp,h}:
	  Moved getNextUnnamedInstanceName() from sprite_instance
	  to character, for use withing other character types
	  (like buttons) and use a single counter for the whole
	  application.

2007-03-09 Sandro Santilli <strk@keybit.net>

	* server/asobj/Object.cpp: remove TESTING
	  warnings for getOwnProperty, isPrototypeOf and
	  isPropertyEnumerable. Warn only once about unimplemented
	  watch and unwatch methods.
	* server/vm/ASHandlers.cpp: warn only once about 
	  Enum2 being in TESTING stage.

2007-03-09 Sandro Santilli <strk@keybit.net>

	* server/as_object.{cpp,h}: add getOwnProperty and prototypeOf()
	  public methods.
	* server/asobj/Object.cpp: implement Object.hasOwnProperty(),
	  Object.isPropertyEnumerable() and isPrototypeOf(); stub
	  Object.watch() and Object.unwatch().
	* testsuite/actionscript.all/Object.as: add tests for
	  Object.hasOwnProperty(), Object.isPropertyEnumerable() and
	  isPrototypeOf(); add TODO note for testing Object.watch()
	  and Object.unwatch().

2007-03-08 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* server/character.h: drop m_enabled since nobody uses it
	* server/button_character_instance.{h,cpp}: add "enabled" property
	  and receive mouse events only when enabled		  

2007-03-08 Bastiaan Jacques <bastiaan@bjacques.org>

	* gui/gtk.cpp: Fix GTK/AGG redrawing upon expose events by switching
	to the new invalidation interface. In this incarnation, only the area
	which is newly exposed is redrawn.

2007-03-08 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* extensions/fileio/fileio.cpp: Fixed fread() 

2007-03-08 Sandro Santilli <strk@keybit.net>

	* server/as_object.h: new protected clearProperties() method.
	* server/sprite_instance.cpp (restart): clear properties.

2007-03-08 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (construct):
	  Ensure first frame is loaded, to eventually not waiting for
	  ::advance to call ::construct and finally remove the startup
	  lateny we're currently experiencing;
	  (restart): call construct() directly, rather then postponing
	  the call to ::adnvace and relying on the crappy
	  m_onload_event_called flag.

2007-03-08 Sandro Santilli <strk@keybit.net>

	* server/character.h: document set_event_hanlder,
	  get_event_handler (as we're getting it wrong).
	* testsuite/actionscript.all/MovieClip.as:
	  Test that the onLoad member of a MovieClip
	  can be set to any value.
	* server/sprite_instance.{h,cpp}: drop unused
	  m_update_frame variable. (restart): simplify
	  and properly reset the displayList backup.

2007-03-08 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/action_execution_order_extend_test.c:
	  Add a check, seems PlaceObject2 tag should not define any functions
	  
2007-03-07 Sandro Santilli <strk@keybit.net>

	* gui/gtk.cpp: hook restart menu
	* server/sprite_instance.cpp (restart): properly
	  clear the displaylist. Invalidated bounds could
	  likely be more fine-tuned.

2007-03-07 Sandro Santilli <strk@keybit.net>

	* gui/gui.{h,cpp}: add play(), pause() and stop() methods,
	  change implementation to be semantically correct and not
	  mess with sprites playstate; Changed menu_* to non-statics
	  to properly acces state. I'm sure this will break fltk but
	  fixing should be easy with men_fun and bind1st..
	* gui/gtk.cpp: enable stop(), pause() and play() menu items.
	* server/asobj/ContextMenu.cpp: Some more stubs.
	* testsuite/actionscript.all/ContextMenu.as: Some more tests.
	* server/as_value.cpp (to_bool) don't choke
	  when converting a movieclip value to a boolean.
	* testsuite/actionscript.all/Boolean.as:
	  Add tests for convertion to boolean value.

2007-03-07 Robert Millan <rmh@aybabtu.com>

	* plugin/plugin.cpp: Guard the first argument to kill() for previously
	unconsidered values.

2007-03-07 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* backend/render_handler_agg.cpp: fixed segfault #19223; set correct
	  visiblerect; fixed Range2d.width() usage; fixed getMaxY() usage
	* extensions/fileio/fileio.{h,cpp}: implemented an experimental 
	  scandir() function (may move to a separate extension); same story
		for unlink()
	* server/sprite_instance.cpp: Make sure clear_invalidated() is called 
	  for sprites which currently have an empty DisplayList
	* server/button_character_instance.{h,cpp}: Implemented correct behaviour
	  on button state change (invalidate only when needed, restart only
		reappeared characters)		 	

2007-03-07 Sandro Santilli <strk@keybit.net>

	* testsuite/swfdec/: README, swfdec_gnash_tester:
	  Initial stuff to hook on swfdec testsuite.

2007-03-06  Rob Savoye  <rob@bertha.welcomehome.org>

	* missing: Update to newer version.
	* mkinstalldirs: Update to newer version.
	* Makefile.am: Add new "olpc" target to cross build RPM using a
	non standard config triplet to force rpmbuild to work correctly,
	since it doesn't support the vendor field. Add macros/incllist
	macros/libslist to EXTRA_DIST. 
	* packaging/redhat/gnash.spec: Add support for cross building
	RPMs.
	* packaging/redhat/rpmrc: Config file for rpmbuild to convert non
	standard config for geode-olpc into a standard i386-olpc-linux
	build, but use the correct cross compiler.
	* plugin/plugin.cpp: Cast away the const for MIME_TYPES_DESCRIPTION.
	* plugin/klash/Makefile.am: Don't build klash.moc, it's built in
	gui now.
	* configure.ac: Remove --enable-fork option, it's unused. Get the
	root directory to look for headers and libraries for a cross build
	from GCC, as the path is different when building RPMs.
	* cygnal/Makefile.am: Fix spelling of noinst_HEADERS.
	* cygnal/README: Fix typo.
	* extensions/Makefile.am: Add support for other directories for
	building a distribution.
	* extensions/gtk2/Makefile.am: Include from gui directory
	too. Don't build test program by default for now.
	* gui/Makefile.am: Add XML to include paths.
	* gui/gnash.cpp: Disable network support for now.
	* gui/gtksup.h: Return the GtkWidget handle of a window.
	* libbase/Makefile.am: PTHREAD_LIBS should always be after
	BOOST_LIBS.
	* libbase/network.cpp: Tweak debug messages. Test for priviledged
	ports. Add support for a blocking select when waiting for a
	connection.
	* macros/boost.m4: Break when the right path is found.
	* macros/ffmpeg.m4: Handle multiple directories with -I when
	setting topdir. Print a warning if avcodec.h is found, but
	avformat.h is not.
	* macros/gnashpkgtool.m4: Don't create an enable option for
	everything, it's confusing.
	* macros/kde.m4: Look in incllist as well as libslist for QT
	headers.
	* testsuite/Makefile.am: Add generic-testrunner.sh to dist_noinst_SCRIPTS.
	* testsuite/misc-ming.all/Makefile.am: Add intervalTest.as to
	EXTRA_DIST.

2007-03-06 Bastiaan Jacques <bastiaan@bjacques.org>

	* backend/render_handler_agg.cpp: Fix an off-by-one error causing
	invalid memory accesses. Use rint() instead of the missing round()
	on OpenBSD 3.9.
	* gui/fltk{.cpp, sup.h, _glue_agg.cpp, _glue_agg.h}: Reimplement AGG
	clipping using the new interfaces.
	* macros/boost.m4: Fix order of lines so that the value of LIBS is
	properly restored. Fixes bug #19211.
	* server/asobj/Date.cpp: Add an implementation (written by Sandro)
	of trunc for platforms that don't define it, e.g. OpenBSD 3.9.

2007-03-06 Sandro Santilli <strk@keybit.net>

	* server/as_value.cpp (to_to_string): positive Infinity 
	  doesn't have the plus sign prepended (at least for SWF5, didn't
	  check with other targets).
	* server/vm/ASHandlers.cpp (ActionCallMethod): properly
	  setup the 'this' pointer when not specified in the tag
	  itself as the object parameter.
	* server/vm/ActionExec.{h,cpp}:
	  Add a _this_ptr member and a getThisPointer() function
	  for use with function calls.
	* server/swf_function.cpp (operator()): setup the this_ptr
	  in ActionExec instance.
	* testsuite/misc-mtasc.all/function.as: unexpect last failure.
	  Looking for more failures now...

2007-03-06 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-mtasc.all/function.as:
	  Add a (succeeding) test for 'this' pointer being correctly set
	  on ActionCallMethod with *defined* name.

2007-03-06 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* libgeometry/snappingrange2d.h: do not call combine_ranges() too 
	  often	

2007-03-06 Sandro Santilli <strk@keybit.net>

	* server/vm/ASHandlers.cpp (ActionCallMethod): when method name
	  is undefined, we must use the provided object's constructor.
	* testsuite/misc-mtasc.all/function.as: add (failing) test for
	  'this' pointer being correctly set on ActionCallMethod.

2007-03-06 Ann Barcomb <kudra@domaintje.com>

	* server/asobj/xmlsocket.cpp: convert init_member to new
	syntax.

2007-03-06 Sandro Santilli <strk@keybit.net>

	* server/as_object.cpp (instanceOf): made circular inheritance an
	  aserror. 
	* testsuite/actionscript.all/Inheritance.as: test circular inheritance
	  detection.
	* server/vm/ASHandlers.cpp (ActionWith): survive empty 'with' blocks.
	* testsuite/actionscript.all/with.as: test empty 'with' block.

2007-03-06 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* backend/render_handler_agg.cpp: Round outline edge anchor points to
	  eliminate anti-aliasing blur and to do it the MM way...; draw outlines 	
	  always with at least 1.0 pixels width
	* libgeometry/snappingrange2d.h: Implement growBy()
	* gui/gui.cpp: grow invalidated ranges by 2 pixels to solve anti-aliasing
	  and outline displacement problems 	

2007-03-06 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-mtasc.all/: Makefile.am, TestClass.as, function.as:
	  Testcase for ActionCallMethod showing the 'this' pointer is not
	  correctly set in Gnash when we lack a method name.
	* server/vm/ASHandlers.cpp (ActionCallMethod): use object as a
	  function when method name is undefined. This makes a step
	  forward with laszlo, altough I'm not sure about wheter
	  the 'this' pointer is correctly set to the function itself.
	* server/debugger.{h,cpp}: use unsigned types for register indexes;
	  properly accept *const* string refs.

2007-03-05 Sandro Santilli <strk@keybit.net>

	* utilities/processor.cpp: don't call gnash::clear, I suspect
	  we're unable to properly cancel loading threads, and this
	  being the cause for the occasional segfaults raising on 
	  'make check' (to be confirmed, hopefully).

2007-03-05 Ann Barcomb <kudra@domaintje.com>

	* server/asobj/xmlnode.cpp: convert init_member to new
          interface.

2007-03-05 Sandro Santilli <strk@keybit.net>

	* server/: character.h, sprite_instance.{h,cpp}:
	  Add character::unload() virtual method to properly unload
	  child elements.
	* server/dlist.cpp: call character::unload() rather then
	  directly invoking the UNLOAD event.
	* testsuite/misc-ming.all/action_execution_order_extend_test.c:
	  Do not expect failures of unload event execution.

2007-03-05 Ann Barcomb <kudra@domaintje.com>

	* doc/C/internals.xml: section 'ActionScript Support' was updated
	  in an attempt to describe the current interface.

2007-03-05 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/action_execution_order_extend_test.c:
	  Add onLoad *clip* event and verify that having the clip event
	  defined triggers actual execution of the the onLoad event
	  for it (even the user-defined one!).
	* libgeometry/snappingrange.h: add visit() templated function.
	* server/parser/movie_def_impl.h, server/parser/movie_definition.h:
	  Document movie_definition::get_bytes_total().
	* testsuite/misc-ming.all/Makefile.am: enable run
	  of action_execution_order_extend_test by 'make check'.

2007-03-05 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/action_execution_order_test.c: Comments fix.
	* testsuite/misc-ming.all/action_execution_order_extend_test.c:
	  A new testcase for testing action execution order.
	  
2007-03-04 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/curl_adapter.cpp: Added support for getting the total size
	  of file being downloaded (get_stream_size()), and the current cached 
	  size (get_cur_stream_size()).
	* libbase/tu_file.{cpp,h}: Added get_size() and get_cur_size() which 
	  uses get_stream_size() and get_cur_stream_size().
	* libbase/noseek_fd_adapter.cpp, libbase/zlib_adapter.cpp: Added dummy
	  support for get_stream_size() and get_cur_stream_size()
	* server/asobj/NetConnection.{cpp,h}: Switched to use StreamProvider
	* server/asobj/NetStream.{cpp,h}, server/asobj/NetStreamFfmpeg.{cpp,h},
	  server/asobj/NetStreamGst.{cpp,h}: Added support for the bytesLoaded 
	  and bytesTotal property.

2007-03-03 Sandro Santilli <strk@keybit.net>

	* server/as_value.h: add ALLOW_C_FUNCTION_VALUES to prepare
	  for dropping C_FUNCTION value types as a whole. Undefine
	  it to make finding bogus uses easier and finish the
	  work in asobj/.
	* server/asobj/: MovieClipLoader.cpp, Number.cpp, Object.cpp,
	  Selection.cpp, SharedObject.cpp, Sound.cpp, Stage.cpp,
	  System.cpp, TextSnapshot.cpp, Video.cpp, xml.cpp:
	  Use builtin_function when initializing methods.
	* server/asobj/: Boolean.cpp, Camera.cpp, Color.cpp,
	  ContextMenu.cpp, CustomActions.cpp, Date.cpp, Error.cpp,
	  Global.cpp, Key.cpp, gLoadVars.cpp, LocalConnection.cpp,
	  Math.cpp, Microphone.cpp, Mouse.cpp, NetConnection.cpp,
	  NetStream.cpp:
	  Use builtin_function when initializing methods.

2007-03-03 Sandro Santilli <strk@keybit.net>

	* server/as_value.{cpp,h}: always check for real type
	  of an as_object to properly set type to AS_FUNCTION
	  for actual as_function instances. always check
	  for NULL pointers to properly set type to NULLTYPE.
	  Fixes latest tests in Function.as.
	* server/: as_object.h, as_function.h:
	  Add virtual to_function() method to reduce RTTI use.
	* testsuite/actionscript.all/Function.as:
	  Test using 'this' as a constructor. Doesn't currently
	  work becase the 'this' as value is initialized to be
	  of kind OBJECT rather then AS_FUNCTION (as_value constructor
	  by as_object doesn't check real type).

2007-03-03 Martin Guy <martinwguy@yahoo.it>

	* server/as_value.cpp: More conservative version of NAN fixes.
	* testsuite/actionscript.all/Date.as: Check for Date.UTC() existing
	  and working even before a Date object is instantiated.

2007-03-03 Bastiaan Jacques <bastiaan@bjacques.org>

	* gui/gtk.cpp: Don't neglect to render the buffer for renderers other
	than AGG.
	* gui/fltk.cpp: Invalidate the whole drawing area, which now appears
	to be a requirement for Agg when we choose not to let the GUI deal with
	clipping.
	* gui/sdl_agg_glue.cpp: Idem dito.

2007-03-03 Martin Guy <martinwguy@yahoo.it>

	* server/as_value.cpp: Revert "NaN" change: it makes all GUI canvasses
	  0-sized (!)
	* server/asobj/XMLNode.cpp: Fix garbled code in {previous,next}Sibling

2007-03-03 Martin Guy <martinwguy@yahoo.it>

	* testsuite/actionscript.all/Number.as: Add test for unary minus
	* testsuite/actionscript.all/Date.as: Turn "date" temp var into "d" 
	* testsuite/actionscript.all/TODO: Check result of call to undefined fn
	* server/as_value.cpp: Return NAN for bad arguments
	* server/asobj/Date.cpp: Fix compiler warning
	* server/asobj/xmlnode.cpp: Remove unused vars, highlight 2 bugs
	* server/asobj/xml.cpp: Remove unused vars, reproduce commentary
	* server/asobj/shape.cpp: Highlight possible bug
	* backend/render_handler_ogl.cpp: Removed unused variables
	* gui/gtk.cpp: Fix compiler warning signed/unsigned

2007-03-02 Sandro Santilli <strk@keybit.net>

	* server/as_environment.{cpp,h}, server/swf_function.cpp:
	  Registers must also be stacked between function calls,
	  like local vars.
	  With this commit I put local registers, local variables
	  and a function pointer into a CallFrame struct
	  and stack that directly. pushCallFrame() and popCallFrame()
	  now replace the add_frame_barrier/set_local_frame_top things.
	  This commit fixes the testcase under misc-mtasc.all !
	* server/vm/ASHandlers.cpp (ActionVar):
	  Ignore local variable declarations in non-function
	  context, and make it an aserror.
	* server/vm/ASHandlers.cpp (ActionNew): add missing
	  premature return on malformed SWF.
	* server/debugger.{cpp,h}: proxy local variables and
	  registers dumping to as_environment funx.

2007-03-02 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* testsuite/libgeometry/snappingrangetest.cpp: Testcase for snapping 
	  ranges
	* libgeometry/snappingrange.h: drop DSOLOCAL
			
2007-03-02  Rob Savoye  <rob@bertha.welcomehome.org>

	* macros/libslist: Add /usr/X11/lib, without the usual R6.
	* macros/incllist: Add /usr/X11/include, without the usual R6.

2007-03-02 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-mtasc.all/inheritance.as:
	  Add more tests, more failing !

2007-03-01 Sandro Santilli <strk@keybit.net>

	* server/vm/ASHandlers.cpp (ActionNewMethod):
	  Use object parameter as *the* function if method name is
	  undefined; check that the constructor is actually a function;
	  (ActionNew) check that the constructor is actually a function;
	  (constructor_object) assert that the constructor is a function.
	* testsuite/misc-mtasc.all/inheritance.as:
	  Add test provided by P T Withington for debugging
	  problems with OpenLaszlo foundation classes.

2007-03-01 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetConnection.cpp: Added support for relative path.
	* server/asobj/NetStreamFfmpeg.cpp: include sound_handler.h.

2007-03-01 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* server/video_stream_instance.cpp: simplify add_invalidated_bounds()
	* libgeometry/snappingrange.h: Clarify comment; use initialization list
	  in constructor; some minimal changes
	* backend/render_handler.h, libgeometry/snappingrange.h: fixed some compiler 
	  warnings
	* server/gnash.h, server/types.cpp: introducing cxform::is_invisible()
	* server/sprite_instance.cpp: treat cxform.alpha==0 like !m_visible	 		
	
2007-03-01 Zou Lunkai <zoulunkai@gmail.com>

	* server/dlist.cpp: keep function declaration consistent with the headfile;
	  libamf/amf.cpp: typos, get rid of warnings for vc8 compiler.
	
2007-03-01 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/: array.as, Function.as
	  Don't expect failures when checking for missing
	  apply/call in SWF5.
	* server/as_function.cpp (getFunctionPrototype):
	  Don't register 'apply' and 'call' members if
	  SWF < 6; use builtin_function when registering them.
	* testsuite/actionscript.all/String.as:
	  Add test for 'substring' with base == length;
	  Fix test for SWF5 (no Function.call or Function.apply
	  there)
	* server/vm/ASHandlers.cpp (ActionGotoExpression):
	  Simplified function, reduced emitted warnings;
	  (ActionSubString): fix case in which base is == length.
	* server/asobj/Global.cpp: register Stage object always.
	* server/asobj/Stage.cpp: don't register addListener
	  and removeListener if SWF < 6.
	* testsuite/actionscript.all/Stage.a: update after fix.

2007-02-28 Sandro Santilli <strk@keybit.net>

	* libgeometry/Range2d.h (scale): allow the scaled range to be
	  monodimensional in any direction.
	* gui/gui.cpp: removed extra tokens at end of #include directive.
	* libgeometry/snappingrange.h: strip CRs, fix contains(), copyright
	  notice and doxygen formatting.
	* testsuite/DummyCharacter.h: update to add_invalidated_bounds
	  (would not need if character provided a default implementation :)

2007-02-28 Udo Giacomozzi <udo.gnu@nova-sys.net>

  * backend/render_handler.h, 
    gui/fb.cpp, gui/fbsup.h, gui/gtk.cpp, gui/gtksup.h, gui/gui.cpp, 
		gui/gui.h,
    server/button_character_instance.cpp,  
    server/button_character_instance.h,    
    server/character.cpp,                  
    server/character.h,                    
    server/dlist.cpp,                      
    server/dlist.h,                        
    server/edit_text_character.cpp,        
    server/edit_text_character.h,          
    server/generic_character.cpp,          
    server/generic_character.h,            
    server/movie_root.cpp,                 
    server/movie_root.h,                   
    server/render.cpp,                     
    server/render.h,                       
    server/sprite_instance.cpp,            
    server/sprite_instance.h,              
    server/video_stream_instance.cpp,      
    server/video_stream_instance.h: replace single invalidated bounds
		with new, abstract InvalidatedRanges class and 
		add_invalidated_range() function to support multiple ranges.		    
	* gui/gtk_glue_agg.cpp: corrected calculation of width/height      
  * backend/render_handler_agg.cpp: Redesigned and optimized rendering 
   	engine; avoid re-calculation of edges for sub-shapes; re-use AGG 
		paths; initialize AGG styles only once
	* libgeometry/snappingrange.h, libgeometry/Makefile.am: new class
	  for 2D range lists
	* testsuite/MovieTester.cpp: Adapted to work with multiple ranges
	* testsuite/misc-ming.all/loadMovieTestRunner.cpp: add return value		    
        
  
2007-02-28 Sandro Santilli <strk@keybit.net>
  
	* testsuite/: Makefile.am, DummyCharacter.h:
	  Dummy character instance for use in test cases.
	* testsuite/server/: Makefile.am, DisplayListTest.cpp:
	  Initial test for DisplayList (just tests equality
	  and inequality operators).
	* server/dlist.{cpp,h}: Add equality, inequality
	  and output operators.

2007-02-28 Sandro Santilli <strk@keybit.net>

	* server/array.cpp: use builtin_method for builtin
	  methods :) ensure the 'this' pointer passed
	  to builtin methods is valid.
	* testsuite/actionscript.all/array.as:
	  Add test for calling Array builtin functions 
	  using FUnction.call.

2007-02-28 Sandro Santilli <strk@keybit.net>

	* server/asobj/gen-asclass.sh: updated to
	  use new, more robust and more correct layout.
	* server/asobj/string.cpp: robustness and
	  correctness improvements: use builtin_function,
	  not c_function for buildin methods; make sure
	  methods are applied to a String instance.
	* testsuite/actionscript.all/String.as: add a
	  test for builtin methods being allowed to be
	  called using Function interface
	  (String.prototype.slice.call: just a small example)

2007-02-28 Sandro Santilli <strk@keybit.net>

	* server/vm/ASHandlers.cpp: use log_aserror for
	  ActionScript errors; (ActionExtends): check
	  that the thing being extended is a function !!

2007-02-28 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/String.as: add
	  test for read-only nature of 'length' property;
	  fix test for SWF5 target.

2007-02-28 Sandro Santilli <strk@keybit.net>

	* server/swf.h: add reference to ActionConstantPool
	  description
	* server/parser/action_buffer.h (read_int16):
	  Use int16_t type, not 'int'.
	* server/parser/action_buffer.cpp (process_decl_dict):
	  Use int16_t type, not 'int'.
	* server/vm/ActionExec.{cpp,h} (operator()):
	  Additional SWF consistency check for action 'length'
	  field.

2007-02-28 Sandro Santilli <strk@keybit.net>

	* server/vm/ActionExec.{cpp,h}: Survive malformed
	  SWF containing 
	* server/as_function.cpp: fix Function.apply()
	  and Function.call() to correctly fetch  the
	  'this' pointer (ie: not accessing the stack
	  directly).
	* server/swf_function.{h,cpp}: properly setup
	  the 'arguments' variable at dispatch time.
	* testsuite/actionscript.all/Function.as:
	  Test the 'arguments' variable in function context.
	* server/array.{cpp,h}: allow resize trough
	  setting the 'length' property.
	* testsuite/actionscript.all/array.as: test
	  that arrays 'length' is settable.

2007-02-28 Markus Gothe <nietzsche@lysator.liu.se>

	* server/asobj/Date.cpp: #define NAN (0.0/0.0) as this is not comp.
	  with C++98 and non-GCC compilers borks.
	* gui/gtk.cpp: Added '//' before commentary.

2007-02-27 Martin Guy <martinwguy@yahoo.it>

	* server/asobj/Date.cpp: Implement Date.UTC(). It is not yet
	  initialised properly (Date.UTC() still gives undefined)
	* testsuite/actionscript.all/Date.cpp: Test Date.UTC()
	* server/asobj/Global.cpp: remove oxbow code.
	* server/asobj/Global.cpp: bugfixen: log_aserror is (now?) printf-like
	* server/asobj/string.cpp: bugfixen: log_aserror is (now?) printf-like

2007-02-27 Sandro Santilli <strk@keybit.net>

	* libgeometry/Range2d.h: add contains(Range2d) method.
	* testsuite/libgeometry/Range2dTest.cpp: Add tests for 'contains'.

2007-02-27 Sandro Santilli <strk@keybit.net>

	* backend/Makefile.am, backend/sound_handler.h,
	  backend/sound_handler.cpp, backend/sound_handler_gst.h,
	  backend/sound_handler_sdl.h, extensions/Makefile.am,
	  gui/Player.cpp, gui/Player.h, gui/gtk.cpp, gui/gui.cpp,
	  server/Makefile.am, server/button_character_instance.h,
	  server/gnash.h, server/impl.cpp, server/impl.h,
	  server/mouse_button_state.h, server/sound.cpp, server/sound.h,
	  server/sprite_instance.cpp, server/asobj/Sound.cpp,
	  server/asobj/SoundFfmpeg.cpp, server/asobj/SoundGst.cpp,
	  server/asobj/SoundMad.cpp, server/parser/Makefile.am,
	  server/parser/button_character_def.cpp,
	  server/parser/button_character_def.h,
	  server/parser/movie_def_impl.cpp,
	  server/parser/sound_definition.cpp,
	  server/parser/sound_definition.h, server/swf/tag_loaders.cpp,
	  server/vm/ASHandlers.cpp, server/vm/action.cpp,
	  testsuite/Makefile.am, testsuite/MovieTester.cpp,
	  testsuite/MovieTester.h, testsuite/sound_handler_test.h,
	  testsuite/actionscript.all/LoadVars.as,
	  testsuite/misc-ming.all/Makefile.am,
	  testsuite/misc-mtasc.all/hello.as,
	  testsuite/movies.all/Makefile.am, testsuite/samples/Makefile.am:
	  Files scramble. sound_handler has now it's own header, sound.{cpp,h}
	  has been moved to parser/sound_definition.{cpp,h}.

2007-02-26 Markus Gothe <nietzsche@lysator.liu.se>

	* extensions/fileio/Makefile.am: Added {PTHREAD,BOOST}_CFLAGS

2007-02-26 Sandro Santilli <strk@keybit.net>

	* server/impl.cpp, server/swf/tag_loaders.{cpp,h}:
	  Add support for IMPORTASSETS2 (an SWF8 tag).

2007-02-26 Sandro Santilli <strk@keybit.net>

	* server/parser/sprite_definition.h: don't check 
	  for movie definition being NULL as we're not allowing
	  this anymore.
	* server/parser/sprite_definition.cpp (ctor) *require*
	  a movie_definition as we'll need it for a few things,
	  including getVersion..
	* server/generic_character.h: store character_def
	  by intrusive_ptr !
	* server/sprite_instance.{cpp,h}: new add_textfield method;
	  fix add_empty_movieclip to provide a movie_definition to
	  sprite-definition constructor; handle dynamic sprites
	  when calling getBytestLoaded/getBytesTotal.

2007-02-26 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/Inheritance.as:
	  a couple of additional tests for accessing
	  a function's prototype after a call to
	  'extends'.
	* testsuite/misc-ming.all/RollOverOutTest.c: don't
	  use Ming-specific 'gotoFrame' ActionScript syntax.
	* testsuite/misc-ming.all/gotoFrame2Test.as: don't
	  use Ming-specific 'gotoFrame' ActionScript construct.
	  With newer Ming versions (0.4.0.beta4 up) the gotoAndPlay()
	  call will be converted to GOTOFRAME2 nonetheless.
	* server/vm/ASHandlers.cpp (ActionGotoExpression:
	  Frame are 1-based when referred to by Flash coders.
	* testsuite/samples/Makefile.am: 
	  Enabled run of GotoAndPlayTest.swf self-contained
	  testcase.

2007-02-26 Sandro Santilli <strk@keybit.net>

	* server/parser/morph2_character_def.cpp (display):
	  survive malformed SWF (mismatching number of paths
	  or edges in start and end shape); (read): warn
	  about malformed swf. Fixes bug #19085.

2007-02-26 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-mtasc.all/: Makefile.am, inheritance.as:
	  Test inheritance using MTASC.
	* server/swf_function.cpp: 'super' in function2 register is now
	  tested, don't warn anymore.

2007-02-25 Sandro Santilli <strk@keybit.net>

	* libbase/URL.cpp (encode,decode): support ' ' <=> '+' conversion.
	* server/asobj/LoadVars.cpp: add support for LoadVars.sendAndLoad().

2007-02-25 Sandro Santilli <strk@keybit.net>

	* libbase/curl_adapter.cpp: implemented seek_to_end 
	  for curl-based stream.
	* server/as_object.cpp (enumerateProperties):
	  Fix wrong 'this_ptr' send to PropertyList::enumerateKeyValue()

2007-02-25 Sandro Santilli <strk@keybit.net>

	* libbase/URL.{cpp,h}: add encode() and decode()
	  public static functions.
	* server/asobj/Global.cpp (escape/unescape):
	  Use URL::encode and URL::decode.

2007-02-25 Sandro Santilli <strk@keybit.net>

	* server/PropertyList.{cpp,h}: add
	  enumerateKeyValue() method; renamed
	  enumerateValues to enumerateKeys (makes more sense).
	* server/as_object.{cpp,h}:
	  add enumerateProperty() overloaded function to 
	  write properties to a std::map
	* testsuite/server/PropertyListTest.cpp: add
	  test for enumerateKeyValue().

2007-02-25 Sandro Santilli <strk@keybit.net>

	* server/asobj/NetConnection.{cpp,h}:
	  Allow build w/out libcurl.
	* extensions/fileio/Makefile.am: fix
	  'make check' and 'make dist' rules.
	* server/asobj/LoadVars.cpp: implemented
	  LoadVars.loaded property.
	* testsuite/actionscript.all/LoadVars.as:
	  Test LoadVars.loaded.

2007-02-25 Markus Gothe <nietzsche@lysator.liu.se>

	* macros/libslist: Check in lib32 before lib64.
	* utilities/processor.cpp: Fixed optopt as extern ifndef _GNUC_
	* macros/boost.m4: Generic approach to test date-time.
	* testsuite/libbase/Makefile.am: Fixed $(NULL)-bug.
	* server/asobj/Date.cpp: Removed extra ; thus letting gcc compile
	  it with -pedantic.
	* libbase/embedVideoDecoder.h: Removed errornous ','.
	* server/asobj/LoadVars.cpp: Fixed "LoadVars.cpp:160: error: ISO C++ 
	  forbids variable-size array 'buf'"
	* server/asobj/Number.cpp: \%s -> %s.

2007-02-24 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/Math.as:
	  Fix testcase to reflect actual behaviour when SWF target
	  version is < 7.
	* server/asobj/LoadVars.cpp: 
	  Made code more robust, and hopefully also cleaner.
	* utilities/processor.cpp:
	  Fix waitforadvance handling. Wait 5 seconds before
	  kicking movie to next frame. This allows for testing
	  intervals and similar time-dependent features.
	* testsuite/actionscript.all/LoadVars.as:
	  Add test for LoadVars.load, LoadVars.getBytesTotal,
	  LoadVars.getBytesLoaded and LoadVars.onLoad.

2007-02-23 Sandro Santilli <strk@keybit.net>

	* server/asobj/LoadVars.cpp: 
	  Use Timers to avoid premature deletion
	  of the LoadVars object while it's loading
	  threads are still alive.

2007-02-23 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* configure.ac: Fix some minor typos

2007-02-23  Rob Savoye  <rob@ute.welcomehome.org>

	* configure.ac: Add --with-pixelformat=option to set the AGG pixel
	format via the command line to override the defaults if
	desired. Exit if one of the values for --with-pixelformat is
	bogus.

2007-02-23 Sandro Santilli <strk@keybit.net>

	* testsuite/media/: vars.txt, vars2.txt: data
	  files for use with LoadVars and loadVariables
	  tests.
	* server/as_function.h: add a call() function
	  to make operator() calls nicer when having
	  an as_function pointer.
	* server/asobj/LoadVars.cpp: implement getBytesLoaded,
	  getBytesTotal, onLoad and onData events, load() method.
	* server/StreamProvider.{cpp,h}: turn into
	  a singleton, add getStream() version taking
	  post data.
	* server/impl.cpp: use the StreamProvider singleton.

2007-02-23 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* backend/render_handler_agg.cpp: Use PIXELFORMAT_xxx defines
	  introduced by Rob		  

2007-02-22  Rob Savoye  <rob@ute.welcomehome.org>

	* configure.ac: Set the pixel type when using AGG for better
	efficiency by looking at the GUI type. Print out MySQL paths if
	extensions are enabled. Don't build klash if KDE isn't found.

2007-02-22 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* server/sprite_instance.cpp: Respect m_old_invalidated_bounds even 
	  when invisible. 	

2007-02-22 Sandro Santilli <strk@keybit.net>

	* libbase/curl_adapter.cpp:
	  Use a member to store post data, as it
	  needs a longer lifetime for libcurl to work.
	* testsuite/libbase/Makefile.am:
	  Don't run CurlStreamTest by 'make check'
	  as it's not ready for automatic testing.
	* testsuite/libbase/CurlStreamTest.cpp: 
	  Turn the test into a tool supporting POST
	  operations (for manual testing it).

2007-02-22 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* backend/sound_handler_gst.cpp: Removed the use of ffdec_mp3 since
	  it isn't recommended by gstreamer. Added warnings if the used
	  version of the fluendo-mp3-plugin is too low.

2007-02-22 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* backend/render_handler_agg.cpp, backend/render_handler_agg_style.h:
	  Switched to pre-multiplied pixel values. Fixes some anti-aliasing
	  issues and improves rendering performance, especially for gradients.
	* backend/render_handler_agg.cpp:
	  Avoid re-initialisation of AGG path class inside for-loop.
	* extensions/fileio/fileio.cpp: Fixed fgets() to avoid segfaults;
	  call fclose() in destructor to close file descriptor in any case.
	* server/movie_root.h: Provided write access for m_timer
	* gui/fb.cpp: Update global timer to make getTimer() work
	  at least with the FB GUI        

2007-02-22 Sandro Santilli <strk@keybit.net>

	* libbase/curl_adapter.{cpp,h}:
	  Add support for http POST (untested).

2007-02-21 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/Makefile.am:
	  Define MEDIADIR
	* testsuite/actionscript.all/check.as:
	  Provide MEDIA() macro to easy access to
	  paths in testsuite/media directory.

2007-02-21 Sandro Santilli <strk@keybit.net>

	* libbase/log.{cpp,h}: add log_debug and used
	  for GNASH_REPORT_FUNCTION.
	* server/asobj/Global.cpp, server/vm/ASHandlers.cpp:
	  Changed trace() function to use log_trace.

2007-02-21 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* backend/sound_handler_{gst,sdl}.cpp: Removed newline from warnings, and 
	  added more user help.
	* macros/ffmpeg.m4: Yet another go at bug #16663.

2007-02-21 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* configure.ac, macros/ffmpeg.m4: Another go at bug #16663.
	* backend/sound_handler_gst.cpp: Added warnings when using fluendos
	  mp3 plugin for gstreamer, since it doesn't support soundstreams.

2007-02-21 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (do_actions): report actions
	  execution with -va.
	* server/vm/ASHandlers.cpp: Store number of arguments
	  into an unsigned integer. Fixes an abort with a malformed
	  SWF.
	* testsuite/misc-ming.all/eventSoundTest1-Runner.cpp:
	  Don't expect failures anymore !

2007-02-21 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* configure.ac, macros/ffmpeg.m4: Output warning when old ffmpeg-version
	  detected. Will hopefully fix bug #16663.
	* gui/Player.cpp: Set the soundhandler to NULL when shutting down, Will
	  hopefully fix bug #18545.
	* server/asobj/NetStreamFfmpeg.cpp, server/asobj/SoundFfmpeg.cpp,
	  server/asobj/SoundMad.cpp: Disconnect cleanly from the soundhandler,
	  if it exists.
	* server/sound.{cpp,h}: Made sound_stream_tag into a state tag.
	* testsuite/sound_handler_test.cpp: Increment the counting variables
	  stopped_all and started_all.

2007-02-21 Sandro Santilli <strk@keybit.net>

	* server/Makefile.am,
	  server/swf/DefineFontAlignZonesTag.{cpp,h}:
	  Initial implementation of DefineFontAlignZones
	  tag loader (unfinished).
	* server/impl.cpp: use unfinished loader for
	  DEFINEFONTALIGNZONES.
	* server/stream.h: add skip_to_tag_end() method.

2007-02-21 Sandro Santilli <strk@keybit.net>

	* server/font.{cpp,h}, server/impl.cpp,
	  server/swf/tag_loaders.{cpp,h}:
	  Add support for DEFINEFONT3 tag (not much done,
	  as Alexis report it to be equal to DEFINEFONT2 
	  in definition - needs support of DEFINEALIGNZONES
	  tag to be fully supported.

2007-02-21 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, gotoFrame2Test.as:
	  Stubbed Udo's test as Ming source and build rule and test runner.

2007-02-21 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* testsuite/samples/GotoAndPlayTest.{as,swf}: Testcase for
	  gotoAndPlay() bug  

2007-02-21 Sandro Santilli <strk@keybit.net>

	* server/sound.{h,cpp}: made start_sound_tag a "state"
	  tag. This seems to fixes eventSoundTest1.swf, altoguth
	  it's runner still fails (a bug in the tester, most likely).
	* testsuite/misc-ming.all/DrawingApiTestRunner.cpp:
	  Fixed input filename (sorry guys).

2007-02-20 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (get_topmost_mouse_entity):
	  Check also drawable bounds !
	* testsuite/misc-ming.all/DrawingApiTestRunner.cpp: 
	  Don't expect failure with filled shapes making 
	  the MovieClip grab mouse envets. Add another test
	  showing that non-filled shapes (simple lines) still
	  fail in this.

2007-02-20 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (get_invalidated_bounds):
	  Include bounds of drawable instance.
	* server/vm/with_stack_entry.h: add non-const
	  version of object() accessor.
	* server/vm/ActionExec.{cpp,h}: add getTarget()
	  method to properly set "this" pointer for function
	  calls.
	* server/vm/ASHandlers.cpp (ActionCallFunction):
	  Properly set the "this" pointer by fetching it
	  from ActionExec "thread" (looks in 'with' stack).

2007-02-20 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/with.as: add test for function
	  call in 'with' context (fails!).
	* testsuite/misc-ming.all/eventSoundTest1-Runner.cpp:
	  Fix input filename; expect the failures (we'll be happy
	  to see XPASS messages :)

2007-02-20 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/gnash.h: Added support for the new test-soundhandler.
	* testsuite/sound_handler_test.{h,cpp}: Added. A soundhandler for 
	  testing gnash.
	* testsuite/Makefile.am: Added the new test-soundhandler.
	* testsuite/MovieTester.{cpp,h}:  Added support for the new 
	  test-soundhandler.
	* testsuite/misc-ming.all/{eventSoundTest1.c,eventSoundTest1-Runner.cpp}:
	  Added. Tests simple event sounds.
	* testsuite/misc-ming.all/Makefile.am: Added the eventSoundTest1 
	  testcase and its runner.
	* testsuite/media/sound1.mp3: Added. Used in the eventSoundTest1
	  testcase.

2007-02-20 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: DrawingApi.as => DrawingApiTest.as,
	  DrawingApiTestRunner.cpp, Makefile.am:
	  Add a runner for DrawingApi test (failing).

2007-02-20 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am,
	  RollOverOutTest-Runner.cpp, root_stop_testrunner.cpp:
	  Allow run of test runners from external dirs.
	* configure.ac: report failign gstreamer detection
	  to refer to failign 0.10 or higher gstreamer 
	  detection.
	* testsuite/simple.exp: have CR also break lines.
	* testsuite/misc-ming.all/attachMovieTestRunner.cpp:
	  Oops, SWF6 is converting stuff to lowercase, so
	  we need to get_member( "mousedown"/"mouseup" )
	  rather then "mouseDown"/"mouseUp".
	  Don't expect a failure anymor ! :)

2007-02-20 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/attachMovieTest.c:
	  print instance name on mouse down/up events.
	* server/button_character_instance.cpp (on_button_event):
	  survive on unhandled event handler. 
	* server/character.{cpp,h}: add getter_setter for
	  onMouseDown, onMouseUp and onMouseMove; add has_mouse_event()
	  method.
	* server/movie_root.{cpp,h}: 
	  Add mouse listeners. Change key listeners to use std::set
	  (more appropriate) and to use intrusive_ptr (safer);
	  Notify mouse listeners on move and click events, don't
	  duplicate notification on *active* entity as these events
	  (mouse up,down,move) are not restricted to entity under the
	  mouse.
	* server/sprite_instance.{cpp,h}: (on_event): if a builtin
	  handler is invoked, don't go look for functions; register
	  as a mouse listener if have mouse event handlers.

2007-02-20 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* extensions/fileio/fileio.cpp: Fixed some compiler warnings 

2007-02-19 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: attachMovieTest.c,
	  attachMovieTestRunner.cpp:
	  Add onMouseDown and onMouseUp handlers to
	  exported symbol. Confirms bug #19040.

2007-02-19  Rob Savoye  <rob@bertha.welcomehome.org>

	* macros/boost.m4: Tweak patch for bug #18788 to work when cross
	configuring.

2007-02-19 Wil Mahan <wmahan+gnu@gmail.com>

	* configure.ac, macros/boost.m4: add check for libboost-date-time
	  (see bug #18788).

2007-02-19 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* macros/ffmpeg.m4: The minimum LIBAVCODEC_VERSION is now 51.11.0.
	  Also we can now handle if VP6 (FFMPEG_VP6) or avcodec_decode_audio2() 
	  (FFMPEG_AUDIO2) is not supported by the used version of ffmpeg.
	* backend/sound_handler_sdl.cpp: Added support for FFMPEG_AUDIO2
	* libbase/embedVideoDecoderFfmpeg.cpp: Made use of the constructor and
	  deconstructor. Added support for FFMPEG_VP6.
	* libbase/embedVideoDecoderGst.cpp: Made use of the constructor and
	  deconstructor.
	* server/asobj/NetStreamFfmpeg.cpp: Added support for FFMPEG_AUDIO2.
 	* server/asobj/Sound.cpp: Use the supplied name when searching for exports.
	* server/asobj/SoundFfmpeg.cpp: Added support for FFMPEG_AUDIO2.
	  Made the deconstructor work better.
	* server/asobj/SoundGst.cpp: Made the deconstructor work better.

2007-02-19 Sandro Santilli <strk@keybit.net>

	* server/: DynamicShape.{cpp,h}, sprite_instance.{cpp,h}:
	  Implement beginFill() and endFill()
	* testsuite/misc-ming.all/DrawingApi.as: non-automatic
	  source for testing the drawing api. Feel free to add
	  calls there :)

2007-02-19 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* server/fill_style.h: add missing return type
	* gui/fb.cpp: add support for eGalax/eTurbotouch touchscreens;
	  use persistent buffer for PS/2 mice also     

2007-02-19 Sandro Santilli <strk@keybit.net>

	* server/fill_style.{cpp,h}: add setSolid() method.

2007-02-19 Sandro Santilli <strk@keybit.net>

	* server/parser/shape_character_def.{h,cpp}: removed calls
	  for dynamic drawing. Use DynamicShape instead.
	* server/: Makefile.am, DynamicShape.{cpp,h}:
	  New subclass of shape_character_def to abstract dynami drawing
	* server/sprite_instance.{cpp,h}:
	  Implement lineStyle, moveTo, lineTo methods of MovieClip
	  class. This works by maintaining a DynamicShape member.
	* server/parser/BitmapMovieDefinition.{cpp,h}: use
	  a DynamicShape rather then a shape_character_def.

2007-02-19 Sandro Santilli <strk@keybit.net>

	* server/shape.{cpp,h}: new empty() and close()
	  methods.

2007-02-18  Rob Savoye  <rob@bertha.welcomehome.org>

	* plugin/.klash/Makefile.am: Install klashpartui.rc,
	klash_part.desktop, and pluginsinfo in their correct
	directories. bug #190821.

2007-02-17 Sandro Santilli <strk@keybit.net>

	* server/parser/shape_character_def.{cpp,h}:
	  Changed signature of add_fill_style and
	  add_line_style to take into account reuse
	  of existing styles and to abstract offset
	  semantic (1-based).
	* server/parser/BitmapMovieDefinition.cpp:
	  Update call to add_fill_stle; don't make
	  assumption about offset of the newly added
	  style.

2007-02-16 Martin Guy <martinwguy@yahoo.it>

	* doc/C/sources.xml: Correct Debian dev package names.
	* server/asobj/Date.cpp: Remove commentary copied from sephiroth;
	  it was lifted straight from MacroMedia copyright material
	  (see http://www.brajeshwar.com/reference/as2)
	* server/asobj/Date.cpp: Document incompatabilities with FlashPlayer.
	* server/asobj/Math.cpp: Remove unused and duplicate code.
	* server/asobj/Math.cpp: Don't abort on missing args; return NAN
	* testsuite/actionscript.all/Math.as: Add test suite for Math methods.
	* testsuite/actionscript.all/Makefile.am: Add Math.as to tests to run.

2007-02-16 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/consecutive_goto_frame_test.c:
	  Visually trace action execution, use C-style comments.
	* server/sprite_instance.cpp (advance_sprite):
	  always update oldDisplayList, not only when in PLAY state !
	* testsuite/misc-ming.all/action_execution_order_test.c:
	  Check UNLOAD being called only *once* (proper management
	  of oldDisplayList).

2007-02-16 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/consecutive_goto_frame_test.c:
	  reduce frame rate to 1 frame per second.
	  Shows that all actions (up to the final stop) are
	  executed at the first advancement (are *supposed* to work like that)
	* server/sprite_instance.cpp (add_display_object):
	  don't check for "events" match when comparing existing
	  char at given depth. Fixes move_object_test.swf.
	* testsuite/misc-ming.all/: Makefile.am, move_object_test.c:
	  Test unnamed instances handling on restart, and also test
	  for syntetized instance names.

2007-02-16 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* server/sprite_instance.cpp: Removed name check to get sprites
	  moved to their correct position after a loop  

2007-02-16 Sandro Santilli <strk@keybit.net>

	* server/dlist.{h,cpp}: don't dispatch UNLOAD event
	  unless explicitly requested by caller. 
	* server/sprite_instance.cpp: properly dispatch
	  UNLOAD event on just-removed chars.
	* testsuite/misc-ming.all/action_execution_order_test.c:
	  Added an additional test for order of onLoad event call.

2007-02-16 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp: 
	  Warn only once about unsupported stuff; Provide
	  the *unimplemented* MovieClip.moveTo method.
	* testsuite/actionscript.all/MovieClip.as: don't
	  expect failure in checking moveTo.

2007-02-16 Sandro Santilli <strk@keybit.net>


	* server/asobj/: Color.cpp, Sound.cpp:
	  Warn only once about unsupported stuff; don't terminate
	  log_<whatever> with a newline (will be added); properly
	  tag ActionScript errors (log_aserror, and protect by
	  IF_VERBOSE_ASCODING_ERRORS).
	* server/sprite_instance.{cpp,h}: Fixed (hopefully)
	  the action execution order. Implementation is far
	  from elegant, but gives the idea of how it should work,
	  and actually passed our test for it, w/out breaking
	  anything else.
	* testsuite/misc-ming.all/action_execution_order_test.c:
	  Add an additional test to verify that function definitions
	  are not specially handled as it comes to action execution
	  order. Don't expect failures anymore.
	* server/dlist.{cpp,h}: add clear_except() override taking
	  a DisplayList as argument. Add a call_unload argument
	  for both clear_except() methods; add empty() method;
	  add clear() override taking a DisplayList as argument.
	* utilities/processor.cpp: add -f <frames> switch to control
	  the number of "advance" calls on the top movie.

2007-02-15 Sandro Santilli <strk@keybit.net>

	* server/parser/movie_definition.h: documented get_frame_size().
	* server/parser/BitmapMovieDefinition.h (get_{width,height}_pixels):
	  use TWIPS_TO_PIXELS for consistency with movie_definition.
	* server/parser/BitmapMovieDefinition.cpp (getShapeDef): use 1 twip
	  per image pixel while drawing.

2007-02-15  Rob Savoye  <rob@bertha.welcomehome.org>

	* doc/C/gtkext.xml: Chapter on the Gtk extension.
	* doc/C/mysqlext.xml: Chapter on the MySQL extension.
	* doc/C/fileext.xml: Chapter on the File I/O extension.
	* doc/C/Makefile.am: Add new files to dependencies.
	
	* doc/C/extensions.xml: New file on the extension mechanism, and
	on writing extensions.
	* doc/C/gnash.xml: Add extensions chapter.
	
	* extensions/gtk2: New directory for Gtk2 API extension.
	* extensions/gtk2/hello.as: The well known Gtk "Hello" example
	program written in ActionScript.
	* extensions/gtk2/gtkext.{cpp,h}: Wrappers for the Gtk2 API to
	export it into Gnash.

2007-02-14 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* server/BitmapMovieInstance.cpp, server/parser/BitmapMovieDefinition.cpp:
	Corrected JPG scale	 

2007-02-14 Sandro Santilli <strk@keybit.net>

	* server/: movie_instance.cpp, movie_root.cpp: move
	  tu_random reset from movie_instance to movie_root
	  (random number generation should be taken care at global level);
	  Have movie_instance::advance call ::construct() rather
	  then manually executing frame tags.
	* testsuite/misc-ming.all/action_execution_order_test.c:
	  Add an additional complexity to the test, checking
	  for proper DisplayList construction to happen *before*
	  actions execution.
	* server/asobj/xmlnode.cpp: fix getter-setters for read-only
	  properties to survive attempts to set (logging the aserror).

2007-02-14  Rob Savoye  <rob@bertha.welcomehome.org>

	* testsuite/actionscript.all/XMLNode.as: Fix tests for newly work
	XLNode class.
	* server/asobj/xmlnode.{cpp,h}: Make nextSibling, previousSibling,
	firstChild, and lastChild work correctly.

2007-02-14 Sandro Santilli <strk@keybit.net>

	* server/swf/tag_loaders.{cpp,h}: implement serialnumber_loader.
	* server/impl.cpp: register SERIALNUMBER loader.
	* server/stream.{h,cpp}: add read_string_with_lenght() function
	  taking length as argument; add get_tag_length() function
	  returning length of current tag.

2007-02-14 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* backend/sound_handler_sdl.cpp, server/asobj/NetStreamFfmpeg.{h,cpp},
	  server/gnash.h: Changed the aux_streamer_ptr callback to return bool.
	* libbase/gstgnashsrc.h, server/asobj/NetStreamGst.cpp: Moved definition
	  of gnash_plugin_desc to registering file to avoid multiple definitions.
	* server/asobj/SoundGst.{cpp,h}, server/asobj/SoundFfmpeg.{cpp,h},
	  server/asobj/SoundMad.{cpp,h} Added FFMPEG, Gstreamer and libmad 
	  backends for the Sound class.
	* server/asobj/Sound.{cpp,h}: Added support for the new backends.
	* server/asobj/Makefile.am: Added SoundGst.{h,cpp}, SoundFfmpeg.{h,cpp},
	  and SoundMad.{h,cpp},
	* server/asobj/NetConnection.{cpp,h}: Made accept as_object as argument 
	  instead of NetStream, to allow Sound to use NetConnection.

2007-02-14 Sandro Santilli <strk@keybit.net>

	* server/shape.h: add more public functions for
	  manipulation.
	* server/parser/morph2_character_def.cpp: try to
	  avoid direct access to shape private wonnabes;
	  simplified code, hopefully more readable now.
	* server/parser/shape_character_def.cpp: try
	  to avoid direct access to shape pritave wonnabes.

2007-02-14 Sandro Santilli <strk@keybit.net>

	* server/shape.{cpp,h}: added primitives for
	  drawing API: drawLineTo, drawCurveTo.
	  Method names track Ming interface.
	* server/parser/BitmapMovieDefinition.cpp: 
	  Use the path drawing api, draw a thicker outline
	  (outline works, fill not).

2007-02-14 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp (goto_frame):
	  Don't trash actions following gotoFrame() calls
	  (fixes multiple_doactions_and_goto_frame_test.c).
	  Added comments about problems with consecutive_goto_frame_test.
	* testsuite/misc-ming.all/multi_doactions_and_goto_frame_test.c:
	  Don't expect the failure anymore :)

2007-02-14 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/ASSound.{cpp,h}: Renamed to Sound.{h,cpp}.
	* server/asobj/Global.cpp, server/asobj/Makefile.am, win32/VC8/gnash.vcproj, 
	  win32/VC8/npgnash.vcproj: Updated to use Sound.{h,cpp} instead of
	  ASSound.{h,cpp}.

2007-02-14 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/Makefile.am: run the multi_doactions
	  gotoframe test.
	* testsuite/misc-ming.all/multi_doactions_and_goto_frame_test.c:
	  expect the failure.
	* server/BitmapMovieInstance.{cpp,h}: use sprite_instance::display,
	  don't override it. instead, place the bitmap shape in the
	  displaylist.
	* server/parser/BitmapMovieDefinition.{cpp,h}: change
	  constructor to take an image rather then a bitmap_character_def
	  (the latter has a poor interface).
	* server/impl.cpp: updated construction of BitmapMovieDefinition.
	* server/parser/shape_character_def.h: new add_line_style()
	  method, for programmatic definition of shapes.

2007-02-14 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/multi_doactions_and_goto_frame_test.c
	another testcase for goto_frame.
	
2007-02-13  Rob Savoye  <rob@bertha.welcomehome.org>

	* configure.ac: Disable dmalloc check for now. Configure
	extension/fileio directory.
	* extensions/Makefile.am: Build in the fileio directory.
	
	* server/asobj/xmlnode.cpp: Implement toString(). Make appendChild
	actually work.
	* server/asobj/xml.cpp: Re-implement toString(). Make
	createElement() and createTextNode() actually work.
	* server/asobj/xmlnode.h, xml.h: Include stringstream, and add to
	stringify() prototype.
	* server/asobj/xml.cpp: 
	* server/vm/ActionExec.cpp: Renable the stack dump messages for
	-va.
	* testsuite/actionscript.all/XML.as: Replace all the create* and
	appendChild() tests now that this functionality actually works.
	* server/Makefile.am: Add boost and pthread libs for cross compiling.
	* server/asobj/Makefile.am: Add glib and gstreamer cflags, needed
	when cross compiling with Gstreamer support.
	

2007-02-13 Sandro Santilli <strk@keybit.net>

	* server/parser/shape_character_def.h: new add_path() and
	  add_fill_style() methods, to allow for programmatic
	  definition of shape chars (will likely need more of these
	  for implementing the Drawing API).
	* server/sprite_instance.h: add a protected place_character
	  method, to fiddle with displaylist w/out character *ids*.
	* server/shape.h (class path): add setLeftFill, setRightFill
	  and setStartPoint methods; document some more.
	* server/sprite_instance.{cpp,h}:
	  Drop unused registeredClass arg in constructor.
	* server/parser/sprite_definition.cpp:
	  update call to sprite_instance constructor.

2007-02-13 Sandro Santilli <strk@keybit.net>

	* server/: Makefile.am, fill_style.{cpp,h},
	  styles.{cpp,h}: moved fill_style class in its
	  own file. Removeod unused code, provided 
	  a fill_style constructor for creating clipped
	  bitmap fills.
	* server/render.h: had doxygen comments point
	  to the correct place (render_handler).

2007-02-13 Sandro Santilli <strk@keybit.net>

	* server/parser/: Makefile.am, BitmapMovieDefinition.h:
	  Class used to return a movie_definition from load of a JPEG.
	* server/: Makefile.am, BitmapMovieInstance.{cpp,h}: 
	  Instance of a BitmapMovieDefinition (a movie_instance).
	* server/impl.cpp: move the unimplemented stuff over
	  to the new BitmapMovie classes.
	* testsuite/misc-ming.all/loadMovieTestRunner.cpp:
	  Don't expect a failure in loading the external JPEG
	  (it loads, just doesn't display).

2007-02-13 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-mtasc.all/.cvsignore: new file.
	* testsuite/misc-ming.all/consecutive_goto_frame_test.c:
	  expect the current failures, just to allow 'make check'
	  to continue working (known bugs need be 'expected', if
	  they unexpectedly pass 'make check' will exit with a
	  FAILURE code so we can joy and remove the expectance).
	* testsuite/misc-mtasc.all/: Makefile.am, hello.as:
	  Generalized Makefile, stuff Dejagnu.swf in first frame
	  and dejagnu_so_fini.as in last frame using 'makeswf'.
	  Ready to start with mtasc tests.

2007-02-13 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* gui/gui.cpp: Make full redraw on ENABLE_REGION_UPDATES_DEBUGGING 
	  configurable
	* gui/fb.cpp, gui/fbsup.h: Initial support for mouse
	* server/character.h: Avoid redrawing when matrix did not change	
	* backend/render_handler_agg.cpp: Correctly handling NULL clipping 
	  rectangle  	
	* server/character.cpp, server/character.h, 
    server/sprite_instance.cpp: distinguish between own and child's 
    invalidation state to avoid useless redrawing (should be a big
    performance gain in certain cases)
 
2007-02-13  Rob Savoye  <rob@bertha.welcomehome.org>

	* extensions/fileio/Makefile.am, fileio.cpp, fileio.h, test.as:
	New files for direct File I/O extension for Gnash.

2007-02-12 Sandro Santilli <strk@keybit.net>

	* macros/mtasc.m4: provide some detection for mtasc
	  (CLASSPATH detection needs more work).
	* configure.ac: detect mtasc availability.
	* Makefile.am: dump MTASC info on 'make dumpconfig'.
	* testsuite/Makefile.am: descend in misc-mtasc.all
	* testsuite/misc-mtasc.all/Makefile.am: initial Makefile
	  for mtasc.
	* testsuite/misc-mtasc.all/hello.as: simple test 
	  (build with 'make hello.swf').

2007-02-12 Sandro Santilli <strk@keybit.net>

	* server/button_character_instance.cpp (on_button_event):
	  Survive MOUSE_DOWN and MOUSE_UP events.
	* server/movie_root.cpp: (generate_mouse_button_events):
	  Dispatch events MOUSE_DOWN and MOUSE_UP togheter with PRESS 
	  and RELEASE (see bug #19040).
	* server/sprite_instance.cpp (can_hanle_mouse_envent):
	  Consider MOUSE_DOWN and MOUSE_UP events (see bug #19040).

2007-02-12 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/ASSound.{cpp,h}, server/asobj/Global.cpp: Updated the
	  AS Sound class to the new init method.

2007-02-12 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.{cpp,h}: reverted
	  goto_frame patch introducing regression failures.
	  See bug #19020.

2007-02-12 Sandro Santilli <strk@keybit.net>

	* server/tesselate.cpp: std::fabsf => std::abs.
	* server/execute_tag.h: doxygen documentation,
	  add new execute_action() function.
	* server/sprite_instance.{cpp,h}: changed signature
	  of execute_frame_tags() to allow executions of
	  action tags only.

2007-02-12 Markus Gothe <nietzsche@lysator.liu.se>

	* server/debugger.h: &val, &val -> &var, &val
	* server/matrix.cpp: Using namespace std; 

2007-02-12 Sandro Santilli <strk@keybit.net>

	* server/character.h: documented ::advance() method.
	* testsuite/misc-ming.all/action_execution_order_test.c: made
	  more verbose, reduced frame rate to better see what goes on,
	  don't use C++ comments.
	* testsuite/misc-ming.all/Makefile.am: add consecutive_goto_frame_test
	  to the 'make check' loop.
	* libbase/utility.h: std::logf => std::log.

2007-02-12 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/consecutive_goto_frame_test.c
	add a new testcase for testing consecutive ActionGotoAndStop.

	
2007-02-12 Markus Gothe <nietzsche@lysator.liu.se>

	* libbase/utility.h: Added note on log2	

2007-02-11 Deanna Phillips <deanna>

	* server/asobj/Number.cpp: Removed use of fpclassify.

2007-02-11 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp: stubbed unloadMovie ActionScript
	  function.
	* server/asobj/MovieClipLoader.cpp: properly register
	  the MovieClipLoader global class (use builtin_function,
	  not a "dumb" c_function.
	* testsuite/actionscript.all/: Makefile.am, MovieClipLoader.as:
	  simple test for MovieClipLoader (just inheritance and functions
	  availability).

2007-02-11 Markus Gothe <nietzsche@lysator.liu.se>

	* server/asobj/Number.cpp: Reverted stupid mistake.

2007-02-11 Sandro Santilli <strk@keybit.net>

	* macros/pthreads.m4: use -pthread for linux, as suggested by boost
	error.

2007-02-11 Martin Guy <martinwguy@yahoo.it>

	* server/asobj/Date.cpp: Disable use of tzset/timezone that does not
	  compile on BSD, contrary to the GNU glibc manual.

2007-02-11 Sandro Santilli <strk@keybit.net>

	* server/: impl.cpp, swf.h: renamed IMPORT2 as IMPORTASSETS2, tracking
	  Ming naming convention; add ENABLEDEBUGGER2 definition (and null
	  loader).
	* server/asobj/Number.cpp: don't redefine fpclassify: _fpclassify
	  won't build on an ubuntu dapper; fpclassify is defined in math.h,
	  already included.

2007-02-10  Rob Savoye  <rob@bertha.welcomehome.org>

	* libbase/Makefile.am: Add glib and gstreamer cflags, needed when
	cross compiling with Gstreamer support.
	* macros/gnashpkgtool.m4: Search_libs after a directory search. 
	* macros/pkg.m4: Use pathlist to find pkg-config.
	* server/Makefile.am:  Add glib and gstreamer cflags, needed when
	cross compiling with Gstreamer support.
	* server/debugger.cpp,: Tweak usage 
	* server/parser/Makefile.am: Add libxml, glib, and gstreamer
	cflags, needed when cross compiling with Gstreamer support.
	* server/vm/Makefile.am: Add glib and gstreamer cflags, needed
	when cross compiling with Gstreamer support.
	* utilities/Makefile.am: With GST for sound, include glib and
	gstreamer libraries.

2007-02-10 Markus Gothe <nietzsche@lysator.liu.se>

	* server/asobj/Math.cpp: using namespace std;
	* server/asobj/Number.cpp: using namespace std; Fixes for C99->C++.
	* libbase/postscript.cpp: using namespace std;
	* libbase/tu_file.cpp: namespacing.

2007-02-10 Udo Giacomozzi <udo.gnu@nova-sys.net>

	* gui/fb.cpp: fixed some compilation problems when DOUBLE_BUFFER is 
	disabled; fixed _validbounds so that the movie is visible again; 
	added 2 pixel border to invalidated bounds to fix anti-aliasing
	problems; set scaling to view movie full-screen; added/fixed 
	support for 24 and 32 bit modes
	* render_handler_agg.cpp: added pixel format BGRA32          

2007-02-10 Sandro Santilli <strk@keybit.net>

	* server/sprite_instance.cpp: remove characters
	  not in current DisplayList from _frame0_chars when
	  looping back. See patch #5620.
	* testsuite/misc-ming.all/Makefile.am:
	  fixed typo in loadMovieTestRunner dependency.

2007-02-10 Zou Lunkai <zoulunkai@gmail.com>

	* testsuite/misc-ming.all/place_and_remove_object_insane_test.c
	add a new check that fails current Gnash and some comments. Only 
	xchecks	are supposed to be insane.

2007-02-09  Rob Savoye  <rob@bertha.welcomehome.org>

	* doc/C/debugger.xml: New file about the Flash debugger.
	* doc/C/sources.xml: Add --disable-debugger option.
	* doc/C/gnash.xml: Add info about the -g option. Add an entity for
	the new debugger chapter.
	* doc/C/gnash-man.xml: Add info about the -g option.

	* server/debugger.{cpp, h}: Implement breakpoint functions. Add a
	call stack.
	* server/vm/ASHandlers.cpp: Break and watch point here.
	* server/vm/ActionExec.cpp: Don't watchpoint here anymore.

	* macros/ffmpeg.m4: Check for the version of ffmpeg and print a
	warning if it's too old to use.
	* configure.ac: Print warning if you have ffmpeg, but it's a
	version older than 5.29.0. #18663.

2007-02-09 Bastiaan Jacques <bastiaan@bjacques.org>

	* libbase/tu_types.h: Add the BYTE_ORDER name used on Mac OSX.

2007-02-09 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/Makefile.am: Added embedVideoDecoderGst.{cpp,h}.
	* libbase/embedVideoDecoderGst.{cpp,h}: Added. Use Gstreamer to decode 
	  embedded video.
	* libbase/embedVideoDecoder.h, libbase/embedVideoDecoderFfmpeg.cpp:
	  Added support for more codecs.
	* server/parser/Makefile.am, server/parser/video_stream_def.cpp,
	  server/parser/video_stream_def.h: Added support for using Gstreamer
	  to decode embedded video.

2007-02-09 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/dejagnu_so_init.as: made use
	  of frame loop a compile-time define for having another way
	  to test setInterval.
	* testsuite/misc-ming.all/: Makefile.am, intervalTest.as,
	  intervalTestRunner.cpp: add test *runner* for intervalTest.swf

2007-02-09 Sandro Santilli <strk@keybit.net>

	* testsuite/MovieTester.cpp: advance the movie_root, not
	  the topmost sprite ! This properly run interval timers.
	* server/movie_root.{cpp,h}: Store Timer objects
	  by value, not by pointer (make memory management easier);
	  I might change this in the future, but for now it works
	  fine. Possible future changes include: reserving a number
	  of slots for timers (possibly setting a limit), reusing
	  slots of expired timers (needs a testcase to see if that's
	  allowed).
	* server/timers.{cpp,h}: Big cleanup; got rid of timer_as_object;
	  use integer values for times, reduced function calls (store timeouts
	  in microseconds directly); documented.
	* server/asobj/xmlsocket.cpp: fix use of Timer class.
	* testsuite/misc-ming.all/: Makefile.am, intervalTest.as: new
	  test for setInterval() and clearInterval(). Lacks a test *runner*
	  but the manually running it clearly shows it works with this commit
	  (and not before). Note that self-contained tests are already
	  present, but a MovieTester based runner is required for proper
	  testing.

2007-02-09 Martin Guy <martinwguy@yahoo.it>

	* server/asobj/Math.cpp: Methods for constants have uppercase names

2007-02-09 Sandro Santilli <strk@keybit.net>

	* server/parser/: movie_def_impl.h, movie_definition.h:
	  Don't include timers.h.
	* server/asobj/Global.cpp: add setInterval and clearInterval
	  global functions.
	* testsuite/actionscript.all/Global.as: test existance of
	  setInterval and clearInterval function.

2007-02-08  Rob Savoye  <rob@bertha.welcomehome.org>

	* server/debugger.cpp: Dump the name of as_objects on the stack
	too. Some objects are created internally, so don't have a symbol
	table entry.
	* server/as_object.h: Return the raw properties handle so the
	debugger can use it. Add set_std_string method to let one add
	standard STL strings. 
	* server/debugger.cpp, debugger.h: Add support for setting
	variables or registers from the debugger console. Fix the symbol
	table to actually work, so now function names are displayed when
	doing a stack frame dump instead of just the address. Add minimal
	support for dumping information about the movie.
	* server/vm/ASHandlers.cpp: Grab the correct address when adding
	symbols to the debugger.

2007-02-08 Sandro Santilli <strk@keybit.net>

	* server/timers.{h,cpp}: add execution operator.
	* server/movie_root.{h,cpp}: removed do_something method,
	  replaced by Timer's execution operator. Changed add_interval_timer
	  to take a Timer& rather then a void*. Fixed clear_interval_timer
	  to avoid modifying the Timer list consequently making interval
	  ids invalid (all commented, check out for details).
	* server/sprite_instance.{h,cpp}: removed {add,clear}_interval_timer
	  and do_somthing methods. Callers should use the ones in movie_root.
	* server/asobj/xmlsocket.cpp: don't register setInterval and
	  clearInterval functions as they should be globals !

2007-02-08 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/video_stream_instance.cpp, server/parser/video_stream_def.cpp:
	  Make sure current video really is from a VideoFrame tag, before trying to
	  decode.

2007-02-08 Sandro Santilli <strk@keybit.net>

	* testsuite/misc-ming.all/: Makefile.am, loadMovieTestRunner.cpp:
	  Test runner for loadMovie.swf.

2007-02-08 Bastiaan Jacques <bastiaan@bjacques.org>

	* server/debugger.cpp: Simple cleanup: remove unneeded casts.

2007-02-08 Sandro Santilli <strk@keybit.net>

	* server/asobj/MovieClipLoader.cpp (loadClip): use the new
	  sprite_instance::loadMovie() method.
	* server/movie_root.cpp: keep root sprite alive during actions
	  execution.
	* server/sprite_instance.{cpp,h}: complete implementation of
	  MovieClip.loadMovie(). 

2007-02-08 Martin Guy <martinwguy@yahoo.it>

	* server/asobj/Number.cpp: Only do string-to-number conversion when
	  text value is required, not on every math operation; moved text
	  conversion code out of class definition into its own function.
	* server/asobj/Number.cpp: Added text conversion of NaN and Infinities.

2007-02-08 Sandro Santilli <strk@keybit.net>

	* server/event_id.h: add id() accessor, properly use the id_code enum.
	* server/sprite_instance.cpp (can_handle_mouse_event): handle
	  case insensitiveness for SWF<7 fixing bug exposed by
	  loadMovieTest.swf; (sprite_load_movie): add
	  a few more checks, needs more work.
	* testsuite/misc-ming.all/: Makefile.am, loadMovieTest.c:
	  simple testcase for MovieClip.loadMovie(); exposes a bug
	  in event handling too. No runner for it (yet).

2007-02-08 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/embedVideoDecoder.h, libbase/embedVideoDecoderFfmpeg.cpp:
	  Added more video codecs.
	* server/asobj/NetStreamFfmpeg.cpp: Check if url is readable.
	* server/asobj/NetStreamGst.cpp: Check if a NetConnection object exists.
	* server/parser/video_stream_def.cpp: Fixed a warning.
	* testsuite/actionscript.all/rtmp.as: Made it actually test something.

2007-02-08 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* libbase/Makefile.am: Added embedVideoDecoder.h, 
	  embedVideoDecoderFfmpeg.{h,cpp}
	* libbase/embedVideoDecoderFfmpeg.{h,cpp}: Added. Decoder for embedded video
	  using ffmpeg.
	* server/impl.cpp: Added support for parsing swf embedded in a player (.exe)
	* server/asobj/NetStreamFfmpeg.{cpp,h}: Fixed some warnings.
	* server/parser/movie_def_impl.h: Removed unused soundstream list.
	* server/video_stream_instance.{cpp,h}, 
	  server/parser/video_stream_def.{cpp,h}, server/swf/tag_loaders.cpp:
	  Added support for embedded video.

2007-02-08 Sandro Santilli <strk@keybit.net>

	* server/character.{h,cpp} (get_relative_target_common):
	  support "_parent".
	* testsuite/actionscript.all/MovieClip.as: add test for _parent
	  member of actionscript created movieclips.

2007-02-07 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/Global.as: expect failures with
	  'unescape'... anyone confirming the results with other players
	  is welcome.
	* testsuite/MovieTester.{cpp,h}: add pressKey() and releaseKey()
	  methods.
	* testsuite/misc-ming.all/: KeyTest-Runner.cpp, KeyTest.as,
	  Makefile.am: test for Key events.
	* testsuite/actionscript.all/Object.as: add test for overriding
	  addProperty() member of an object.

2007-02-07 Martin Guy <martinwguy@yahoo.it>

	* server/asobj/Data.cpp: Completed reverse engineering of get/set
	  methods
	* configure.ac: Added check for ftime()
	* testsuite/actionscript.all/Date.as: Add tests for get/set methods

2007-02-07 Sandro Santilli <strk@keybit.net>

	* server/debugger.h: const-correctness fixes.
	* server/parser/action_buffer.h: buffer accessor return by const
	  pointer.
	* server/asobj/Key.cpp (notify_key_event): fix update
	  of the _global.Key object, properly handle case of function names
	  (TODO: produce an automated testcase for this!).
	* server/sprite_instance.cpp (movieclip_ctor): don't attach MovieClip
	  properties, as those are only good for real sprites.
	* server/swf/tag_loaders.cpp: use log_swferror where appropriate,
	  (swf_event::read): tolerate malformed header.

2007-02-07 Sandro Santilli <strk@keybit.net>

	* server/types.cpp (rgba::read): made more readable.
	* server/vm/fn_call.h: add dump_args() method.
	* server/asobj/Object.cpp: use log_aserror() where appropriate,
	  dump function args when invalid. Don't giveup when number of 
	  args is greater then required.

2007-02-07 Sandro Santilli <strk@keybit.net>

	* testsuite/actionscript.all/Object.as: add tests for invalid calls
	  to addProperty() [ found in hello.swf from Laszlo ]
	* server/asobj/Object.{cpp,h}: export getObjectInterface()
	* server/asobj/as_object.{cpp,h} (get_prototype): return
	  Object class interface when hit top of inheritance chain;
	  make sure to never access m_prototype directly but always
	  use get_prototype() instead. This ensures that *every* object
	  ends up being an Object instance.
	* testsuite/actionscript.all/Function.as: a few more tests to
	  ensure that functions are instance of Object.
	* testsuite/actionscript.all/: MovieClip.as, Inheritance.as:
	  Don't expect failures while checking for objects being
	  instance of Object class.

2007-02-07 Sandro Santilli <strk@keybit.net>

	* server/swf/tag_loaders.cpp (define_shape_loader): neater parse
	  print.
	* server/types.{cpp,h}: add output operator and toString
	  method for rgba class.
	* server/styles.cpp (fill_stle::read): neater color print.
	* server/parser/shape_character_def.cpp (read):
	  neater parse print.

2007-02-06  Rob Savoye  <rob@bertha.welcomehome.org>

	* server/as_value.h: Add is_as_function() .
	* server/debugger.cpp: Try to lookup a symbol name for each
	address when dumping the stack. Add support for a symbol table for
	all functions and "new" objects and an "i s" command to dump the
	symbol table. "i f" now dumps the stack frame, it was "i s"
	before. 
	* server/parser/action_buffer.h: Add accessors for the code
	buffer.
	* server/vm/ASHandlers.cpp: Don't need std:: since we're using the
	std namespace. Add a symbol for function definitions.
	* server/vm/ActionExec.cpp: Stash the pc pointer for later instead
	of passing it in on the command line.
	* utilities/parser.cpp, processor.cpp: Add support for the debugger.

2007-02-06 Sandro Santilli <strk@keybit.net>

	* server/debugger.{h,cpp}: (disassemble): first argument
	  can safely be passed as a 'const' pointer.
	* server/parser/action_buffer.h: added get_buffer() to
	  return an unsugned char.
	* server/vm/ActionExec.cpp (operator()): use
	  action_buffer::get_buffer() to fetch an appropriate argument
	  for Debugger::disassemble.

2007-02-06 Martin Guy <martinwguy@yahoo.it>

	* server/asobj/Data.cpp: Fixed bug in setUTCHours(),
	  make utc/localtime specification compulsory in inner workings.
	* server/asobj/Number.cpp: Convert numbers to strings the same way as a
	  certain commercial Flash Player does.
	* configure.ac: Add check for memmove, used in Number.cpp

2007-02-06  Rob Savoye  <rob@bertha.welcomehome.org>

	* configure.ac: Add --disable-debugger option.
	* server/debugger.h, debugger.cpp: New files for Flash debugger
	support.
	* gui/gnash.cpp: Add -g option to start the debugger console.
	* server/as_environment.h: Add methods to set registers.
	* server/parser/action_buffer.cpp: Add to existing string value,
	don't replace it.
	* server/vm/ActionExec.cpp: Add support for the Flash
	debugger. Simplify the methods where case conversion is done.

2007-02-06 Sandro Santilli <strk@keybit.net>

	* server/as_environment.cpp (get_variable_raw):
	  Don't provide "_global" when SWF version is < 6.
	* testsuite/actionscript.all/getvariable.as: don't expect
	  failures in SWF5 mode (_global related)
	* testsuite/actionscript.all/Global.as: use check_equals
	  when possible, fix for missing SWF5 _global, remove
	  escape() tests with SWF > 5 as I can't confirm correct
	  result.
	* testsuite/actionscript.all/delete.as: fix for SWF5 run
	  (_global related).

2007-02-05 Tomas Groth Christensen <tomasgroth@yahoo.dk>

	* server/asobj/NetConnection.cpp: Make sure we don't setup a connection
	  that already exists.
	* server/asobj/NetStreamFfmpeg.{cpp,h}: Fixed a potential hanging thread.
	* server/asobj/NetStreamGst.{cpp,h}: Switched from pthreads to boost.
	  Fixed a potential hanging thread.

2007-02-05 Sandro Santilli <strk@keybit.net>

	* server/PropertyList.cpp: delete overridden properties in import();
	  properly clear current container on assignment operator (also fixed
	  it's signature). Properly delete Property in delProperty().
	* server/PropertyList.h: Properly document Property ownership.

2007-02-05 Zou Lunkai <zoulunkai@gmail.com>

	* server/movie_root.cpp, server/asobj/xml.cpp,
	  server/asobj/xmlnode.cpp.
	  typos, get rid of unnecessary warnings with vc8 compiler 
	  
2007-02-05 Markus Gothe <nietzsche@lysator.liu.se>

	* macros/pthreads.m4: Fixed a quirky LIBS/CFLAGS-bug.
	* libbase/log.cpp: Removed BOOST_HAS_THREADS.
	* cygnal/cygnal.cpp: Removed implicit include.
	* cygnal/statistics.h: Removed unsed include.

2007-02-03 Sandro Santilli <strk@keybit.net>

	* server/GetterSetter.{cpp,h}: fixed assignment operator (a bad typo!).
	* server/dlist.cpp: call character::construct() everytime an object
	  is placed on stage, making the code much more readable and clean
	  (IMHO).
	* server/sprite_instance.{h,cpp}: implement 'construct' method
	  to take care of properly handling user-defined registered
	  classes for sprites and to execute tags in frame0; attach
	  properties to *instances* rather then to the MovieClip
	  exported interface.
	* server/character.h: add a 'construct' method.
	* testsuite/misc-ming.all/: registerClassTest.c,
	  registerClassTestRunner.cpp: add new tests, a fix
	  for gnash will follow shortly.
	* server/parser/sprite_definition.h: add getRegisteredClass()
	  method.

2007-02-03 Martin Guy <martinwguy@yahoo.it>

	* server/asobj/Data.cpp: Fixed fmod issues.

2007-02-03 Martin Guy <martinwguy@yahoo.it>

	* server/asobj/Data.cpp: Pretty much complete rewrite of nonworking
	  module forced by change of internal representation from many little
	  date fields to milliseconds since epoch. Not fully working yet.
	* configure.ac: include tests for localtime_r and tzset.

2007-02-02 Markus Gothe <nietzsche@lysator.liu.se>

	* server/asobj/Data.cpp: Fixed fmod issue.

2007-02-02 Martin Guy <martinwguy@yahoo.it>

	* testsuite/actionscript.all/Global.as: add checks for malformed
	  encoded URLs

